GNU Emacs NEWS -- history of user-visible changes.  2003-05-21
Copyright (C) 1999, 2000, 2001, 2002, 2003, 2004, 2005
          Free Software Foundation, Inc.
See the end for copying conditions.

Please send Emacs bug reports to bug-gnu-emacs@gnu.org.
For older news, see the file ONEWS
You can narrow news to the specific version by calling
`view-emacs-news' with a prefix argument or by typing C-u C-h C-n.

Temporary note:
 +++ indicates that the appropriate manual has already been updated.
 --- means no change in the manuals is called for.
When you add a new item, please add it without either +++ or ---
so we will look at it and add it to the manual.


* Installation Changes in Emacs 21.4

** Emacs includes now support for loading image libraries on demand.
(Currently this feature is only used on MS Windows.)  You can configure
the supported image types and their associated dynamic libraries by
setting the variable `image-library-alist'.

---
** New translations of the Emacs Tutorial are available in the following
   languages: Brasilian, Bulgarian, Chinese (both with simplified and
   traditional characters), French, and Italian.  Type `C-u C-h t' to
   choose one of them in case your language setup doesn't automatically
   select the right one.

** You can build Emacs with Gtk+ widgets by specifying `--with-x-toolkit=gtk'
when you run configure.  This requires Gtk+ 2.0 or newer.  This port
provides a way to display multilingual text in menus (with some caveats).

---
** Emacs can now be built without sound support.

** The `emacsserver' program has been removed, replaced with elisp code.

---
** Emacs now supports new configure options `--program-prefix',
`--program-suffix' and `--program-transform-name' that affect the names of
installed programs.

---
** By default, Emacs now uses a setgid helper program to update game
scores.  The directory ${localstatedir}/games/emacs is the normal
place for game scores to be stored.  This may be controlled by the
configure option `--with-game-dir'.  The specific user that Emacs uses
to own the game scores is controlled by `--with-game-user'.  If access
to a game user is not available, then scores will be stored separately
in each user's home directory.

---
** Leim is now part of the Emacs distribution.
You no longer need to download a separate tarball in order to build
Emacs with Leim.

+++
** The Emacs Lisp Reference Manual is now part of the distribution.

The ELisp reference manual in Info format is built as part of the
Emacs build procedure and installed together with the Emacs User
Manual.  A menu item was added to the menu bar that makes it easy
accessible (Help->More Manuals->Emacs Lisp Reference).

---
** The Introduction to Programming in Emacs Lisp manual is now part of
the distribution.

This manual is now part of the standard distribution and is installed,
together with the Emacs User Manual, into the Info directory.  A menu
item was added to the menu bar that makes it easy accessible
(Help->More Manuals->Introduction to Emacs Lisp).

** Support for Cygwin was added.

---
** Support for FreeBSD/Alpha has been added.

---
** Support for GNU/Linux systems on S390 machines was added.

---
** Support for MacOS X was added.
See the files mac/README and mac/INSTALL for build instructions.

---
** Support for GNU/Linux systems on X86-64 machines was added.

---
** A French translation of the `Emacs Survival Guide' is available.

---
** Building with -DENABLE_CHECKING does not automatically build with union
types any more.  Add -DUSE_LISP_UNION_TYPE if you want union types.


* Changes in Emacs 21.4

** display-battery has been replaced by display-battery-mode.
** calculator.el now has radix grouping mode, which is available when
`calculator-output-radix' is non-nil.  In this mode a separator
character is used every few digits, making it easier to see byte
boundries etc.  For more info, see the documentation of the variable
`calculator-radix-grouping-mode'.

** You can now follow links by clicking Mouse-1 on the link.

Traditionally, Emacs uses a Mouse-1 click to set point and a Mouse-2
click to follow a link, whereas most other applications use a Mouse-1
click for both purposes, depending on whether you click outside or
inside a link.  With release 21.4, the behaviour of a Mouse-1 click
has been changed to match this context-sentitive dual behaviour.

Depending on the current mode, a Mouse-2 click in Emacs may do much
more than just follow a link, so the new Mouse-1 behaviour is only
activated for modes which explicitly mark a clickable text as a "link"
(see the new function `mouse-on-link-p' for details).  The lisp
packages that are included in release 21.4 have been adapted to do
this, but external packages may not yet support this.  However, there
is no risk in using such packages, as the worst thing that could
happen is that you get the original Mouse-1 behaviour when you click
on a link, which typically means that you set point where you click.

If you want to get the original Mouse-1 action also inside a link, you
just need to press the Mouse-1 button a little longer than a normal
click (i.e. press and hold the Mouse-1 button for half a second before
you release it).

Dragging the Mouse-1 inside a link still performs the original
drag-mouse-1 action, typically copy the text.

You can customize the new Mouse-1 behaviour via the new user option
`mouse-1-click-follows-link'.

+++
** require-final-newline now has two new possible values:

`visit' means add a newline (as an undoable change) if it's needed
when visiting the file.

`visit-save' means add a newline (as an undoable change) if it's
needed when visiting the file, and also add a newline if it's needed
when saving the file.

+++
** The new option mode-require-final-newline controls how certain
major modes enable require-final-newline.  Any major mode that's
designed for a kind of file that should normally end in a newline
sets require-final-newline based on mode-require-final-newline.
So you can customize mode-require-final-newline to control what these
modes do.

+++
** When the undo information of the current command gets really large
(beyond the value of `undo-outer-limit'), Emacs asks you whether to
discard it or keep it.

** line-move-ignore-invisible now defaults to t.

** In Outline mode, hide-body no longer hides lines at the top
of the file that precede the first header line.

+++
** In Enriched mode, `set-left-margin' and `set-right-margin' are now
by default bound to `C-c [' and `C-c ]' instead of the former `C-c C-l'
and `C-c C-r'.

+++
** In processing a local variables list, Emacs strips the prefix and
suffix are from every line before processing all the lines.

+++
** `apply-macro-to-region-lines' now operates on all lines that begin
in the region, rather than on all complete lines in the region.

** global-whitespace-mode is a new alias for whitespace-global-mode.

+++
** There are now two new regular expression operators, \_< and \_>,
for matching the beginning and end of a symbol.  A symbol is a
non-empty sequence of either word or symbol constituent characters, as
specified by the syntax table.

** Passing resources on the command line now works on MS Windows.
You can use --xrm to pass resource settings to Emacs, overriding any
existing values.  For example:

  emacs --xrm "Emacs.Background:red" --xrm "Emacs.Geometry:100x20"

will start up Emacs on an initial frame of 100x20 with red background,
irrespective of geometry or background setting on the Windows registry.

** The terminal emulation code in term.el has been improved, it can
run most curses applications now.

** New features in evaluation commands

+++
*** The function `eval-defun' (C-M-x) called on defface reinitializes
the face to the value specified in the defface expression.

*** Typing C-x C-e twice prints the value of the integer result
in additional formats (octal, hexadecimal, character) specified
by the new function `eval-expression-print-format'.  The same
function also defines the result format for `eval-expression' (M-:),
`eval-print-last-sexp' (C-j) and some edebug evaluation functions.

** New input method chinese-sisheng for inputting Chinese Pinyin
characters.

** New command quail-show-key shows what key (or key sequence) to type
in the current input method to input a character at point.

** Convenient commands to switch buffers in a cyclic order are C-x <left>
(prev-buffer) and C-x <right> (next-buffer).

** Commands winner-redo and winner-undo, from winner.el, are now bound to
C-c <left> and C-c <right>, respectively.  This is an incompatible change.

** Help commands `describe-function' and `describe-key' now show function
arguments in lowercase italics on displays that support it.  To change the
default, customize face `help-argument-name' or redefine the function
`help-default-arg-highlight'.

---
** The comint prompt can now be made read-only, using the new user
option `comint-prompt-read-only'.  This is not enabled by default,
except in IELM buffers.  The read-only status of IELM prompts can be
controlled with the new user option `ielm-prompt-read-only', which
overrides `comint-prompt-read-only'.

The new commands `comint-kill-whole-line' and `comint-kill-region'
support editing comint buffers with read-only prompts.

`comint-kill-whole-line' is like `kill-whole-line', but ignores both
read-only and field properties.  Hence, it always kill entire
lines, including any prompts.

`comint-kill-region' is like `kill-region', except that it ignores
read-only properties, if it is safe to do so.  This means that if any
part of a prompt is deleted, then the entire prompt must be deleted
and that all prompts must stay at the beginning of a line.  If this is
not the case, then `comint-kill-region' behaves just like
`kill-region' if read-only are involved: it copies the text to the
kill-ring, but does not delete it.

** You can now use next-error (C-x `) and previous-error to advance to
the next/previous matching line found by M-x occur.

** Telnet now prompts you for a port number with C-u M-x telnet.

+++
** New command line option -Q.

This is like using -q --no-site-file, but in addition it also disables
the menu-bar, the tool-bar, the scroll-bars, tool tips, the blinking
cursor, and the fancy startup screen.

** C-h v and C-h f commands now include a hyperlink to the C source for
variables and functions defined in C (if the C source is available).

** When used interactively, `format-write-file' now asks for confirmation
before overwriting an existing file, unless a prefix argument is
supplied.  This behavior is analogous to `write-file'.

** You can now use Auto Revert mode to `tail' a file.
If point is at the end of a file buffer before reverting, Auto Revert
mode keeps it at the end after reverting.  Similarly if point is
displayed at the end of a file buffer in any window, it stays at
the end of the buffer in that window.  This allows to tail a file:
just put point at the end of the buffer and it stays there.  This
rule applies to file buffers.  For non-file buffers, the behavior may
be mode dependent.

If you are sure that the file will only change by growing at the end,
then you can tail the file more efficiently by using the new minor
mode Auto Revert Tail mode.  The function `auto-revert-tail-mode'
toggles this mode.

** Auto Revert mode is now more careful to avoid excessive reverts and
other potential problems when deciding which non-file buffers to
revert.  This matters especially if Global Auto Revert mode is enabled
and `global-auto-revert-non-file-buffers' is non-nil.  Auto Revert
mode only reverts a non-file buffer if the buffer has a non-nil
`revert-buffer-function' and a non-nil `buffer-stale-function', which
decides whether the buffer should be reverted.  Currently, this means
that auto reverting works for Dired buffers (although this may not
work properly on all operating systems) and for the Buffer Menu.

** If the new user option `auto-revert-check-vc-info' is non-nil, Auto
Revert mode reliably updates version control info (such as the version
control number in the mode line), in all version controlled buffers in
which it is active.  If the option is nil, the default, then this info
only gets updated whenever the buffer gets reverted.

** New command `Buffer-menu-toggle-files-only' toggles display of file
buffers only in the Buffer Menu.  It is bound to `T' in Buffer Menu
mode.

** M-x compile has become more robust and reliable

Quite a few more kinds of messages are recognized.  Messages that are
recognized as warnings or informational come in orange or green, instead of
red.  Informational messages are by default skipped with `next-error'
(controlled by `compilation-skip-threshold').

Location data is collected on the fly as the *compilation* buffer changes.
This means you could modify messages to make them point to different files.
This also means you can not go to locations of messages you may have deleted.

The variable `compilation-error-regexp-alist' has now become customizable.  If
you had added your own regexps to this, you'll probably need to include a
leading `^', otherwise they'll match anywhere on a line.  There is now also a
`compilation-mode-font-lock-keywords' and it nicely handles all the checks
that configure outputs and -o options so you see at a glance where you are.

The new file etc/compilation.txt gives examples of each type of message.

** Compilation mode enhancements:

+++
*** New user option `compilation-environment'.
This option allows you to specify environment variables for inferior
compilation processes without affecting the environment that all
subprocesses inherit.

** Grep has been decoupled from compilation mode setup.

*** There's a new separate package grep.el.

*** M-x grep has been adapted to new compile

Hits are fontified in green, and hits in binary files in orange.  Grep buffers
can be saved and automatically revisited with the new Grep mode.

*** Grep commands now have their own submenu and customization group.

*** The new variables `grep-window-height', `grep-auto-highlight', and
`grep-scroll-output' can be used to override the corresponding
compilation mode settings for grep commands.

*** New option `grep-highlight-matches' highlightes matches in *grep*
buffer.  It uses a special feature of some grep programs which accept
--color option to output markers around matches.  When going to the next
match with `next-error' the exact match is highlighted in the source
buffer.  Otherwise, if `grep-highlight-matches' is nil, the whole
source line is highlighted.

*** New key bindings in grep output window:
SPC and DEL scrolls window up and down.  C-n and C-p moves to next and
previous match in the grep window.  RET jumps to the source line of
the current match.  `n' and `p' shows next and previous match in
other window, but does not switch buffer.  `{' and `}' jumps to the
previous or next file in the grep output.  TAB also jumps to the next
file.

** New options `next-error-highlight' and `next-error-highlight-no-select'
specify the method of highlighting of the corresponding source line
in new face `next-error'.

** A new minor mode `next-error-follow-minor-mode' can be used in
compilation-mode, grep-mode, occur-mode, and diff-mode (i.e. all the
modes that can use `next-error').  In this mode, cursor motion in the
buffer causes automatic display in another window of the corresponding
matches, compilation errors, etc.  This minor mode can be toggled with
C-c C-f.

** M-x diff uses diff-mode instead of compilation-mode.

** M-x compare-windows now can automatically skip non-matching text to
resync points in both windows.

** New command `strokes-global-set-stroke-string'.
This is like `strokes-global-set-stroke', but it allows you to bind
the stroke directly to a string to insert.  This is convenient for
using strokes as an input method.

** Gnus package

*** Gnus now includes Sieve and PGG
Sieve is a library for managing Sieve scripts.  PGG is a library to handle
PGP/MIME.

*** There are many news features, bug fixes and improvements.
See the file GNUS-NEWS or the node "Oort Gnus" in the Gnus manual for details.

+++
** Desktop package

*** Desktop saving is now a minor mode, desktop-save-mode. Variable
desktop-enable is obsolete. Customize desktop-save-mode to enable desktop
saving.

*** Buffers are saved in the desktop file in the same order as that in the
buffer list.

*** The desktop package can be customized to restore only some buffers immediately,
remaining buffers are restored lazily (when Emacs is idle).

*** New commands:
  - desktop-revert reverts to the last loaded desktop.
  - desktop-change-dir kills current desktop and loads a new.
  - desktop-save-in-desktop-dir saves desktop in the directory from which
    it was loaded.
  - desktop-lazy-complete runs the desktop load to completion.
  - desktop-lazy-abort aborts lazy loading of the desktop.

*** New customizable variables:
  - desktop-save. Determins whether the desktop should be saved when it is
    killed.
  - desktop-file-name-format. Format in which desktop file names should be saved.
  - desktop-path. List of directories in which to lookup the desktop file.
  - desktop-locals-to-save. List of local variables to save.
  - desktop-globals-to-clear. List of global variables that `desktop-clear' will clear.
  - desktop-clear-preserve-buffers-regexp. Regexp identifying buffers that `desktop-clear'
    should not delete.
  - desktop-restore-eager. Number of buffers to restore immediately. Remaining buffers are
    restored lazily (when Emacs is idle).
  - desktop-lazy-verbose. Verbose reporting of lazily created buffers.
  - desktop-lazy-idle-delay. Idle delay before starting to create buffers.

*** New command line option --no-desktop

*** New hooks:
  - desktop-after-read-hook run after a desktop is loaded.
  - desktop-no-desktop-file-hook run when no desktop file is found.

---
** The saveplace.el package now filters out unreadable files.
When you exit Emacs, the saved positions in visited files no longer
include files that aren't readable, e.g. files that don't exist.
Customize the new option `save-place-forget-unreadable-files' to nil
to get the old behavior.  The new options `save-place-save-skipped'
and `save-place-skip-check-regexp' allow further fine-tuning of this
feature.

** You can have several Emacs servers on the same machine.

	% emacs --eval '(setq server-name "foo")' -f server-start &
	% emacs --eval '(setq server-name "bar")' -f server-start &
	% emacsclient -s foo file1
	% emacsclient -s bar file2

+++
** On window systems, lines which are exactly as wide as the window
(not counting the final newline character) are no longer broken into
two lines on the display (with just the newline on the second line).
Instead, the newline now "overflows" into the right fringe, and the
cursor will be displayed in the fringe when positioned on that newline.

The new user option 'overflow-newline-into-fringe' may be set to nil to
revert to the old behaviour of continuing such lines.

+++
** The buffer boundaries (i.e. first and last line in the buffer) may
now be marked with angle bitmaps in the fringes.  In addition, up and
down arrow bitmaps may be shown at the top and bottom of the left or
right fringe if the window can be scrolled in either direction.

This behavior is activated by setting the buffer-local variable
`indicate-buffer-boundaries' to a non-nil value.  The default value of
this variable is found in `default-indicate-buffer-boundaries'.

If value is `left' or `right', both angle and arrow bitmaps are
displayed in the left or right fringe, resp.

Value may also be an alist which specifies the presense and position
of each bitmap individually.

For example, ((top . left) (t .  right)) places the top angle bitmap
in left fringe, the bottom angle bitmap in right fringe, and both
arrow bitmaps in right fringe.  To show just the angle bitmaps in the
left fringe, but no arrow bitmaps, use ((top . left) (bottom . left)).

** New command `display-local-help' displays any local help at point
in the echo area.  It is bound to `C-h .'.  It normally displays the
same string that would be displayed on mouse-over using the
`help-echo' property, but, in certain cases, it can display a more
keyboard oriented alternative.

** New user option `help-at-pt-display-when-idle' allows to
automatically show the help provided by `display-local-help' on
point-over, after suitable idle time.  The amount of idle time is
determined by the user option `help-at-pt-timer-delay' and defaults
to one second.  This feature is turned off by default.

** New commands `scan-buf-next-region' and `scan-buf-previous-region'
move to the start of the next (previous, respectively) region with
non-nil help-echo property and display any help found there in the
echo area, using `display-local-help'.

+++
** Help mode now only makes hyperlinks for faces when the face name is
preceded or followed by the word `face'.  It no longer makes
hyperlinks for variables without variable documentation, unless
preceded by one of the words `variable' or `option'.  It now makes
hyperlinks to Info anchors (or nodes) if the anchor (or node) name is
enclosed in single quotes and preceded by `info anchor' or `Info
anchor' (in addition to earlier `info node' and `Info node').

** The max size of buffers and integers has been doubled.
On 32bit machines, it is now 256M (i.e. 268435455).

+++
** The -f option, used from the command line to call a function,
now reads arguments for the function interactively if it is
an interactively callable function.


** sql changes.

*** The variable `sql-product' controls the highlightng of different
SQL dialects.  This variable can be set globally via Customize, on a
buffer-specific basis via local variable settings, or for the current
session using the new SQL->Product submenu.  (This menu replaces the
SQL->Highlighting submenu.)

The following values are supported:

    ansi	ANSI Standard (default)
    db2		DB2
    informix    Informix
    ingres      Ingres
    interbase	Interbase
    linter	Linter
    ms		Microsoft
    mysql	MySQL
    oracle	Oracle
    postgres	Postgres
    solid       Solid
    sqlite      SQLite
    sybase      Sybase

The current product name will be shown on the mode line following the
SQL mode indicator.

The technique of setting `sql-mode-font-lock-defaults' directly in
your .emacs will no longer establish the default highlighting -- Use
`sql-product' to accomplish this.

ANSI keywords are always highlighted.

*** The function `sql-add-product-keywords' can be used to add
font-lock rules to the product specific rules.  For example, to have
all identifiers ending in "_t" under MS SQLServer treated as a type,
you would use the following line in your .emacs file:

  (sql-add-product-keywords 'ms
             '(("\\<\\w+_t\\>" . font-lock-type-face)))

*** Oracle support includes keyword highlighting for Oracle 9i.  Most
SQL and PL/SQL keywords are implemented.  SQL*Plus commands are
highlighted in `font-lock-doc-face'.

*** Microsoft SQLServer support has been significantly improved.
Keyword highlighting for SqlServer 2000 is implemented.
sql-interactive-mode defaults to use osql, rather than isql, because
osql flushes its error stream more frequently.  Thus error messages
are displayed when they occur rather than when the session is
terminated.

If the username and password are not provided to `sql-ms', osql is
called with the -E command line argument to use the operating system
credentials to authenticate the user.

*** Postgres support is enhanced.
Keyword highlighting of Postgres 7.3 is implemented.  Prompting for
the username and the pgsql `-U' option is added.

*** MySQL support is enhanced.
Keyword higlighting of MySql 4.0 is implemented.

*** Imenu support has been enhanced to locate tables, views, indexes,
packages, procedures, functions, triggers, sequences, rules, and
defaults.

*** Added SQL->Start SQLi Session menu entry which calls the
appropriate sql-interactive-mode wrapper for the current setting of
`sql-product'.

** M-x view-file and commands that use it now avoid interfering
with special modes such as Tar mode.

** Enhancements to apropos commands:

*** The apropos commands now accept a list of words to match.
When more than one word is specified, at least two of those words must
be present for an item to match.  Regular expression matching is still
available.

*** The new option `apropos-sort-by-scores' causes the matching items
to be sorted according to their score.  The score for an item is a
number calculated to indicate how well the item matches the words or
regular expression that you entered to the apropos command.  The best
match is listed first, and the calculated score is shown for each
matching item.

+++
** The old bindings C-M-delete and C-M-backspace have been deleted,
since there are situations where one or the other will shut down
the operating system or your X server.

** New minor mode, Visible mode, toggles invisibility in the current buffer.
When enabled, it makes all invisible text visible.  When disabled, it
restores the previous value of `buffer-invisibility-spec'.

** New command `kill-whole-line' kills an entire line at once.
By default, it is bound to C-S-<backspace>.

** New commands to operate on pairs of open and close characters:
`insert-pair', `delete-pair', `raise-sexp'.

** A prefix argument of C-M-q in Emacs Lisp mode pretty-printifies the
list starting after point.

** Dired mode:

*** New faces dired-header, dired-mark, dired-marked, dired-flagged,
dired-ignored, dired-directory, dired-symlink, dired-warning
introduced for Dired mode instead of font-lock faces.

*** New Dired command `dired-compare-directories' marks files
with different file attributes in two dired buffers.

+++
*** New Dired command `dired-do-touch' (bound to T) changes timestamps
of marked files with the value entered in the minibuffer.

+++
*** In Dired's ! command (dired-do-shell-command), `*' and `?' now
control substitution of the file names only when they are surrounded
by whitespace.  This means you can now use them as shell wildcards
too.  If you want to use just plain `*' as a wildcard, type `*""'; the
doublequotes make no difference in the shell, but they prevent
special treatment in `dired-do-shell-command'.

*** In Dired, the w command now copies the current line's file name
into the kill ring.  With a zero prefix arg, copies absolute file names.

+++
** Dired-x:

*** Omitting files is now a minor mode, dired-omit-mode. The mode toggling
command is bound to M-o. A new command dired-mark-omitted, bound to M-O,
marks omitted files. The variable dired-omit-files-p is obsoleted, use the
mode toggling function instead.

+++
** find-file-read-only visits multiple files in read-only mode,
when the file name contains wildcard characters.

+++
** find-alternate-file replaces the current file with multiple files,
when the file name contains wildcard characters.

** FFAP

+++
*** New ffap commands and keybindings: C-x C-r (`ffap-read-only'),
C-x C-v (`ffap-alternate-file'), C-x C-d (`ffap-list-directory'),
C-x 4 r (`ffap-read-only-other-window'), C-x 4 d (`ffap-dired-other-window'),
C-x 5 r (`ffap-read-only-other-frame'), C-x 5 d (`ffap-dired-other-frame').

---
*** FFAP accepts wildcards in a file name by default.  C-x C-f passes
it to `find-file' with non-nil WILDCARDS argument, which visits
multiple files, and C-x d passes it to `dired'.

** Info mode:

*** A numeric prefix argument of `info' selects an Info buffer
with the number appended to the *info* buffer name.

*** Regexp isearch (C-M-s and C-M-r) can search through multiple nodes.
Failed isearch wraps to the top/final node.

*** New search commands: `Info-search-case-sensitively' (bound to S),
`Info-search-backward', and `Info-search-next' which repeats the last
search without prompting for a new search string.

*** New command `Info-history' (bound to L) displays a menu of visited nodes.

*** New command `Info-toc' (bound to T) creates a node with table of contents
from the tree structure of menus of the current Info file.

*** New command `info-apropos' searches the indices of the known
Info files on your system for a string, and builds a menu of the
possible matches.

*** New command `Info-copy-current-node-name' (bound to w) copies
the current Info node name into the kill ring.  With a zero prefix
arg, puts the node name inside the `info' function call.

*** New face `info-xref-visited' distinguishes visited nodes from unvisited
and a new option `Info-fontify-visited-nodes' to control this.

*** http and ftp links in Info are now operational: they look like cross
references and following them calls `browse-url'.

+++
*** Info now hides node names in menus and cross references by default.
If you prefer the old behavior, you can set the new user option
`Info-hide-note-references' to nil.

*** Images in Info pages are supported.
Info pages show embedded images, in Emacs frames with image support.
Info documentation that includes images, processed with makeinfo
version 4.7 or newer, compiles to Info pages with embedded images.

+++
*** The default value for `Info-scroll-prefer-subnodes' is now nil.

---
*** Info-index offers completion.

** Support for the SQLite interpreter has been added to sql.el by calling
'sql-sqlite'.

** BibTeX mode:
*** The new command bibtex-url browses a URL for the BibTeX entry at
point (bound to C-c C-l and mouse-2, RET on clickable fields).

*** The new command bibtex-entry-update (bound to C-c C-u) updates
an existing BibTeX entry.

*** New `bibtex-entry-format' option `required-fields', enabled by default.

*** bibtex-maintain-sorted-entries can take values `plain',
`crossref', and `entry-class' which control the sorting scheme used
for BibTeX entries.  `bibtex-sort-entry-class' controls the sorting
scheme `entry-class'.  TAB completion for reference keys and
automatic detection of duplicates does not require anymore that
bibtex-maintain-sorted-entries is non-nil.

*** If the new variable bibtex-parse-keys-fast is non-nil,
use fast but simplified algorithm for parsing BibTeX keys.

*** If the new variable bibtex-autoadd-commas is non-nil,
automatically add missing commas at end of BibTeX fields.

*** The new variable bibtex-autofill-types contains a list of entry
types for which fields are filled automatically (if possible).

*** The new command bibtex-complete completes word fragment before
point according to context (bound to M-tab).

*** The new commands bibtex-find-entry and bibtex-find-crossref
locate entries and crossref'd entries (bound to C-c C-s and C-c C-x).
Crossref fields are clickable (bound to mouse-2, RET).

*** In BibTeX mode the command fill-paragraph (bound to M-q) fills
individual fields of a BibTeX entry.

*** The new variables bibtex-files and bibtex-file-path define a set
of BibTeX files that are searched for entry keys.

*** The new command bibtex-validate-globally checks for duplicate keys
in multiple BibTeX files.

*** The new command bibtex-copy-summary-as-kill pushes summary
of BibTeX entry to kill ring (bound to C-c C-t).

** When display margins are present in a window, the fringes are now
displayed between the margins and the buffer's text area, rather than
at the edges of the window.

** A window may now have individual fringe and scroll-bar settings,
in addition to the individual display margin settings.

Such individual settings are now preserved when windows are split
horizontally or vertically, a saved window configuration is restored,
or when the frame is resized.

** New functions frame-current-scroll-bars and window-current-scroll-bars.

These functions return the current locations of the vertical and
horizontal scroll bars in a frame or window.

---
** Emacs now supports drag and drop for X.  Dropping a file on a window
   opens it, dropping text inserts the text.  Dropping a file on a dired
   buffer copies or moves the file to that directory.

** Under X, mouse-wheel-mode is turned on by default.

** The X resource useXIM can be used to turn off use of XIM, which may
speed up Emacs with slow networking to the X server.

If the configure option `--without-xim' was used to turn off use of
XIM by default, the X resource useXIM can be used to turn it on.

** `undo-only' does an undo which does not redo any previous undo.

** `uniquify-strip-common-suffix' tells uniquify to prefer
`file|dir1' and `file|dir2' to `file|dir1/subdir' and `file|dir2/subdir'.

** If the user visits a file larger than `large-file-warning-threshold',
Emacs prompts her for confirmation.

** A UTF-7 coding system is available in the library `utf-7'.

** GUD mode has its own tool bar for controlling execution of the inferior
and other common debugger commands.

** recentf changes.

The recent file list is now automatically cleanup when recentf mode is
enabled.  The new option `recentf-auto-cleanup' controls when to do
automatic cleanup.

With the more advanced option: `recentf-filename-handler', you can
specify a function that transforms filenames handled by recentf.  For
example, if set to `file-truename', the same file will not be in the
recent list with different symbolic links.

To follow naming convention, `recentf-keep-non-readable-files-flag'
and `recentf-menu-append-commands-flag' respectively replace the
misnamed options `recentf-keep-non-readable-files-p' and
`recentf-menu-append-commands-p'.  The old names remain available as
aliases, but have been marked obsolete.

** The default for the paper size (variable ps-paper-type) is taken
from the locale.

** Init file changes

You can now put the init files .emacs and .emacs_SHELL under
~/.emacs.d or directly under ~.  Emacs will find them in either place.

** partial-completion-mode now does partial completion on directory names.

** skeleton.el now supports using - to mark the skeleton-point without
   interregion interaction.  @ has reverted to only setting
   skeleton-positions and no longer sets skeleton-point.  Skeletons
   which used @ to mark skeleton-point independent of _ should now use -
   instead.  The updated skeleton-insert docstring explains these new
   features along with other details of skeleton construction.

** MH-E changes.

Upgraded to MH-E version 7.82. There have been major changes since
version 5.0.2; see MH-E-NEWS for details.

+++
** The `emacsclient' command understands the options `--eval' and
`--display' which tell Emacs respectively to evaluate the given elisp
expression and to use the given display when visiting files.

** User option `server-mode' can be used to start a server process.

+++
** The mode line position information now comes before the major mode.
When the file is maintained under version control, that information
appears between the position information and the major mode.

** C-x s (save-some-buffers) now offers an option `d' to diff a buffer
against its file, so you can see what changes you would be saving.

+++
** You can now customize the use of window fringes.  To control this
for all frames, use M-x fringe-mode or the Show/Hide submenu of the
top-level Options menu, or customize the `fringe-mode' variable.  To
control this for a specific frame, use the command M-x
set-fringe-style.

+++
** There is a new user option `mail-default-directory' that allows you
to specify the value of `default-directory' for mail buffers.  This
directory is used for auto-save files of mail buffers.  It defaults to
"~/".

+++
** When you are root, and you visit a file whose modes specify
read-only, the Emacs buffer is now read-only too.  Type C-x C-q if you
want to make the buffer writable.  (As root, you can in fact alter the
file.)

** The new command `revert-buffer-with-coding-system' (C-x RET r)
revisits the current file using a coding system that you specify.

** The new command `recode-file-name' changes the encoding of the name
of a file.

---
** `ps-print' can now print characters from the mule-unicode charsets.

Printing text with characters from the mule-unicode-* sets works with
ps-print, provided that you have installed the appropriate BDF fonts.
See the file INSTALL for URLs where you can find these fonts.

---
** The new options `buffers-menu-show-directories' and
`buffers-menu-show-status' let you control how buffers are displayed
in the menu dropped down when you click "Buffers" from the menu bar.

`buffers-menu-show-directories' controls whether the menu displays
leading directories as part of the file name visited by the buffer.
If its value is `unless-uniquify', the default, directories are
shown unless uniquify-buffer-name-style' is non-nil.  The value of nil
and t turn the display of directories off and on, respectively.

`buffers-menu-show-status' controls whether the Buffers menu includes
the modified and read-only status of the buffers.  By default it is
t, and the status is shown.

Setting these variables directly does not take effect until next time
the Buffers menu is regenerated.

+++
** The commands M-x customize-face and M-x customize-face-other-window
now look at the character after point.  If a face or faces are
specified for that character, the commands by default customize those
faces.

** New language environments: French, Ukrainian, Tajik,
Bulgarian, Belarusian, Ukrainian, UTF-8, Windows-1255, Welsh, Latin-6,
Latin-7, Lithuanian, Latvian, Swedish, Slovenian, Croatian, Georgian,
Italian, Russian, Malayalam, Tamil, Russian, Chinese-EUC-TW.  (Set up
automatically according to the locale.)

** Indian support has been updated.
The in-is13194 coding system is now Unicode-based.  CDAC fonts are
assumed.  There is a framework for supporting various
Indian scripts, but currently only Devanagari, Malayalam and Tamil are
supported.

---
** New input methods: latin-alt-postfix, latin-postfix, latin-prefix,
ukrainian-computer, belarusian, bulgarian-bds, russian-computer,
vietnamese-telex, lithuanian-numeric, lithuanian-keyboard,
latvian-keyboard, welsh, georgian, rfc1345, ucs, sgml,
bulgarian-phonetic, dutch, slovenian, croatian, malayalam-inscript,
tamil-inscript.

---
** A new coding system `euc-tw' has been added for traditional Chinese
in CNS encoding; it accepts both Big 5 and CNS as input; on saving,
Big 5 is then converted to CNS.

---
** Many new coding systems are available by loading the `code-pages'
library.  These include complete versions of most of those in
codepage.el, based on Unicode mappings.  `codepage-setup' is now
obsolete and is used only in the MS-DOS port of Emacs.  windows-1252
and windows-1251 are preloaded since the former is so common and the
latter is used by GNU locales.

** The utf-8/16 coding systems have been enhanced.
By default, untranslatable utf-8 sequences are simply composed into
single quasi-characters.  User option `utf-translate-cjk-mode' (it is
turned on by default) arranges to translate many utf-8 CJK character
sequences into real Emacs characters in a similar way to the Mule-UCS
system.  As this loads a fairly big data on demand, people who are not
interested in CJK characters may want to customize it to nil.
You can augment/amend the CJK translation via hash tables
`ucs-mule-cjk-to-unicode' and `ucs-unicode-to-mule-cjk'.  The utf-8
coding system now also encodes characters from most of Emacs's
one-dimensional internal charsets, specifically the ISO-8859 ones.
The utf-16 coding system is affected similarly.

** New variable `utf-translate-cjk-unicode-range' controls which
Unicode characters to translate in `utf-translate-cjk-mode'.

** iso-10646-1 (`Unicode') fonts can be used to display any range of
characters encodable by the utf-8 coding system.  Just specify the
fontset appropriately.

** New command `ucs-insert' inserts a character specified by its
unicode.

+++
** Limited support for character `unification' has been added.
Emacs now knows how to translate between different representations of
the same characters in various Emacs charsets according to standard
Unicode mappings.  This applies mainly to characters in the ISO 8859
sets plus some other 8-bit sets, but can be extended.  For instance,
translation works amongst the Emacs ...-iso8859-... charsets and the
mule-unicode-... ones.

By default this translation happens automatically on encoding.
Self-inserting characters are translated to make the input conformant
with the encoding of the buffer in which it's being used, where
possible.

You can force a more complete unification with the user option
unify-8859-on-decoding-mode.  That maps all the Latin-N character sets
into Unicode characters (from the latin-iso8859-1 and
mule-unicode-0100-24ff charsets) on decoding.  Note that this mode
will often effectively clobber data with an iso-2022 encoding.

** There is support for decoding Greek and Cyrillic characters into
either Unicode (the mule-unicode charsets) or the iso-8859 charsets,
when possible.  The latter are more space-efficient.  This is
controlled by user option utf-fragment-on-decoding.

** The new command `set-file-name-coding-system' (C-x RET F) sets
coding system for encoding and decoding file names.  A new menu item
(Options->Mule->Set Coding Systems->For File Name) invokes this
command.

---
** The scrollbar under LessTif or Motif has a smoother drag-scrolling.
On the other hand, the size of the thumb does not represent the actual
amount of text shown any more (only a crude approximation of it).

---
** The pop up menus for Lucid now stay up if you do a fast click and can
be navigated with the arrow keys (like Gtk+, Mac and W32).

---
** Dialogs for Lucid/Athena and Lesstif/Motif now pops down when pressing
ESC, like they do for Gtk+, Mac and W32.

---
**  Dialogs and menus pop down when pressing C-g.

---
** The menu item "Open File..." has been split into two items, "New File..."
and "Open File...".  "Open File..." now opens only existing files.  This is
to support existing GUI file selection dialogs better.

+++
** The file selection dialog for Gtk+, Mac, W32 and Motif/Lesstif can be
disabled by customizing the variable `use-file-dialog'.

+++
** For Gtk+ version 2.4, you can make Emacs use the old file dialog
by setting the variable `x-use-old-gtk-file-dialog' to t.  Default is to use
the new dialog.

+++
** Emacs can produce an underscore-like (horizontal bar) cursor.
The underscore cursor is set by putting `(cursor-type . hbar)' in
default-frame-alist.  It supports variable heights, like the `bar'
cursor does.

+++
** On X, MS Windows, and Mac OS, the blinking cursor's "off" state is
now controlled by the variable `blink-cursor-alist'.

** Filesets are collections of files.  You can define a fileset in
various ways, such as based on a directory tree or based on
program files that include other program files.

Once you have defined a fileset, you can perform various operations on
all the files in it, such as visiting them or searching and replacing
in them.

---
** PO translation files are decoded according to their MIME headers
when Emacs visits them.

---
** The game `mpuz' is enhanced.

`mpuz' now allows the 2nd factor not to have two identical digits.  By
default, all trivial operations involving whole lines are performed
automatically.  The game uses faces for better visual feedback.

** The new variable `x-select-request-type' controls how Emacs
requests X selection.  The default value is nil, which means that
Emacs requests X selection with types COMPOUND_TEXT and UTF8_STRING,
and use the more appropriately result.

+++
** The parameters of automatic hscrolling can now be customized.
The variable `hscroll-margin' determines how many columns away from
the window edge point is allowed to get before automatic hscrolling
will horizontally scroll the window.  The default value is 5.

The variable `hscroll-step' determines how many columns automatic
hscrolling scrolls the window when point gets too close to the
window edge.  If its value is zero, the default, Emacs scrolls the
window so as to center point.  If its value is an integer, it says how
many columns to scroll.  If the value is a floating-point number, it
gives the fraction of the window's width to scroll the window.

The variable `automatic-hscrolling' was renamed to
`auto-hscroll-mode'.  The old name is still available as an alias.

** TeX modes:
*** C-c C-c prompts for a command to run, and tries to offer a good default.
+++
*** The user option `tex-start-options-string' has been replaced
by two new user options: `tex-start-options', which should hold
command-line options to feed to TeX, and `tex-start-commands' which should hold
TeX commands to use at startup.
*** verbatim environments are now highlighted in courier by font-lock
and super/sub-scripts are made into super/sub-scripts.

*** New major mode doctex-mode for *.dtx files.

+++
** New display feature: focus follows the mouse from one Emacs window
to another, even within a frame.  If you set the variable
mouse-autoselect-window to non-nil value, moving the mouse to a
different Emacs window will select that window (minibuffer window can
be selected only when it is active).  The default is nil, so that this
feature is not enabled.

** On X, when the window manager requires that you click on a frame to
select it (give it focus), the selected window and cursor position
normally changes according to the mouse click position.  If you set
the variable x-mouse-click-focus-ignore-position to t, the selected
window and cursor position do not change when you click on a frame
to give it focus.

+++
** The new command `describe-char' (C-u C-x =) pops up a buffer with
description various information about a character, including its
encodings and syntax, its text properties, how to input, overlays, and
widgets at point.  You can get more information about some of them, by
clicking on mouse-sensitive areas or moving there and pressing RET.

+++
** The new command `multi-occur' is just like `occur', except it can
search multiple buffers.  There is also a new command
`multi-occur-by-filename-regexp' which allows you to specify the
buffers to search by their filename.  Internally, Occur mode has been
rewritten, and now uses font-lock, among other changes.

** The default values of paragraph-start and indent-line-function have
been changed to reflect those used in Text mode rather than those used
in Indented-Text mode.

** New user option `query-replace-skip-read-only': when non-nil,
`query-replace' and related functions simply ignore
a match if part of it has a read-only property.

** When used interactively, the commands `query-replace-regexp' and
`replace-regexp' allow \,expr to be used in a replacement string,
where expr is an arbitrary Lisp expression evaluated at replacement
time.  In many cases, this will be more convenient than using
`query-replace-regexp-eval'.  `\#' in a replacement string now refers
to the count of replacements already made by the replacement command.
All regular expression replacement commands now allow `\?' in the
replacement string to specify a position where the replacement string
can be edited for each replacement.

** query-replace uses isearch lazy highlighting when the new user option
`query-replace-lazy-highlight' is non-nil.

** The current match in query-replace is highlighted in new face
`query-replace' which by default inherits from isearch face.

+++
** Emacs normally highlights mouse sensitive text whenever the mouse
is over the text.  By setting the new variable `mouse-highlight', you
can optionally enable mouse highlighting only after you move the
mouse, so that highlighting disappears when you press a key.  You can
also disable mouse highlighting.

** You can now customize if selecting a region by dragging the mouse
shall not copy the selected text to the kill-ring by setting the new
variable mouse-drag-copy-region to nil.

+++
** font-lock: in modes like C and Lisp where the fontification assumes that
an open-paren in column 0 is always outside of any string or comment,
font-lock now highlights any such open-paren-in-column-zero in bold-red
if it is inside a string or a comment, to indicate that it can cause
trouble with fontification and/or indentation.

+++
** There's a new face `minibuffer-prompt'.
Emacs adds this face to the list of text properties stored in the
variable `minibuffer-prompt-properties', which is used to display the
prompt string.

+++
** The new face `mode-line-inactive' is used to display the mode line
of non-selected windows.  The `mode-line' face is now used to display
the mode line of the currently selected window.

The new variable `mode-line-in-non-selected-windows' controls whether
the `mode-line-inactive' face is used.

---
** A menu item "Show/Hide" was added to the top-level menu "Options".
This menu allows you to turn various display features on and off (such
as the fringes, the tool bar, the speedbar, and the menu bar itself).
You can also move the vertical scroll bar to either side here or turn
it off completely.  There is also a menu-item to toggle displaying of
current date and time, current line and column number in the
mode-line.

---
** Speedbar has moved from the "Tools" top level menu to "Show/Hide".

+++
** Emacs can now indicate in the mode-line the presence of new e-mail
in a directory or in a file.  See the documentation of the user option
`display-time-mail-directory'.

---
** LDAP support now defaults to ldapsearch from OpenLDAP version 2.

+++
** You can now disable pc-selection-mode after enabling it.
M-x pc-selection-mode behaves like a proper minor mode, and with no
argument it toggles the mode.

Turning off PC-Selection mode restores the global key bindings
that were replaced by turning on the mode.

+++
** Emacs now displays a splash screen by default even if command-line
arguments were given.  The new command-line option --no-splash
disables the splash screen; see also the variable
`inhibit-startup-message' (which is also aliased as
`inhibit-splash-screen').

** Changes in support of colors on character terminals

+++
*** The new command-line option --color=MODE lets you specify a standard
mode for a tty color support.  It is meant to be used on character
terminals whose capabilities are not set correctly in the terminal
database, or with terminal emulators which support colors, but don't
set the TERM environment variable to a name of a color-capable
terminal.  "emacs --color" uses the same color commands as GNU `ls'
when invoked with "ls --color", so if your terminal can support colors
in "ls --color", it will support "emacs --color" as well.  See the
user manual for the possible values of the MODE parameter.

---
*** Emacs now supports several character terminals which provide more
than 8 colors.  For example, for `xterm', 16-color, 88-color, and
256-color modes are supported.  Emacs automatically notes at startup
the extended number of colors, and defines the appropriate entries for
all of these colors.

+++
*** Emacs now uses the full range of available colors for the default
faces when running on a color terminal, including 16-, 88-, and
256-color xterms.  This means that when you run "emacs -nw" on an
88-color or 256-color xterm, you will see essentially the same face
colors as on X.

---
*** There's a new support for colors on `rxvt' terminal emulator.

+++
** Emacs can now be invoked in full-screen mode on a windowed display.

When Emacs is invoked on a window system, the new command-line options
`--fullwidth', `--fullheight', and `--fullscreen' produce a frame
whose width, height, or both width and height take up the entire
screen size.  (For now, this does not work with some window managers.)

---
** Emacs now tries to set up buffer coding systems for HTML/XML files
automatically.

+++
** The new command `comint-insert-previous-argument' in comint-derived
modes (shell-mode etc) inserts arguments from previous command lines,
like bash's `ESC .' binding.  It is bound by default to `C-c .', but
otherwise behaves quite similarly to the bash version.

+++
** Changes in C-h bindings:

C-h e displays the *Messages* buffer.

C-h followed by a control character is used for displaying files
    that do not change:

C-h C-f displays the FAQ.
C-h C-e displays the PROBLEMS file.

The info-search bindings on C-h C-f, C-h C-k and C-h C-i
have been moved to C-h F, C-h K and C-h S.

C-h c, C-h k, C-h w, and C-h f now handle remapped interactive commands.

- C-h c and C-h k report the actual command (after possible remapping)
  run by the key sequence.

- C-h w and C-h f on a command which has been remapped now report the
  command it is remapped to, and the keys which can be used to run
  that command.

For example, if C-k is bound to kill-line, and kill-line is remapped
to new-kill-line, these commands now report:

- C-h c and C-h k C-k reports:
  C-k runs the command new-kill-line

- C-h w and C-h f kill-line reports:
  kill-line is remapped to new-kill-line which is on C-k, <deleteline>

- C-h w and C-h f new-kill-line reports:
  new-kill-line is on C-k

+++
** Vertical scrolling is now possible within incremental search.
To enable this feature, customize the new user option
`isearch-allow-scroll'.  User written commands which satisfy stringent
constraints can be marked as "scrolling commands".  See the Emacs manual
for details.

+++
** C-w in incremental search now grabs either a character or a word,
making the decision in a heuristic way.  This new job is done by the
command `isearch-yank-word-or-char'.  To restore the old behavior,
bind C-w to `isearch-yank-word' in `isearch-mode-map'.

+++
** C-y in incremental search now grabs the next line if point is already
at the end of a line.

+++
** C-M-w deletes and C-M-y grabs a character in isearch mode.
Another method to grab a character is to enter the minibuffer by `M-e'
and to type `C-f' at the end of the search string in the minibuffer.

+++
** M-% typed in isearch mode invokes `query-replace' or
`query-replace-regexp' (depending on search mode) with the current
search string used as the string to replace.

+++
** Isearch no longer adds `isearch-resume' commands to the command
history by default.  To enable this feature, customize the new
user option `isearch-resume-in-command-history'.

+++
** New user option `history-delete-duplicates'.
If set to t when adding a new history element, all previous identical
elements are deleted.

+++
** Yanking text now discards certain text properties that can
be inconvenient when you did not expect them.  The variable
`yank-excluded-properties' specifies which ones.  Insertion
of register contents and rectangles also discards these properties.

+++
** Occur, Info, and comint-derived modes now support using
M-x font-lock-mode to toggle fontification.  The variable
`Info-fontify' is no longer applicable; to disable fontification,
remove `turn-on-font-lock' from `Info-mode-hook'.

+++
** M-x grep now tries to avoid appending `/dev/null' to the command line
by using GNU grep `-H' option instead.  M-x grep automatically
detects whether this is possible or not the first time it is invoked.
When `-H' is used, the grep command line supplied by the user is passed
unchanged to the system to execute, which allows more complicated
command lines to be used than was possible before.

---
** The face-customization widget has been reworked to be less confusing.
In particular, when you enable a face attribute using the corresponding
check-box, there's no longer a redundant `*' option in value selection
for that attribute; the values you can choose are only those which make
sense for the attribute.  When an attribute is de-selected by unchecking
its check-box, then the (now ignored, but still present temporarily in
case you re-select the attribute) value is hidden.

+++
** When you set or reset a variable's value in a Customize buffer,
the previous value becomes the "backup value" of the variable.
You can go back to that backup value by selecting "Use Backup Value"
under the "[State]" button.

** The new customization type `float' specifies numbers with floating
point (no integers are allowed).

+++
** In GUD mode, when talking to GDB, C-x C-a C-j "jumps" the program
counter to the specified source line (the one where point is).

---
** GUD mode improvements for jdb:

*** Search for source files using jdb classpath and class
    information. Fast startup since there is no need to scan all
    source files up front. There is also no need to create and maintain
    lists of source directories to scan. Look at `gud-jdb-use-classpath'
    and `gud-jdb-classpath' customization variables documentation.

*** Supports the standard breakpoint (gud-break, gud-clear)
    set/clear operations from java source files under the classpath, stack
    traversal (gud-up, gud-down), and run until current stack finish
    (gud-finish).

*** Supports new jdb (Java 1.2 and later) in addition to oldjdb
    (Java 1.1 jdb).

*** The previous method of searching for source files has been
    preserved in case someone still wants/needs to use it.
    Set gud-jdb-use-classpath to nil.

  Added Customization Variables

*** gud-jdb-command-name.  What command line to use to invoke jdb.

*** gud-jdb-use-classpath. Allows selection of java source file searching
    method: set to t for new method, nil to scan gud-jdb-directories for
    java sources (previous method).

*** gud-jdb-directories. List of directories to scan and search for java
    classes using the original gud-jdb method (if gud-jdb-use-classpath
    is nil).

  Minor Improvements

*** The STARTTLS elisp wrapper (starttls.el) can now use GNUTLS
instead of the OpenSSL based "starttls" tool.  For backwards
compatibility, it prefers "starttls", but you can toggle
`starttls-use-gnutls' to switch to GNUTLS (or simply remove the
"starttls" tool).

*** Do not allow debugger output history variable to grow without bounds.

+++
** hide-ifdef-mode now uses overlays rather than selective-display
to hide its text.  This should be mostly transparent but slightly
changes the behavior of motion commands like C-e and C-p.

+++
** Unquoted `$' in file names do not signal an error any more when
the corresponding environment variable does not exist.
Instead, the `$ENVVAR' text is left as is, so that `$$' quoting
is only rarely needed.

---
** JIT-lock changes
*** jit-lock can now be delayed with `jit-lock-defer-time'.

If this variable is non-nil, its value should be the amount of Emacs
idle time in seconds to wait before starting fontification.  For
example, if you set `jit-lock-defer-time' to 0.25, fontification will
only happen after 0.25s of idle time.

*** contextual refontification is now separate from stealth fontification.

jit-lock-defer-contextually is renamed jit-lock-contextually and
jit-lock-context-time determines the delay after which contextual
refontification takes place.

+++
** Marking commands extend the region when invoked multiple times.  If
you hit M-C-SPC (mark-sexp), M-@ (mark-word), M-h (mark-paragraph), or
C-M-h (mark-defun) repeatedly, the marked region extends each time, so
you can mark the next two sexps with M-C-SPC M-C-SPC, for example.
This feature also works for mark-end-of-sentence, if you bind that to
a key.  It also extends the region when the mark is active in Transient
Mark mode, regardless of the last command.  To start a new region with
one of marking commands in Transient Mark mode, you can deactivate the
active region with C-g, or set the new mark with C-SPC.

+++
** Some commands do something special in Transient Mark mode when the
mark is active--for instance, they limit their operation to the
region.  Even if you don't normally use Transient Mark mode, you might
want to get this behavior from a particular command.  There are two
ways you can enable Transient Mark mode and activate the mark, for one
command only.

One method is to type C-SPC C-SPC; this enables Transient Mark mode
and sets the mark at point.  The other method is to type C-u C-x C-x.
This enables Transient Mark mode temporarily but does not alter the
mark or the region.

After these commands, Transient Mark mode remains enabled until you
deactivate the mark.  That typically happens when you type a command
that alters the buffer, but you can also deactivate the mark by typing
C-g.

+++
** A prefix argument is no longer required to repeat a jump to a
previous mark, i.e. C-u C-SPC C-SPC C-SPC ... cycles through the
mark ring.  Use C-u C-u C-SPC to set the mark immediately after a jump.

** Movement commands `beginning-of-buffer', `end-of-buffer',
`beginning-of-defun', `end-of-defun' do not set the mark if the mark
is already active in Transient Mark mode.

+++
** In the *Occur* buffer, `o' switches to it in another window, and
C-o displays the current line's occurrence in another window without
switching to it.

+++
** When you specify a frame size with --geometry, the size applies to
all frames you create.  A position specified with --geometry only
affects the initial frame.

+++
** M-h (mark-paragraph) now accepts a prefix arg.
With positive arg, M-h marks the current and the following paragraphs;
if the arg is negative, it marks the current and the preceding
paragraphs.

+++
** The variables dired-free-space-program and dired-free-space-args
have been renamed to directory-free-space-program and
directory-free-space-args, and they now apply whenever Emacs puts a
directory listing into a buffer.

---
** mouse-wheels can now scroll a specific fraction of the window
(rather than a fixed number of lines) and the scrolling is `progressive'.

** Unexpected yanking of text due to accidental clicking on the mouse
wheel button (typically mouse-2) during wheel scrolling is now avoided.
This behaviour can be customized via the mouse-wheel-click-event and
mouse-wheel-inhibit-click-time variables.

+++
** The keyboard-coding-system is now automatically set based on your
current locale settings if you are not using a window system.  This
may mean that the META key doesn't work but generates non-ASCII
characters instead, depending on how the terminal (or terminal
emulator) works.  Use `set-keyboard-coding-system' (or customize
keyboard-coding-system) if you prefer META to work (the old default)
or if the locale doesn't describe the character set actually generated
by the keyboard.  See Info node `Single-Byte Character Support'.

+++
** Emacs now reads the standard abbrevs file ~/.abbrev_defs
automatically at startup, if it exists.  When Emacs offers to save
modified buffers, it saves the abbrevs too if they have changed.  It
can do this either silently or asking for confirmation first,
according to the value of `save-abbrevs'.

+++
** Display of hollow cursors now obeys the buffer-local value (if any)
of `cursor-in-non-selected-windows' in the buffer that the cursor
appears in.

** The variable `cursor-in-non-selected-windows' can now be set to any
of the recognized cursor types.

---
** The variable `auto-save-file-name-transforms' now has a third element that
controls whether or not the function `make-auto-save-file-name' will
attempt to construct a unique auto-save name (e.g. for remote files).

+++
** There is a new calendar package, icalendar.el, that can be used to
convert Emacs diary entries to/from the iCalendar format.

+++
** Diary sexp entries can have custom marking in the calendar.
Diary sexp functions which only apply to certain days (such as
`diary-block' or `diary-cyclic') now take an optional parameter MARK,
which is the name of a face or a single-character string indicating
how to highlight the day in the calendar display.  Specifying a
single-character string as @var{mark} places the character next to the
day in the calendar.  Specifying a face highlights the day with that
face.  This lets you have different colors or markings for vacations,
appointments, paydays or anything else using a sexp.

+++
** The new function `calendar-goto-day-of-year' (g D) prompts for a
year and day number, and moves to that date. Negative day numbers
count backward from the end of the year.

+++
** The new Calendar function `calendar-goto-iso-week' (g w)
prompts for a year and a week number, and moves to the first
day of that ISO week.

---
** The functions `holiday-easter-etc' and `holiday-advent' now take
optional arguments, in order to only report on the specified holiday
rather than all. This makes customization of variables such as
`christian-holidays' simpler.

** The function `simple-diary-display' now by default sets a header line.
This can be controlled through the variables `diary-header-line-flag'
and `diary-header-line-format'.

+++
** The procedure for activating appointment reminders has changed: use
the new function `appt-activate'. The new variable
`appt-display-format' controls how reminders are displayed, replacing
appt-issue-message, appt-visible, and appt-msg-window.

** The new functions `diary-from-outlook', `diary-from-outlook-gnus',
and `diary-from-outlook-rmail' can be used to import diary entries
from Outlook-format appointments in mail messages.  The variable
`diary-outlook-formats' can be customized to recognize additional
formats.


** VC Changes

*** The key C-x C-q no longer checks files in or out, it only changes
the read-only state of the buffer (toggle-read-only).  We made this
change because we held a poll and found that many users were unhappy
with the previous behavior.  If you do prefer this behavior, you
can bind `vc-toggle-read-only' to C-x C-q in your .emacs:

    (global-set-key "\C-x\C-q" 'vc-toggle-read-only)

The function `vc-toggle-read-only' will continue to exist.

+++
*** There is a new user option `vc-cvs-global-switches' that allows
you to specify switches that are passed to any CVS command invoked
by VC.  These switches are used as "global options" for CVS, which
means they are inserted before the command name.  For example, this
allows you to specify a compression level using the "-z#" option for
CVS.

*** New backends for Subversion and Meta-CVS.

** EDiff changes.

+++
***  When comparing directories.
Typing D brings up a buffer that lists the differences between the contents of
directories. Now it is possible to use this buffer to copy the missing files
from one directory to another.

+++
*** When comparing files or buffers.
Typing the = key now offers to perform the word-by-word comparison of the
currently highlighted regions in an inferior Ediff session. If you answer 'n'
then it reverts to the old behavior and asks the user to select regions for
comparison.

*** The new command `ediff-backup' compares a file with its most recent
backup using `ediff'.  If you specify the name of a backup file,
`ediff-backup' compares it with the file of which it is a backup.

+++
** Etags changes.

*** New regular expressions features

**** New syntax for regular expressions, multi-line regular expressions.
The syntax --ignore-case-regexp=/regex/ is now undocumented and retained
only for backward compatibility.  The new equivalent syntax is
--regex=/regex/i.  More generally, it is --regex=/TAGREGEX/TAGNAME/MODS,
where `/TAGNAME' is optional, as usual, and MODS is a string of 0 or
more characters among `i' (ignore case), `m' (multi-line) and `s'
(single-line).  The `m' and `s' modifiers behave as in Perl regular
expressions: `m' allows regexps to match more than one line, while `s'
(which implies `m') means that `.' matches newlines.  The ability to
span newlines allows writing of much more powerful regular expressions
and rapid prototyping for tagging new languages.

**** Regular expressions can use char escape sequences as in Gcc.
The escaped character sequence \a, \b, \d, \e, \f, \n, \r, \t, \v,
respectively, stand for the ASCII characters BEL, BS, DEL, ESC, FF, NL,
CR, TAB, VT,

**** Regular expressions can be bound to a given language.
The syntax --regex={LANGUAGE}REGEX means that REGEX is used to make tags
only for files of language LANGUAGE, and ignored otherwise.  This is
particularly useful when storing regexps in a file.

**** Regular expressions can be read from a file.
The --regex=@regexfile option means read the regexps from a file, one
per line.  Lines beginning with space or tab are ignored.

*** New language parsing features

**** The `::' qualifier triggers C++ parsing in C file.
Previously, only the `template' and `class' keywords had this effect.

**** The gnucc __attribute__ keyword is now recognised and ignored.

**** New language HTML.
Title and h1, h2, h3 are tagged.  Also, tags are generated when name= is
used inside an anchor and whenever id= is used.

**** In Makefiles, constants are tagged.
If you want the old behavior instead, thus avoiding to increase the
size of the tags file, use the --no-globals option.

**** New language Lua.
All functions are tagged.

**** In Perl, packages are tags.
Subroutine tags are named from their package.  You can jump to sub tags
as you did before, by the sub name, or additionally by looking for
package::sub.

**** In Prolog, etags creates tags for rules in addition to predicates.

**** New language PHP.
Tags are functions, classes and defines.
If the --members option is specified to etags, tags are variables also.

**** New default keywords for TeX.
The new keywords are def, newcommand, renewcommand, newenvironment and
renewenvironment.

*** Honour #line directives.
When Etags parses an input file that contains C preprocessor's #line
directives, it creates tags using the file name and line number
specified in those directives.  This is useful when dealing with code
created from Cweb source files.  When Etags tags the generated file, it
writes tags pointing to the source file.

*** New option --parse-stdin=FILE.
This option is mostly useful when calling etags from programs.  It can
be used (only once) in place of a file name on the command line.  Etags
reads from standard input and marks the produced tags as belonging to
the file FILE.

+++
** CC Mode changes.

*** Font lock support.
CC Mode now provides font lock support for all its languages.  This
supersedes the font lock patterns that have been in the core font lock
package for C, C++, Java and Objective-C.  Like indentation, font
locking is done in a uniform way across all languages (except the new
AWK mode - see below).  That means that the new font locking will be
different from the old patterns in various details for most languages.

The main goal of the font locking in CC Mode is accuracy, to provide a
dependable aid in recognizing the various constructs.  Some, like
strings and comments, are easy to recognize while others like
declarations and types can be very tricky.  CC Mode can go to great
lengths to recognize declarations and casts correctly, especially when
the types aren't recognized by standard patterns.  This is a fairly
demanding analysis which can be slow on older hardware, and it can
therefore be disabled by choosing a lower decoration level with the
variable font-lock-maximum-decoration.

Note that the most demanding font lock level has been tuned with lazy
fontification in mind, i.e.  there should be a support mode that waits
with the fontification until the text is actually shown
(e.g. Just-in-time Lock mode, which is the default, or Lazy Lock
mode).  Fontifying a file with several thousand lines in one go can
take the better part of a minute.

**** The (c|c++|objc|java|idl|pike)-font-lock-extra-types variables
are now used by CC Mode to recognize identifiers that are certain to
be types.  (They are also used in cases that aren't related to font
locking.)  At the maximum decoration level, types are often recognized
properly anyway, so these variables should be fairly restrictive and
not contain patterns for uncertain types.

**** Support for documentation comments.
There is a "plugin" system to fontify documentation comments like
Javadoc and the markup within them.  It's independent of the host
language, so it's possible to e.g. turn on Javadoc font locking in C
buffers.  See the variable c-doc-comment-style for details.

Currently two kinds of doc comment styles are recognized: Suns Javadoc
and Autodoc which is used in Pike.  This is by no means a complete
list of the most common tools; if your doc comment extractor of choice
is missing then please drop a note to bug-cc-mode@gnu.org.

**** Better handling of C++ templates.
As a side effect of the more accurate font locking, C++ templates are
now handled much better.  The angle brackets that delimit them are
given parenthesis syntax so that they can be navigated like other
parens.

This also improves indentation of templates, although there still is
work to be done in that area.  E.g. it's required that multiline
template clauses are written in full and then refontified to be
recognized, and the indentation of nested templates is a bit odd and
not as configurable as it ought to be.

**** Improved handling of Objective-C and CORBA IDL.
Especially the support for Objective-C and IDL has gotten an overhaul.
The special "@" declarations in Objective-C are handled correctly.
All the keywords used in CORBA IDL, PSDL, and CIDL are recognized and
handled correctly, also wrt indentation.

*** Support for the AWK language.
Support for the AWK language has been introduced.  The implementation is
based around GNU AWK version 3.1, but it should work pretty well with
any AWK.  As yet, not all features of CC Mode have been adapted for AWK.
Here is a summary:

**** Indentation Engine
The CC Mode indentation engine fully supports AWK mode.

AWK mode handles code formatted in the conventional AWK fashion: `{'s
which start actions, user-defined functions, or compound statements are
placed on the same line as the associated construct; the matching `}'s
are normally placed under the start of the respective pattern, function
definition, or structured statement.

The predefined indentation functions haven't yet been adapted for AWK
mode, though some of them may work serendipitously.  There shouldn't be
any problems writing custom indentation functions for AWK mode.

The command C-c C-q (c-indent-defun) hasn't yet been adapted for AWK,
though in practice it works properly nearly all the time.  Should it
fail, explicitly set the region around the function (using C-u C-SPC:
C-M-h probably won't work either) then do C-M-\ (indent-region).

**** Font Locking
There is a single level of font locking in AWK mode, rather than the
three distinct levels the other modes have.  There are several
idiosyncrasies in AWK mode's font-locking due to the peculiarities of
the AWK language itself.

**** Comment Commands
M-; (indent-for-comment) works fine.  None of the other CC Mode
comment formatting commands have yet been adapted for AWK mode.

**** Movement Commands
Most of the movement commands work in AWK mode.  The most important
exceptions are M-a (c-beginning-of-statement) and M-e
(c-end-of-statement) which haven't yet been adapted.

The notion of "defun" has been augmented to include AWK pattern-action
pairs.  C-M-a (c-awk-beginning-of-defun) and C-M-e (c-awk-end-of-defun)
recognise these pattern-action pairs, as well as user defined
functions.

**** Auto-newline Insertion and Clean-ups
Auto-newline insertion hasn't yet been adapted for AWK.  Some of
the clean-ups can actually convert good AWK code into syntactically
invalid code.  These features are best disabled in AWK buffers.

*** New syntactic symbols in IDL mode.
The top level constructs "module" and "composition" (from CIDL) are
now handled like "namespace" in C++: They are given syntactic symbols
module-open, module-close, inmodule, composition-open,
composition-close, and incomposition.

*** New functions to do hungry delete without enabling hungry delete mode.
The functions c-hungry-backspace and c-hungry-delete-forward can be
bound to keys to get this feature without toggling a mode.
Contributed by Kevin Ryde.

*** Better control over require-final-newline.  The variable that
controls how to handle a final newline when the buffer is saved,
require-final-newline, is now customizable on a per-mode basis through
c-require-final-newline.  That is a list of modes, and only those
modes set require-final-newline.  By default that's C, C++ and
Objective-C.

The specified modes set require-final-newline based on
mode-require-final-newline, as usual.

*** Format change for syntactic context elements.
The elements in the syntactic context returned by c-guess-basic-syntax
and stored in c-syntactic-context has been changed somewhat to allow
attaching more information.  They are now lists instead of single cons
cells.  E.g. a line that previously had the syntactic analysis

((inclass . 11) (topmost-intro . 13))

is now analysed as

((inclass 11) (topmost-intro 13))

In some cases there are more than one position given for a syntactic
symbol.

This change might affect code that call c-guess-basic-syntax directly,
and custom lineup functions if they use c-syntactic-context.  However,
the argument given to lineup functions is still a single cons cell
with nil or an integer in the cdr.

*** API changes for derived modes.
There have been extensive changes "under the hood" which can affect
derived mode writers.  Some of these changes are likely to cause
incompatibilities with existing derived modes, but on the other hand
care has now been taken to make it possible to extend and modify CC
Mode with less risk of such problems in the future.

**** New language variable system.
See the comment blurb near the top of cc-langs.el.

**** New initialization functions.
The initialization procedure has been split up into more functions to
give better control: c-basic-common-init, c-font-lock-init, and
c-init-language-vars.

*** Changes in analysis of nested syntactic constructs.
The syntactic analysis engine has better handling of cases where
several syntactic constructs appear nested on the same line.  They are
now handled as if each construct started on a line of its own.

This means that CC Mode now indents some cases differently, and
although it's more consistent there might be cases where the old way
gave results that's more to one's liking.  So if you find a situation
where you think that the indentation has become worse, please report
it to bug-cc-mode@gnu.org.

**** New syntactic symbol substatement-label.
This symbol is used when a label is inserted between a statement and
its substatement.  E.g:

    if (x)
      x_is_true:
        do_stuff();

*** Better handling of multiline macros.

**** Syntactic indentation inside macros.
The contents of multiline #define's are now analyzed and indented
syntactically just like other code.  This can be disabled by the new
variable c-syntactic-indentation-in-macros.  A new syntactic symbol
cpp-define-intro has been added to control the initial indentation
inside #define's.

**** New lineup function c-lineup-cpp-define.
Now used by default to line up macro continuation lines.  The behavior
of this function closely mimics the indentation one gets if the macro
is indented while the line continuation backslashes are temporarily
removed.  If syntactic indentation in macros is turned off, it works
much line c-lineup-dont-change, which was used earlier, but handles
empty lines within the macro better.

**** Automatically inserted newlines continues the macro if used within one.
This applies to the newlines inserted by the auto-newline mode, and to
c-context-line-break and c-context-open-line.

**** Better alignment of line continuation backslashes.
c-backslash-region tries to adapt to surrounding backslashes.  New
variable c-backslash-max-column which put a limit on how far out
backslashes can be moved.

**** Automatic alignment of line continuation backslashes.
This is controlled by the new variable c-auto-align-backslashes.  It
affects c-context-line-break, c-context-open-line and newlines
inserted in auto-newline mode.

**** Line indentation works better inside macros.
Regardless whether syntactic indentation and syntactic indentation
inside macros are enabled or not, line indentation now ignores the
line continuation backslashes.  This is most noticeable when syntactic
indentation is turned off and there are empty lines (save for the
backslash) in the macro.

*** indent-for-comment is more customizable.
The behavior of M-; (indent-for-comment) is now configurable through
the variable c-indent-comment-alist.  The indentation behavior based
on the preceding code on the line, e.g. to get two spaces after #else
and #endif but indentation to comment-column in most other cases
(something which was hardcoded earlier).

*** New function c-context-open-line.
It's the open-line equivalent of c-context-line-break.

*** New lineup functions

**** c-lineup-string-cont
This lineup function lines up a continued string under the one it
continues.  E.g:

result = prefix + "A message "
                  "string.";      <- c-lineup-string-cont

**** c-lineup-cascaded-calls
Lines up series of calls separated by "->" or ".".

**** c-lineup-knr-region-comment
Gives (what most people think is) better indentation of comments in
the "K&R region" between the function header and its body.

**** c-lineup-gcc-asm-reg
Provides better indentation inside asm blocks.  Contributed by Kevin
Ryde.

**** c-lineup-argcont
Lines up continued function arguments after the preceding comma.
Contributed by Kevin Ryde.

*** Better caching of the syntactic context.
CC Mode caches the positions of the opening parentheses (of any kind)
of the lists surrounding the point.  Those positions are used in many
places as anchor points for various searches.  The cache is now
improved so that it can be reused to a large extent when the point is
moved.  The less it moves, the less needs to be recalculated.

The effect is that CC Mode should be fast most of the time even when
opening parens are hung (i.e. aren't in column zero).  It's typically
only the first time after the point is moved far down in a complex
file that it'll take noticeable time to find out the syntactic
context.

*** Statements are recognized in a more robust way.
Statements are recognized most of the time even when they occur in an
"invalid" context, e.g. in a function argument.  In practice that can
happen when macros are involved.

*** Improved the way c-indent-exp chooses the block to indent.
It now indents the block for the closest sexp following the point
whose closing paren ends on a different line.  This means that the
point doesn't have to be immediately before the block to indent.
Also, only the block and the closing line is indented; the current
line is left untouched.

*** Added toggle for syntactic indentation.
The function c-toggle-syntactic-indentation can be used to toggle
syntactic indentation.

** The command line option --no-windows has been changed to
--no-window-system.  The old one still works, but is deprecated.

+++
** The command `list-text-properties-at' has been deleted because
C-u C-x = gives the same information and more.

+++
** `buffer-menu' and `list-buffers' now list buffers whose names begin
with a space, when those buffers are visiting files.  Normally buffers
whose names begin with space are omitted.

+++
** You can now customize fill-nobreak-predicate to control where
filling can break lines.  We provide two sample predicates,
fill-single-word-nobreak-p and fill-french-nobreak-p.

+++
** New user option `add-log-always-start-new-record'.
When this option is enabled, M-x add-change-log-entry always
starts a new record regardless of when the last record is.

+++
** SGML mode has indentation and supports XML syntax.
The new variable `sgml-xml-mode' tells SGML mode to use XML syntax.
When this option is enabled, SGML tags are inserted in XML style,
i.e., there is always a closing tag.
By default, its setting is inferred on a buffer-by-buffer basis
from the file name or buffer contents.

+++
** `xml-mode' is now an alias for `sgml-mode', which has XML support.

---
** Lisp mode now uses font-lock-doc-face for the docstrings.

---
** Perl mode has a new variable `perl-indent-continued-arguments'.

+++
** Fortran mode has a new variable `fortran-directive-re'.
Adapt this to match the format of any compiler directives you use.
Lines that match are never indented, and are given distinctive font-locking.

---
** F90 mode has new navigation commands `f90-end-of-block',
`f90-beginning-of-block', `f90-next-block', `f90-previous-block'.

** F90 mode now has support for hs-minor-mode (hideshow).
It cannot deal with every code format, but ought to handle a sizeable
majority.

---
** The new function `f90-backslash-not-special' can be used to change
the syntax of backslashes in F90 buffers.

---
** Prolog mode has a new variable `prolog-font-lock-keywords'
to support use of font-lock.

+++
** `special-display-buffer-names' and `special-display-regexps' now
understand two new boolean pseudo-frame-parameters `same-frame' and
`same-window'.

+++
** M-x setenv now expands environment variables of the form `$foo' and
`${foo}' in the specified new value of the environment variable.  To
include a `$' in the value, use `$$'.

+++
** File-name completion can now ignore directories.
If an element of the list in `completion-ignored-extensions' ends in a
slash `/', it indicates a subdirectory that should be ignored when
completing file names.  Elements of `completion-ignored-extensions'
which do not end in a slash are never considered when a completion
candidate is a directory.

+++
** The completion commands TAB, SPC and ? in the minibuffer apply only
to the text before point.  If there is text in the buffer after point,
it remains unchanged.

** Enhanced visual feedback in *Completions* buffer.

Completions lists use faces to highlight what all completions
have in common and where they begin to differ.

The common prefix shared by all possible completions uses the face
`completions-common-part', while the first character that isn't the
same uses the face `completions-first-difference'.  By default,
`completions-common-part' inherits from `default', and
`completions-first-difference' inherits from `bold'.  The idea of
`completions-common-part' is that you can use it to make the common
parts less visible than normal, so that the rest of the differing
parts is, by contrast, slightly highlighted.

+++
** New user option `inhibit-startup-buffer-menu'.
When loading many files, for instance with `emacs *', Emacs normally
displays a buffer menu.  This option turns the buffer menu off.

---
** Rmail now displays 5-digit message ids in its summary buffer.

---
** On MS Windows, the "system caret" now follows the cursor.
This enables Emacs to work better with programs that need to track
the cursor, for example screen magnifiers and text to speech programs.

---
** Tooltips now work on MS Windows.
See the Emacs 21.1 NEWS entry for tooltips for details.

---
** Images are now supported on MS Windows.
PBM and XBM images are supported out of the box. Other image formats
depend on external libraries.  All of these libraries have been ported
to Windows, and can be found in both source and binary form at
http://gnuwin32.sourceforge.net/.  Note that libpng also depends on
zlib, and tiff depends on the version of jpeg that it was compiled
against.  For additional information, see nt/INSTALL.

---
** Sound is now supported on MS Windows.
WAV format is supported on all versions of Windows, other formats such
as AU, AIFF and MP3 may be supported in the more recent versions of
Windows, or when other software provides hooks into the system level
sound support for those formats.

---
** Different shaped mouse pointers are supported on MS Windows.
The mouse pointer changes shape depending on what is under the pointer.

---
** Pointing devices with more than 3 buttons are now supported on MS Windows.
The new variable `w32-pass-extra-mouse-buttons-to-system' controls
whether Emacs should handle the extra buttons itself (the default), or
pass them to Windows to be handled with system-wide functions.

---
** Emacs takes note of colors defined in Control Panel on MS-Windows.
The Control Panel defines some default colors for applications in much
the same way as wildcard X Resources do on X.  Emacs now adds these
colors to the colormap prefixed by System (eg SystemMenu for the
default Menu background, SystemMenuText for the foreground), and uses
some of them to initialize some of the default faces.
`list-colors-display' shows the list of System color names, in case
you wish to use them in other faces.

+++
** Under X11, it is possible to swap Alt and Meta (and Super and Hyper).
The new variables `x-alt-keysym', `x-hyper-keysym', `x-meta-keysym',
and `x-super-keysym' can be used to choose which keysyms Emacs should
use for the modifiers.  For example, the following two lines swap
Meta and Alt:
    (setq x-alt-keysym 'meta)
    (setq x-meta-keysym 'alt)

+++
** vc-annotate-mode enhancements

In vc-annotate mode, you can now use the following key bindings for
enhanced functionality to browse the annotations of past revisions, or
to view diffs or log entries directly from vc-annotate-mode:

    P:  annotates the previous revision
    N:  annotates the next revision
    J:  annotates the revision at line
    A:  annotates the revision previous to line
    D:  shows the diff of the revision at line with its previous revision
    L:  shows the log of the revision at line
    W:  annotates the workfile (most up to date) version

+++
** In pcl-cvs mode, there is a new `d y' command to view the diffs
between the local version of the file and yesterday's head revision
in the repository.

+++
** In pcl-cvs mode, there is a new `d r' command to view the changes
anyone has committed to the repository since you last executed
"checkout", "update" or "commit".  That means using cvs diff options
-rBASE -rHEAD.

** New variable `hs-set-up-overlay' allows customization of the overlay
used to effect hiding for hideshow minor mode.  Integration with isearch
handles the overlay property `display' specially, preserving it during
temporary overlay showing in the course of an isearch operation.

** New command `recode-region' decodes the region again by a specified
coding system.


* New modes and packages in Emacs 21.4

** The new package conf-mode.el handles thousands of configuration files, with
varying syntaxes for comments (;, #, //, /* */ or !), assignment (var = value,
var : value, var value or keyword var value) and sections ([section] or
section { }).  Many files under /etc/, or with suffixes like .cf through
.config, .properties (Java), .desktop (KDE/Gnome), .ini and many others are
recognized.

** The new package password.el provide a password cache and expiring mechanism.

** The new package dns-mode.el add syntax highlight of DNS master files.
The key binding C-c C-s (`dns-mode-soa-increment-serial') can be used
to increment the SOA serial.

** The new package flymake.el does on-the-fly syntax checking of program
source files.  See the Flymake's Info manual for more details.

** The library tree-widget.el provides a new widget to display a set
of hierarchical data as an outline.  For example, the tree-widget is
well suited to display a hierarchy of directories and files.

** The wdired.el package allows you to use normal editing commands on Dired
buffers to change filenames, permissions, etc...

** The thumbs.el package allows you to preview image files as thumbnails
and can be invoked from a Dired buffer.

** The new python.el package is used to edit Python and Jython programs.

** The URL package (which had been part of W3) is now part of Emacs.

+++
** The new global minor mode `size-indication-mode' (off by default)
shows the size of accessible part of the buffer on the mode line.

** GDB-Script-mode is used for files like .gdbinit.

---
** Ido mode is now part of the Emacs distribution.

The ido (interactively do) package is an extension of the iswitchb
package to do interactive opening of files and directories in addition
to interactive buffer switching.  Ido is a superset of iswitchb (with
a few exceptions), so don't enable both packages.

---
** CUA mode is now part of the Emacs distribution.

The new cua package provides CUA-like keybindings using C-x for
cut (kill), C-c for copy, C-v for paste (yank), and C-z for undo.
With cua, the region can be set and extended using shifted movement
keys (like pc-selection-mode) and typed text replaces the active
region (like delete-selection-mode).  Do not enable these modes with
cua-mode.  Customize the variable `cua-mode' to enable cua.

In addition, cua provides unified rectangle support with visible
rectangle highlighting: Use S-return to start a rectangle, extend it
using the movement commands (or mouse-3), and cut or copy it using C-x
or C-c (using C-w and M-w also works).

Use M-o and M-c to `open' or `close' the rectangle, use M-b or M-f, to
fill it with blanks or another character, use M-u or M-l to upcase or
downcase the rectangle, use M-i to increment the numbers in the
rectangle, use M-n to fill the rectangle with a numeric sequence (such
as 10 20 30...), use M-r to replace a regexp in the rectangle, and use
M-' or M-/ to restrict command on the rectangle to a subset of the
rows.  See the commentary in cua-base.el for more rectangle commands.

Cua also provides unified support for registers:  Use a numeric
prefix argument between 0 and 9, i.e. M-0 .. M-9, for C-x, C-c, and
C-v to cut or copy into register 0-9, or paste from register 0-9.

The last text deleted (not killed) is automatically stored in
register 0.  This includes text deleted by typing text.

Finally, cua provides a global mark which is set using S-C-space.
When the global mark is active, any text which is cut or copied is
automatically inserted at the global mark position.  See the
commentary in cua-base.el for more global mark related commands.

The features of cua also works with the standard emacs bindings for
kill, copy, yank, and undo.  If you want to use cua mode, but don't
want the C-x, C-c, C-v, and C-z bindings, you may customize the
`cua-enable-cua-keys' variable.

Note: This version of cua mode is not backwards compatible with older
versions of cua.el and cua-mode.el.  To ensure proper operation, you
must remove older versions of cua.el or cua-mode.el as well as the
loading and customization of those packages from the .emacs file.

** The new keypad setup package provides several common bindings for
the numeric keypad which is available on most keyboards.  The numeric
keypad typically has the digits 0 to 9, a decimal point, keys marked
+, -, /, and *, an Enter key, and a NumLock toggle key.  The keypad
package only controls the use of the digit and decimal keys.

By customizing the variables `keypad-setup', `keypad-shifted-setup',
`keypad-numlock-setup', and `keypad-numlock-shifted-setup', or by
using the function `keypad-setup', you can rebind all digit keys and
the decimal key of the keypad in one step for each of the four
possible combinations of the Shift key state (not pressed/pressed) and
the NumLock toggle state (off/on).

The choices for the keypad keys in each of the above states are:
`Plain numeric keypad' where the keys generates plain digits,
`Numeric keypad with decimal key' where the character produced by the
decimal key can be customized individually (for internationalization),
`Numeric Prefix Arg' where the keypad keys produce numeric prefix args
for emacs editing commands, `Cursor keys' and `Shifted Cursor keys'
where the keys work like (shifted) arrow keys, home/end, etc., and
`Unspecified/User-defined' where the keypad keys (kp-0, kp-1, etc.)
are left unspecified and can be bound individually through the global
or local keymaps.

+++
** The new kmacro package provides a simpler user interface to
emacs' keyboard macro facilities.

Basically, it uses two function keys (default F3 and F4) like this:
F3 starts a macro, F4 ends the macro, and pressing F4 again executes
the last macro.  While defining the macro, F3 inserts a counter value
which automatically increments every time the macro is executed.

There is now a keyboard macro ring which stores the most recently
defined macros.

The C-x C-k sequence is now a prefix for the kmacro keymap which
defines bindings for moving through the keyboard macro ring,
C-x C-k C-p and C-x C-k C-n, editing the last macro C-x C-k C-e,
manipulating the macro counter and format via C-x C-k C-c,
C-x C-k C-a, and C-x C-k C-f.  See the commentary in kmacro.el
for more commands.

The normal macro bindings C-x (, C-x ), and C-x e now interfaces to
the keyboard macro ring.

The C-x e command now automatically terminates the current macro
before calling it, if used while defining a macro.

In addition, when ending or calling a macro with C-x e, the macro can
be repeated immediately by typing just the `e'.  You can customize
this behaviour via the variable kmacro-call-repeat-key and
kmacro-call-repeat-with-arg.

Keyboard macros can now be debugged and edited interactively.
C-x C-k SPC steps through the last keyboard macro one key sequence
at a time, prompting for the actions to take.

---
** The old Octave mode bindings C-c f and C-c i have been changed
to C-c C-f and C-c C-i.  The C-c C-i subcommands now have duplicate
bindings on control characters--thus, C-c C-i C-b is the same as
C-c C-i b, and so on.

** The printing package is now part of the Emacs distribution.

If you enable the printing package by including (require 'printing) in
the .emacs file, the normal Print item on the File menu is replaced
with a Print sub-menu which allows you to preview output through
ghostview, use ghostscript to print (if you don't have a PostScript
printer) or send directly to printer a PostScript code generated by
`ps-print' package.  Use M-x pr-help for more information.

+++
** Calc is now part of the Emacs distribution.

Calc is an advanced desk calculator and mathematical tool written in
Emacs Lisp.  Its documentation is in a separate manual; within Emacs,
type "C-h i m calc RET" to read that manual.  A reference card is
available in `etc/calccard.tex' and `etc/calccard.ps'.

+++
** Tramp is now part of the distribution.

This package is similar to Ange-FTP: it allows you to edit remote
files.  But whereas Ange-FTP uses FTP to access the remote host,
Tramp uses a shell connection.  The shell connection is always used
for filename completion and directory listings and suchlike, but for
the actual file transfer, you can choose between the so-called
`inline' methods (which transfer the files through the shell
connection using base64 or uu encoding) and the `out-of-band' methods
(which invoke an external copying program such as `rcp' or `scp' or
`rsync' to do the copying).

Shell connections can be acquired via `rsh', `ssh', `telnet' and also
`su' and `sudo'.

---
** The new global minor mode `file-name-shadow-mode' modifies the way
filenames being entered by the user in the minibuffer are displayed, so
that it's clear when part of the entered filename will be ignored due to
emacs' filename parsing rules.  The ignored portion can be made dim,
invisible, or otherwise less visually noticable.  The display method may
be displayed by customizing the variable `file-name-shadow-properties'.

---
** The ruler-mode.el library provides a minor mode for displaying an
"active" ruler in the header line.  You can use the mouse to visually
change the `fill-column', `window-margins' and `tab-stop-list'
settings.

---
** The minor mode Reveal mode makes text visible on the fly as you
move your cursor into hidden regions of the buffer.
It should work with any package that uses overlays to hide parts
of a buffer, such as outline-minor-mode, hs-minor-mode, hide-ifdef-mode, ...

There is also Global Reveal mode which affects all buffers.

---
** The new package ibuffer provides a powerful, completely
customizable replacement for buff-menu.el.

** The new package table.el implements editable, WYSIWYG, embedded
`text tables' in Emacs buffers.  It simulates the effect of putting
these tables in a special major mode.  The package emulates WYSIWYG
table editing available in modern word processors.  The package also
can generate a table source in typesetting and markup languages such
as latex and html from the visually laid out text table.

+++
** SES mode (ses-mode) is a new major mode for creating and editing
spreadsheet files.  Besides the usual Emacs features (intuitive command
letters, undo, cell formulas in Lisp, plaintext files, etc.) it also offers
viral immunity and import/export of tab-separated values.

---
** Support for `magic cookie' standout modes has been removed.
Emacs will still work on terminals that require magic cookies in order
to use standout mode, however they will not be able to display
mode-lines in inverse-video.

---
** cplus-md.el has been removed to avoid problems with Custom.

** New package benchmark.el contains simple support for convenient
timing measurements of code (including the garbage collection component).

** The new Lisp library fringe.el controls the appearance of fringes.

** `cfengine-mode' is a major mode for editing GNU Cfengine
configuration files.

* Incompatible Lisp Changes in Emacs 21.4

+++
** Mode line display ignores text properties as well as the
:propertize and :eval forms in the value of a variable whose
`risky-local-variable' property is nil.

* Lisp Changes in Emacs 21.4

+++
** If a buffer sets buffer-save-without-query to non-nil,
save-some-buffers will always save that buffer without asking
(if it's modified).

+++
** The function symbol-file tells you which file defined
a certain function or variable.

** Lisp code can now test if a given buffer position is inside a
clickable link with the new function `mouse-on-link-p'.  This is the
function used by the new `mouse-1-click-follows-link' functionality.

+++
** (while-no-input BODY...) runs BODY, but only so long as no input
arrives.  If the user types or clicks anything, BODY stops as if a
quit had occurred.  while-no-input returns the value of BODY, if BODY
finishes.  It returns nil if BODY was aborted.

+++
** `set-auto-mode' now gives the interpreter magic line (if present)
precedence over the file name.  Likewise an <?xml or <!DOCTYPE declaration
will give the buffer XML or SGML mode, based on the new var
`magic-mode-alist'.

+++
** New function `looking-back' checks whether a regular expression matches
the text before point.  Specifying the LIMIT argument bounds how far
back the match can start; this is a way to keep it from taking too long.

+++
** New functions `make-progress-reporter', `progress-reporter-update',
`progress-reporter-force-update' and `progress-reporter-done' provide
a simple and efficient way for a command to present progress messages
for the user.

---
** To manipulate the File menu using easy-menu, you must specify the
proper name "file".  In previous Emacs versions, you had to specify
"files", even though the menu item itself was changed to say "File"
several versions ago.

+++
** read-from-minibuffer now accepts an additional argument KEEP-ALL
saying to put all inputs in the history list, even empty ones.

+++
** The new variable search-spaces-regexp controls how to search
for spaces in a regular expression.  If it is non-nil, it should be a
regular expression, and any series of spaces stands for that regular
expression.  If it is nil, spaces stand for themselves.

Spaces inside of constructs such as [..] and *, +, ? are never
replaced with search-spaces-regexp.

---
** list-buffers-noselect now takes an additional argument, BUFFER-LIST.
If it is non-nil, it specifies which buffers to list.

---
** set-buffer-file-coding-system now takes an additional argument,
NOMODIFY.  If it is non-nil, it means don't mark the buffer modified.

+++
** The new function syntax-after returns the syntax code
of the character after a specified buffer position, taking account
of text properties as well as the character code.

+++
** The new primitive `get-internal-run-time' returns the processor
run time used by Emacs since start-up.

+++
** The new function `called-interactively-p' does what many people
have mistakenly believed `interactive-p' did: it returns t if the
calling function was called through `call-interactively'.  This should
only be used when you cannot add a new "interactive" argument to the
command.

+++
** The new function `assoc-string' replaces `assoc-ignore-case' and
`assoc-ignore-representation', which are still available, but have
been declared obsolete.

+++
** An interactive specification may now use the code letter 'U' to get
the up-event that was discarded in case the last key sequence read for a
previous 'k' or 'K' argument was a down-event; otherwise nil is used.

** Function `translate-region' accepts also a char-table as TABLE
argument.

+++
** Major mode functions now run the new normal hook
`after-change-major-mode-hook', at their very end, after the mode hooks.

+++
** `auto-save-file-format' has been renamed to
`buffer-auto-save-file-format' and made into a permanent local.

+++
** Both the variable and the function `disabled-command-hook' have
been renamed to `disabled-command-function'.  The variable
`disabled-command-hook' has been kept as an obsolete alias.

** Function `compute-motion' now calculates the usable window
width if the WIDTH argument is nil.  If the TOPOS argument is nil,
the usable window height and width is used.

+++
** `visited-file-modtime' and `calendar-time-from-absolute' now return
a list of two integers, instead of a cons.

** If a command sets transient-mark-mode to `only', that
enables Transient Mark mode for the following command only.
During that following command, the value of transient-mark-mode
is `identity'.  If it is still `identity' at the end of the command,
it changes to nil.

+++
** Cleaner way to enter key sequences.

You can enter a constant key sequence in a more natural format, the
same one used for saving keyboard macros, using the macro `kbd'.  For
example,

(kbd "C-x C-f") => "\^x\^f"

** The sentinel is now called when a network process is deleted with
delete-process.  The status message passed to the sentinel for a
deleted network process is "deleted".  The message passed to the
sentinel when the connection is closed by the remote peer has been
changed to "connection broken by remote peer".

** If the buffer's undo list for the current command gets longer than
undo-outer-limit, garbage collection empties it.  This is to prevent
it from using up the available memory and choking Emacs.

---
** New function quail-find-key returns a list of keys to type in the
current input method to input a character.

+++
** New functions posn-at-point and posn-at-x-y return
click-event-style position information for a given visible buffer
position or for a given window pixel coordinate.

** skip-chars-forward and skip-chars-backward now handle
character classes such as [:alpha:], along with individual characters
and ranges.

** Function pos-visible-in-window-p now returns the pixel coordinates
and partial visiblity state of the corresponding row, if the PARTIALLY
arg is non-nil.

** The function `eql' is now available without requiring the CL package.

+++
** The new primitive `set-file-times' sets a file's access and
modification times.  Magic file name handlers can handle this
operation.

+++
** The display space :width and :align-to text properties are now
supported on text terminals.

+++
** Support for displaying image slices

*** New display property (slice X Y WIDTH HEIGHT) may be used with
an image property to display only a specific slice of the image.

*** Function insert-image has new optional fourth arg to
specify image slice (X Y WIDTH HEIGHT).

*** New function insert-sliced-image inserts a given image as a
specified number of evenly sized slices (rows x columns).

+++
** New line-height and line-spacing properties for newline characters

A newline may now have line-height and line-spacing text or overlay
properties that control the height of the corresponding display row.

If the line-height property value is t, the newline does not
contribute to the height of the display row; instead the height of the
newline glyph is reduced.  Also, a line-spacing property on this
newline is ignored.  This can be used to tile small images or image
slices without adding blank areas between the images.

If the line-height property value is a positive integer, the value
specifies the minimum line height in pixels.  If necessary, the line
height it increased by increasing the line's ascent.

If the line-height property value is a float, the minimum line height
is calculated by multiplying the default frame line height by the
given value.

If the line-height property value is a cons (FACE . RATIO), the
minimum line height is calculated as RATIO * height of named FACE.
RATIO is int or float.  If FACE is t, it specifies the current face.

If the line-height property value is a cons (nil . RATIO), the line
height is calculated as RATIO * actual height of the line's contents.

If the line-height value is a cons (HEIGHT . TOTAL), HEIGHT specifies
the line height as described above, while TOTAL is any of the forms
described above and specifies the total height of the line, causing a
varying number of pixels to be inserted after the line to make it line
exactly that many pixels high.

If the line-spacing property value is an positive integer, the value
is used as additional pixels to insert after the display line; this
overrides the default frame line-spacing and any buffer local value of
the line-spacing variable.

If the line-spacing property may be a float or cons, the line spacing
is calculated as specified above for the line-height property.

** The buffer local line-spacing variable may now have a float value,
which is used as a height relative to the default frame line height.

+++
** Enhancements to stretch display properties

The display property stretch specification form `(space PROPS)', where
PROPS is a property list now allows pixel based width and height
specifications, as well as enhanced horizontal text alignment.

The value of these properties can now be a (primitive) expression
which is evaluated during redisplay.  The following expressions
are supported:

EXPR ::= NUM | (NUM) | UNIT | ELEM | POS | IMAGE | FORM
NUM  ::= INTEGER | FLOAT | SYMBOL
UNIT ::= in | mm | cm | width | height
ELEM ::= left-fringe | right-fringe | left-margin | right-margin
      |  scroll-bar | text
POS  ::= left | center | right
FORM ::= (NUM . EXPR) | (OP EXPR ...)
OP   ::= + | -

The form `NUM' specifies a fractional width or height of the default
frame font size.  The form `(NUM)' specifies an absolute number of
pixels.  If a symbol is specified, its buffer-local variable binding
is used.  The `in', `mm', and `cm' units specifies the number of
pixels per inch, milli-meter, and centi-meter, resp.  The `width' and
`height' units correspond to the width and height of the current face
font.  An image specification corresponds to the width or height of
the image.

The `left-fringe', `right-fringe', `left-margin', `right-margin',
`scroll-bar', and `text' elements specify to the width of the
corresponding area of the window.

The `left', `center', and `right' positions can be used with :align-to
to specify a position relative to the left edge, center, or right edge
of the text area.  One of the above window elements (except `text')
can also be used with :align-to to specify that the position is
relative to the left edge of the given area.  Once the base offset for
a relative position has been set (by the first occurrence of one of
these symbols), further occurences of these symbols are interpreted as
the width of the area.

For example, to align to the center of the left-margin, use
    :align-to (+ left-margin (0.5 . left-margin))

If no specific base offset is set for alignment, it is always relative
to the left edge of the text area.  For example, :align-to 0 in a
header-line aligns with the first text column in the text area.

The value of the form `(NUM . EXPR)' is the value of NUM multiplied by
the value of the expression EXPR.  For example, (2 . in) specifies a
width of 2 inches, while (0.5 . IMAGE) specifies half the width (or
height) of the specified image.

The form `(+ EXPR ...)' adds up the value of the expressions.
The form `(- EXPR ...)' negates or subtracts the value of the expressions.

+++
** Normally, the cursor is displayed at the end of any overlay and
text property string that may be present at the current window
position.  The cursor may now be placed on any character of such
strings by giving that character a non-nil `cursor' text property.

** New macro with-local-quit temporarily sets inhibit-quit to nil for use
around potentially blocking or long-running code in timers
and post-command-hooks.

** The first face specification element in a defface can specify
`default' instead of frame classification.  Then its attributes act as
defaults that apply to all the subsequent cases (and may be overridden
by them).

+++
** New face attribute `min-colors' can be used to tailor the face color
to the number of colors supported by a display, and define the
foreground and background colors accordingly so that they look best on
a terminal that supports at least this many colors.  This is now the
preferred method for defining default faces in a way that makes a good
use of the capabilities of the display.

+++
** Customizable fringe bitmaps

*** New function 'define-fringe-bitmap' can now be used to create new
fringe bitmaps, as well as change the built-in fringe bitmaps.

To change a built-in bitmap, do (require 'fringe) and use the symbol
identifing the bitmap such as `left-truncation or `continued-line'.

*** New function 'destroy-fringe-bitmap' may be used to destroy a
previously created bitmap, or restore a built-in bitmap.

*** New function 'set-fringe-bitmap-face' can now be used to set a
specific face to be used for a specific fringe bitmap.  Normally,
this should be a face derived from the `fringe' face, specifying
the foreground color as the desired color of the bitmap.

*** There are new display properties, left-fringe and right-fringe,
that can be used to show a specific bitmap in the left or right fringe
bitmap of the display line.

Format is 'display '(left-fringe BITMAP [FACE]), where BITMAP is a
symbol identifying a fringe bitmap, either built-in or defined with
`define-fringe-bitmap', and FACE is an optional face name to be used
for displaying the bitmap.

*** New function `fringe-bitmaps-at-pos' returns the current fringe
bitmaps in the display line at a given buffer position.

** Multiple overlay arrows can now be defined and managed via the new
variable `overlay-arrow-variable-list'.  It contains a list of
varibles which contain overlay arrow position markers, including
the original `overlay-arrow-position' variable.

Each variable on this list may have individual `overlay-arrow-string'
and `overlay-arrow-bitmap' properties that specify an overlay arrow
string (for non-window terminals) or fringe bitmap (for window
systems) to display at the corresponding overlay arrow position.
If either property is not set, the default `overlay-arrow-string' or
'overlay-arrow-fringe-bitmap' will be used.

+++
** New function `line-number-at-pos' returns line number of current
line in current buffer, or if optional buffer position is given, line
number of corresponding line in current buffer.

+++
** The default value of `sentence-end' is now defined using the new
variable `sentence-end-without-space' which contains such characters
that end a sentence without following spaces.

+++
** The function `sentence-end' should be used to obtain the value of
the variable `sentence-end'.  If the variable `sentence-end' is nil,
then this function returns the regexp constructed from the variables
`sentence-end-without-period', `sentence-end-double-space' and
`sentence-end-without-space'.

+++
** The flags, width, and precision options for %-specifications in function
`format' are now documented.  Some flags that were accepted but not
implemented (such as "*") are no longer accepted.

** New function `macroexpand-all' expands all macros in a form.
It is similar to the Common-Lisp function of the same name.
One difference is that it guarantees to return the original argument
if no expansion is done, which may be tested using `eq'.

+++
** New function `delete-dups' destructively removes `equal' duplicates
from a list.  Of several `equal' occurrences of an element in the list,
the first one is kept.

+++
** `declare' is now a macro.  This change was made mostly for
documentation purposes and should have no real effect on Lisp code.

** The new hook `before-save-hook' is invoked by `basic-save-buffer'
before saving buffers.  This allows packages to perform various final
tasks, for example; it can be used by the copyright package to make
sure saved files have the current year in any copyright headers.

+++
** The function `insert-for-yank' now supports strings where the
`yank-handler' property does not span the first character of the
string.  The old behavior is available if you call
`insert-for-yank-1' instead.

** New function `get-char-property-and-overlay' accepts the same
arguments as `get-char-property' and returns a cons whose car is the
return value of `get-char-property' called with those arguments and
whose cdr is the overlay in which the property was found, or nil if
it was found as a text property or not found at all.

+++ (lispref)
??? (man)
** The mouse pointer shape in void text areas (i.e. after the end of a
line or below the last line in the buffer) of the text window is now
controlled by the new variable `void-text-area-pointer'.  The default
is to use the `arrow' (non-text) pointer.  Other choices are `text'
(or nil), `hand', `vdrag', `hdrag', `modeline', and `hourglass'.

+++
** The mouse pointer shape over an image can now be controlled by the
:pointer image property.

+++
** The mouse pointer shape over ordinary text or images may now be
controlled/overriden via the `pointer' text property.

+++
** Images may now have an associated image map via the :map property.

An image map is an alist where each element has the format (AREA ID PLIST).
An AREA is specified as either a rectangle, a circle, or a polygon:
A rectangle is a cons (rect . ((x0 . y0) . (x1 . y1))) specifying the
pixel coordinates of the upper left and bottom right corners.
A circle is a cons (circle . ((x0 . y0) . r)) specifying the center
and the radius of the circle; r may be a float or integer.
A polygon is a cons (poly . [x0 y0 x1 y1 ...]) where each pair in the
vector describes one corner in the polygon.

When the mouse pointer is above a hot-spot area of an image, the
PLIST of that hot-spot is consulted; if it contains a `help-echo'
property it defines a tool-tip for the hot-spot, and if it contains
a `pointer' property, it defines the shape of the mouse cursor when
it is over the hot-spot.  See the variable 'void-area-text-pointer'
for possible pointer shapes.

When you click the mouse when the mouse pointer is over a hot-spot,
an event is composed by combining the ID of the hot-spot with the
mouse event, e.g. [area4 mouse-1] if the hot-spot's ID is `area4'.

** Mouse event enhancements:

*** Mouse clicks on fringes now generates left-fringe or right-fringes
events, rather than a text area click event.

*** Mouse clicks in the left and right marginal areas now includes a
sensible buffer position corresponding to the first character in the
corresponding text row.

*** Function `mouse-set-point' now works for events outside text area.

+++
*** Mouse events now includes buffer position for all event types.

+++
*** `posn-point' now returns buffer position for non-text area events.

+++
*** New function `posn-area' returns window area clicked on (nil means
text area).

+++
*** Mouse events include actual glyph column and row for all event types.

+++
*** New function `posn-actual-col-row' returns actual glyph coordinates.

+++
*** Mouse events may now include image object in addition to string object.

+++
*** Mouse events include relative x and y pixel coordinates relative to
the top left corner of the object (image or character) clicked on.

+++
*** Mouse events include the pixel width and height of the object
(image or character) clicked on.

+++
*** New functions 'posn-object', 'posn-object-x-y', and
'posn-object-width-height' return the image or string object of a mouse
click, the x and y pixel coordinates relative to the top left corner
of that object, and the total width and height of that object.

** New function `force-window-update' can initiate a full redisplay of
one or all windows.  Normally, this is not needed as changes in window
contents are detected automatically.  However, certain implicit
changes to mode lines, header lines, or display properties may require
forcing an explicit window update.

** New function `redirect-debugging-output' can be used to redirect
debugging output on the stderr file handle to a file.

+++
** `split-string' now includes null substrings in the returned list if
the optional argument SEPARATORS is non-nil and there are matches for
SEPARATORS at the beginning or end of the string.  If SEPARATORS is
nil, or if the new optional third argument OMIT-NULLS is non-nil, all
empty matches are omitted from the returned list.

+++
** `makehash' is now obsolete.  Use `make-hash-table' instead.

+++
** If optional third argument APPEND to `add-to-list' is non-nil, a
new element gets added at the end of the list instead of at the
beginning.  This change actually occurred in Emacs-21.1, but was not
documented.

** Major modes can define `eldoc-print-current-symbol-info-function'
locally to provide Eldoc functionality by some method appropriate to
the language.

---
** New coding system property `mime-text-unsuitable' indicates that
the coding system's `mime-charset' is not suitable for MIME text
parts, e.g. utf-16.

+++
** The argument to forward-word, backward-word, forward-to-indentation
and backward-to-indentation is now optional, and defaults to 1.

+++
** (char-displayable-p CHAR) returns non-nil if Emacs ought to be able
to display CHAR.  More precisely, if the selected frame's fontset has
a font to display the character set that CHAR belongs to.

Fontsets can specify a font on a per-character basis; when the fontset
does that, this value may not be accurate.

+++
** The new function `window-inside-edges' returns the edges of the
actual text portion of the window, not including the scroll bar or
divider line, the fringes, the display margins, the header line and
the mode line.

+++
** The new functions `window-pixel-edges' and `window-inside-pixel-edges'
return window edges in units of pixels, rather than columns and lines.

+++
** The kill-buffer-hook is now permanent-local.

+++
** `select-window' takes an optional second argument `norecord', like
`switch-to-buffer'.

+++
** The new macro `with-selected-window' temporarily switches the
selected window without impacting the order of buffer-list.

+++
** The `keymap' property now also works at the ends of overlays and
text-properties, according to their stickiness.  This also means that it
works with empty overlays.  The same hold for the `local-map' property.

+++
** (map-keymap FUNCTION KEYMAP) applies the function to each binding
in the keymap.

---
** VC changes for backends:
*** (vc-switches BACKEND OPERATION) is a new function for use by backends.
*** The new `find-version' backend function replaces the `destfile'
parameter of the `checkout' backend function.
Old code still works thanks to a default `find-version' behavior that
uses the old `destfile' parameter.

+++
** The new macro dynamic-completion-table supports using functions
as a dynamic completion table.

  (dynamic-completion-table FUN)

FUN is called with one argument, the string for which completion is required,
and it should return an alist containing all the intended possible
completions. This alist may be a full list of possible completions so that FUN
can ignore the value of its argument. If completion is performed in the
minibuffer, FUN will be called in the buffer from which the minibuffer was
entered. dynamic-completion-table then computes the completion.

+++
** The new macro lazy-completion-table initializes a variable
as a lazy completion table.

  (lazy-completion-table VAR FUN &rest ARGS)

If the completion table VAR is used for the first time (e.g., by passing VAR
as an argument to `try-completion'), the function FUN is called with arguments
ARGS. FUN must return the completion table that will be stored in VAR. If
completion is requested in the minibuffer, FUN will be called in the buffer
from which the minibuffer was entered. The return value of
`lazy-completion-table' must be used to initialize the value of VAR.

+++
** `minor-mode-list' now holds a list of minor mode commands.

+++
** The new function `modify-all-frames-parameters' modifies parameters
for all (existing and future) frames.

+++
** `sit-for' can now be called with args (SECONDS &optional NODISP).

+++
** New standard font-lock face `font-lock-preprocessor-face'.

+++
** The macro `with-syntax-table' does not copy the table any more.

+++
** The variable `face-font-rescale-alist' specifies how much larger
(or smaller) font we should use.  For instance, if the value is
'((SOME-FONTNAME-PATTERN . 1.3)) and a face requests a font of 10
point, we actually use a font of 13 point if the font matches
SOME-FONTNAME-PATTERN.

+++
** The function `number-sequence' returns a list of equally-separated
numbers.  For instance, (number-sequence 4 9) returns (4 5 6 7 8 9).
By default, the separation is 1, but you can specify a different separation
as the third argument.  (number-sequence 1.5 6 2) returns (1.5 3.5 5.5).

+++
** `file-chase-links' now takes an optional second argument LIMIT which
specifies the maximum number of links to chase through.  If after that
many iterations the file name obtained is still a symbolic link,
`file-chase-links' returns it anyway.

---
** `set-fontset-font', `fontset-info', `fontset-font' now operate on
the default fontset if the argument NAME is nil..

+++
** The escape sequence \s is now interpreted as a SPACE character,
unless it is followed by a `-' in a character constant (e.g. ?\s-A),
in which case it is still interpreted as the super modifier.
In strings, \s is always interpreted as a space.

+++
** New function `set-process-filter-multibyte' sets the multibyteness
of a string given to a process's filter.

+++
** New function `process-filter-multibyte-p' returns t if
a string given to a process's filter is multibyte.

+++
** A filter function of a process is called with a multibyte string if
the filter's multibyteness is t.  That multibyteness is decided by the
value of `default-enable-multibyte-characters' when the process is
created and can be changed later by `set-process-filter-multibyte'.

+++
** If a process's coding system is raw-text or no-conversion and its
buffer is multibyte, the output of the process is at first converted
to multibyte by `string-to-multibyte' then inserted in the buffer.
Previously, it was converted to multibyte by `string-as-multibyte',
which was not compatible with the behaviour of file reading.

+++
** New function `string-to-multibyte' converts a unibyte string to a
multibyte string with the same individual character codes.

+++
** New variables `gc-elapsed' and `gcs-done' provide extra information
on garbage collection.

+++
** New function `decode-coding-inserted-region' decodes a region as if
it is read from a file without decoding.

+++
** New function `locale-info' accesses locale information.

+++
** `save-selected-window' now saves and restores the selected window
of every frame.  This way, it restores everything that can be changed
by calling `select-window'.

---
** `easy-menu-define' now allows you to use nil for the symbol name
if you don't need to give the menu a name.  If you install the menu
into other keymaps right away (MAPS is non-nil), it usually doesn't
need to have a name.

** Byte compiler changes:

---
*** `(featurep 'xemacs)' is treated by the compiler as nil.  This
helps to avoid noisy compiler warnings in code meant to run under both
Emacs and XEmacs and may sometimes make the result significantly more
efficient.  Since byte code from recent versions of XEmacs won't
generally run in Emacs and vice versa, this optimization doesn't lose
you anything.

+++
*** You can avoid warnings for possibly-undefined symbols with a
simple convention that the compiler understands.  (This is mostly
useful in code meant to be portable to different Emacs versions.)
Write forms like the following, or code that macroexpands into such
forms:

  (if (fboundp 'foo) <then> <else>)
  (if (boundp 'foo) <then> <else)

In the first case, using `foo' as a function inside the <then> form
won't produce a warning if it's not defined as a function, and in the
second case, using `foo' as a variable won't produce a warning if it's
unbound.  The test must be in exactly one of the above forms (after
macro expansion), but such tests may be nested.  Note that `when' and
`unless' expand to `if', but `cond' doesn't.

+++
*** The new macro `with-no-warnings' suppresses all compiler warnings
inside its body.  In terms of execution, it is equivalent to `progn'.

+++
** The new translation table `translation-table-for-input'
is used for customizing self-insertion.  The character to
be inserted is translated through it.

+++
** `load-history' can now have elements of the form (t . FUNNAME),
which means FUNNAME was previously defined as an autoload (before the
current file redefined it).

+++
** `load-history' now records (defun . FUNNAME) when a function is
defined.  For a variable, it records just the variable name.

+++
** New Lisp library testcover.el works with edebug to help you determine
whether you've tested all your Lisp code.  Function testcover-start
instruments all functions in a given file.  Then test your code.  Function
testcover-mark-all adds overlay "splotches" to the Lisp file's buffer to
show where coverage is lacking.  Command testcover-next-mark (bind it to
a key!) will move point forward to the next spot that has a splotch.

*** Normally, a red splotch indicates the form was never completely evaluated;
a brown splotch means it always evaluated to the same value.  The red
splotches are skipped for forms that can't possibly complete their evaluation,
such as `error'.  The brown splotches are skipped for forms that are expected
to always evaluate to the same value, such as (setq x 14).

*** For difficult cases, you can add do-nothing macros to your code to help
out the test coverage tool.  The macro `noreturn' suppresses a red splotch.
It is an error if the argument to `noreturn' does return.  The macro 1value
suppresses a brown splotch for its argument.  This macro is a no-op except
during test-coverage -- then it signals an error if the argument actually
returns differing values.

+++
** New function unsafep returns nil if the given Lisp form can't possibly
do anything dangerous; otherwise it returns a reason why the form might be
unsafe (calls dangerous function, alters global variable, etc).

+++
** The new variable `print-continuous-numbering', when non-nil, says
that successive calls to print functions should use the same
numberings for circular structure references.  This is only relevant
when `print-circle' is non-nil.

When you bind `print-continuous-numbering' to t, you should
also bind `print-number-table' to nil.

+++
** When using non-toolkit scroll bars with the default width,
the scroll-bar-width frame parameter value is nil.

+++
** The new function copy-abbrev-table returns a new abbrev table that
is a copy of a given abbrev table.

+++
** The option --script FILE runs Emacs in batch mode and loads FILE.
It is useful for writing Emacs Lisp shell script files, because they
can start with this line:

   #!/usr/bin/emacs --script

** The option --directory DIR now modifies `load-path' immediately.
Directories are added to the front of `load-path' in the order they
appear on the command line.  For example, with this command line:

  emacs -batch -L .. -L /tmp --eval "(require 'foo)"

Emacs looks for library `foo' in the parent directory, then in /tmp, then
in the other directories in `load-path'.  (-L is short for --directory.)

+++
** A function's docstring can now hold the function's usage info on
its last line.  It should match the regexp "\n\n(fn.*)\\'".

---
** New CCL functions `lookup-character' and `lookup-integer' access
hash tables defined by the Lisp function `define-translation-hash-table'.

+++
** The new function `minibufferp' returns non-nil if its optional buffer
argument is a minibuffer.  If the argument is omitted it defaults to
the current buffer.

+++
** There is a new Warnings facility; see the functions `warn'
and `display-warning'.

+++
** The functions all-completions and try-completion now accept lists
of strings as well as hash-tables additionally to alists, obarrays
and functions.  Furthermore, the function `test-completion' is now
exported to Lisp.

---
** When pure storage overflows while dumping, Emacs now prints how
much pure storage it will approximately need.

+++
** The new variable `auto-coding-functions' lets you specify functions
to examine a file being visited and deduce the proper coding system
for it.  (If the coding system is detected incorrectly for a specific
file, you can put a `coding:' tags to override it.)

---
** The new function `merge-coding-systems' fills in unspecified aspects
of one coding system from another coding system.

+++
** The variable `safe-local-eval-forms' specifies a list of forms that
are ok to evaluate when they appear in an `eval' local variables
specification.  Normally Emacs asks for confirmation before evaluating
such a form, but if the form appears in this list, no confirmation is
needed.

---
** If a function has a non-nil `safe-local-eval-function' property,
that means it is ok to evaluate some calls to that function when it
appears in an `eval' local variables specification.  If the property
is t, then any form calling that function with constant arguments is
ok.  If the property is a function or list of functions, they are called
with the form as argument, and if any returns t, the form is ok to call.

If the form is not "ok to call", that means Emacs asks for
confirmation as before.

+++
** Controlling the default left and right fringe widths.

The default left and right fringe widths for all windows of a frame
can now be controlled by setting the `left-fringe' and `right-fringe'
frame parameters to an integer value specifying the width in pixels.
Setting the width to 0 effectively removes the corresponding fringe.

The actual default fringe widths for the frame may deviate from the
specified widths, since the combined fringe widths must match an
integral number of columns.  The extra width is distributed evenly
between the left and right fringe.  For force a specific fringe width,
specify the width as a negative integer (if both widths are negative,
only the left fringe gets the specified width).

Setting the width to nil (the default), restores the default fringe
width which is the minimum number of pixels necessary to display any
of the currently defined fringe bitmaps.  The width of the built-in
fringe bitmaps is 8 pixels.

+++
** Per-window fringes settings

Windows can now have their own individual fringe widths and position
settings.

To control the fringe widths of a window, either set the buffer-local
variables `left-fringe-width', `right-fringe-width', or call
`set-window-fringes'.

To control the fringe position in a window, that is, whether fringes
are positioned between the display margins and the window's text area,
or at the edges of the window, either set the buffer-local variable
`fringes-outside-margins' or call `set-window-fringes'.

The function `window-fringes' can be used to obtain the current
settings.  To make `left-fringe-width', `right-fringe-width', and
`fringes-outside-margins' take effect, you must set them before
displaying the buffer in a window, or use `set-window-buffer' to force
an update of the display margins.

+++
** Per-window vertical scroll-bar settings

Windows can now have their own individual scroll-bar settings
controlling the width and position of scroll-bars.

To control the scroll-bar of a window, either set the buffer-local
variables `scroll-bar-mode' and `scroll-bar-width', or call
`set-window-scroll-bars'.  The function `window-scroll-bars' can be
used to obtain the current settings.  To make `scroll-bar-mode' and
`scroll-bar-width' take effect, you must set them before displaying
the buffer in a window, or use `set-window-buffer' to force an update
of the display margins.

+++
** The function `set-window-buffer' now has an optional third argument
KEEP-MARGINS which will preserve the window's current margin, fringe,
and scroll-bar settings if non-nil.

+++
** Renamed hooks to better follow the naming convention:
find-file-hooks to find-file-hook,
find-file-not-found-hooks to find-file-not-found-functions,
write-file-hooks to write-file-functions,
write-contents-hooks to write-contents-functions,
x-lost-selection-hooks to x-lost-selection-functions,
x-sent-selection-hooks to x-sent-selection-functions.
Marked local-write-file-hooks as obsolete (use the LOCAL arg of `add-hook').

+++
** The new variable `delete-frame-functions' replaces `delete-frame-hook'.
It was renamed to follow the naming conventions for abnormal hooks.  The old
name remains available as an alias, but has been marked obsolete.

+++
** The `read-file-name' function now takes an additional argument which
specifies a predicate which the file name read must satify.  The
new variable `read-file-name-predicate' contains the predicate argument
while reading the file name from the minibuffer; the predicate in this
variable is used by read-file-name-internal to filter the completion list.

---
** The new variable `read-file-name-function' can be used by lisp code
to override the internal read-file-name function.


** The new variable `read-file-name-completion-ignore-case' specifies
whether completion ignores case when reading a file name with the
`read-file-name' function.

+++
** The new function `read-directory-name' can be used instead of
`read-file-name' to read a directory name; when used, completion
will only show directories.

+++
** The new function `file-remote-p' tests a file name and returns
non-nil if it specifies a remote file (one that Emacs accesses using
its own special methods and not directly through the file system).
The value in that case is an identifier for the remote file system.

---
** When a Lisp file uses CL functions at run-time, compiling the file
now issues warnings about these calls, unless the file performs
(require 'cl) when loaded.

+++
** The `defmacro' form may contain declarations specifying how to
indent the macro in Lisp mode and how to debug it with Edebug.  The
syntax of defmacro has been extended to

   (defmacro NAME LAMBDA-LIST [DOC-STRING] [DECLARATION ...] ...)

DECLARATION is a list `(declare DECLARATION-SPECIFIER ...)'.  The
declaration specifiers supported are:

(indent INDENT)
	Set NAME's `lisp-indent-function' property to INDENT.

(edebug DEBUG)
	Set NAME's `edebug-form-spec' property to DEBUG.  (This is
	equivalent to writing a `def-edebug-spec' for the macro.

+++
** Interactive commands can be remapped through keymaps.

This is an alternative to using defadvice or substitute-key-definition
to modify the behavior of a key binding using the normal keymap
binding and lookup functionality.

When a key sequence is bound to a command, and that command is
remapped to another command, that command is run instead of the
original command.

Example:
Suppose that minor mode my-mode has defined the commands
my-kill-line and my-kill-word, and it wants C-k (and any other key
bound to kill-line) to run the command my-kill-line instead of
kill-line, and likewise it wants to run my-kill-word instead of
kill-word.

Instead of rebinding C-k and the other keys in the minor mode map,
command remapping allows you to directly map kill-line into
my-kill-line and kill-word into my-kill-word through the minor mode
map using define-key:

   (define-key my-mode-map [remap kill-line] 'my-kill-line)
   (define-key my-mode-map [remap kill-word] 'my-kill-word)

Now, when my-mode is enabled, and the user enters C-k or M-d,
the commands my-kill-line and my-kill-word are run.

Notice that only one level of remapping is supported.  In the above
example, this means that if my-kill-line is remapped to other-kill,
then C-k still runs my-kill-line.

The following changes have been made to provide command remapping:

- Command remappings are defined using `define-key' with a prefix-key
  `remap', i.e. `(define-key MAP [remap CMD] DEF)' remaps command CMD
  to definition DEF in keymap MAP.  The definition is not limited to
  another command; it can be anything accepted for a normal binding.

- The new function `command-remapping' returns the binding for a
  remapped command in the current keymaps, or nil if not remapped.

- key-binding now remaps interactive commands unless the optional
  third argument NO-REMAP is non-nil.

- where-is-internal now returns nil for a remapped command (e.g.
  kill-line if my-mode is enabled), and the actual key binding for
  the command it is remapped to (e.g. C-k for my-kill-line).
  It also has a new optional fifth argument, NO-REMAP, which inhibits
  remapping if non-nil (e.g. it returns C-k for kill-line and
  <kill-line> for my-kill-line).

- The new variable `this-original-command' contains the original
  command before remapping.  It is equal to `this-command' when the
  command was not remapped.

+++
** New variable emulation-mode-map-alists.

Lisp packages using many minor mode keymaps can now maintain their own
keymap alist separate from minor-mode-map-alist by adding their keymap
alist to this list.

+++
** Atomic change groups.

To perform some changes in the current buffer "atomically" so that
they either all succeed or are all undone, use `atomic-change-group'
around the code that makes changes.  For instance:

  (atomic-change-group
    (insert foo)
    (delete-region x y))

If an error (or other nonlocal exit) occurs inside the body of
`atomic-change-group', it unmakes all the changes in that buffer that
were during the execution of the body.  The change group has no effect
on any other buffers--any such changes remain.

If you need something more sophisticated, you can directly call the
lower-level functions that `atomic-change-group' uses.  Here is how.

To set up a change group for one buffer, call `prepare-change-group'.
Specify the buffer as argument; it defaults to the current buffer.
This function returns a "handle" for the change group.  You must save
the handle to activate the change group and then finish it.

Before you change the buffer again, you must activate the change
group.  Pass the handle to `activate-change-group' afterward to
do this.

After you make the changes, you must finish the change group.  You can
either accept the changes or cancel them all.  Call
`accept-change-group' to accept the changes in the group as final;
call `cancel-change-group' to undo them all.

You should use `unwind-protect' to make sure the group is always
finished.  The call to `activate-change-group' should be inside the
`unwind-protect', in case the user types C-g just after it runs.
(This is one reason why `prepare-change-group' and
`activate-change-group' are separate functions.)  Once you finish the
group, don't use the handle again--don't try to finish the same group
twice.

To make a multibuffer change group, call `prepare-change-group' once
for each buffer you want to cover, then use `nconc' to combine the
returned values, like this:

  (nconc (prepare-change-group buffer-1)
         (prepare-change-group buffer-2))

You can then activate the multibuffer change group with a single call
to `activate-change-group', and finish it with a single call to
`accept-change-group' or `cancel-change-group'.

Nested use of several change groups for the same buffer works as you
would expect.  Non-nested use of change groups for the same buffer
will lead to undesirable results, so don't let it happen; the first
change group you start for any given buffer should be the last one
finished.

+++
** New variable char-property-alias-alist.

This variable allows you to create alternative names for text
properties.  It works at the same level as `default-text-properties',
although it applies to overlays as well.  This variable was introduced
to implement the `font-lock-face' property.

+++
** New special text property `font-lock-face'.

This property acts like the `face' property, but it is controlled by
M-x font-lock-mode.  It is not, strictly speaking, a builtin text
property.  Instead, it is implemented inside font-core.el, using the
new variable `char-property-alias-alist'.

+++
** New function remove-list-of-text-properties.

The new function `remove-list-of-text-properties' is almost the same
as `remove-text-properties'.  The only difference is that it takes
a list of property names as argument rather than a property list.

+++
** New function insert-for-yank.

This function normally works like `insert' but removes the text
properties in the `yank-excluded-properties' list.  However, if the
inserted text has a `yank-handler' text property on the first
character of the string, the insertion of the text may be modified in
a number of ways.  See the description of `yank-handler' below.

+++
** New function insert-buffer-substring-as-yank.

This function works like `insert-buffer-substring', but removes the
text properties in the `yank-excluded-properties' list.

+++
** New function insert-buffer-substring-no-properties.

This function is like insert-buffer-substring, but removes all
text properties from the inserted substring.

+++
** New `yank-handler' text property may be used to control how
previously killed text on the kill-ring is reinserted.

The value of the yank-handler property must be a list with one to four
elements with the following format:
  (FUNCTION PARAM NOEXCLUDE UNDO).

The `insert-for-yank' function looks for a yank-handler property on
the first character on its string argument (typically the first
element on the kill-ring).  If a yank-handler property is found,
the normal behaviour of `insert-for-yank' is modified in various ways:

  When FUNCTION is present and non-nil, it is called instead of `insert'
to insert the string.  FUNCTION takes one argument--the object to insert.
  If PARAM is present and non-nil, it replaces STRING as the object
passed to FUNCTION (or `insert'); for example, if FUNCTION is
`yank-rectangle', PARAM should be a list of strings to insert as a
rectangle.
  If NOEXCLUDE is present and non-nil, the normal removal of the
yank-excluded-properties is not performed; instead FUNCTION is
responsible for removing those properties.  This may be necessary
if FUNCTION adjusts point before or after inserting the object.
  If UNDO is present and non-nil, it is a function that will be called
by `yank-pop' to undo the insertion of the current object.  It is
called with two arguments, the start and end of the current region.
FUNCTION may set `yank-undo-function' to override the UNDO value.

*** The functions kill-new, kill-append, and kill-region now have an
optional argument to specify the yank-handler text property to put on
the killed text.

*** The function yank-pop will now use a non-nil value of the variable
`yank-undo-function' (instead of delete-region) to undo the previous
yank or yank-pop command (or a call to insert-for-yank).  The function
insert-for-yank automatically sets that variable according to the UNDO
element of the string argument's yank-handler text property if present.

+++
** New function display-supports-face-attributes-p may be used to test
whether a given set of face attributes is actually displayable.

A new predicate `supports' has also been added to the `defface' face
specification language, which can be used to do this test for faces
defined with defface.

** The function face-differs-from-default-p now truly checks whether the
given face displays differently from the default face or not (previously
it did only a very cursory check).

+++
** face-attribute, face-foreground, face-background, and face-stipple now
accept a new optional argument, INHERIT, which controls how face
inheritance is used when determining the value of a face attribute.

+++
** New functions face-attribute-relative-p and merge-face-attribute
help with handling relative face attributes.

** The priority of faces in an :inherit attribute face-list is reversed.
If a face contains an :inherit attribute with a list of faces, earlier
faces in the list override later faces in the list; in previous releases
of Emacs, the order was the opposite.  This change was made so that
:inherit face-lists operate identically to face-lists in text `face'
properties.

+++
** Enhancements to process support

*** Function list-processes now has an optional argument; if non-nil,
only the processes whose query-on-exit flag is set are listed.

*** New set-process-query-on-exit-flag and process-query-on-exit-flag
functions.  The existing process-kill-without-query function is still
supported, but new code should use the new functions.

*** Function signal-process now accepts a process object or process
name in addition to a process id to identify the signalled process.

*** Processes now have an associated property list where programs can
maintain process state and other per-process related information.

The new functions process-get and process-put are used to access, add,
and modify elements on this property list.

The new low-level functions process-plist and set-process-plist are
used to access and replace the entire property list of a process.

*** Function accept-process-output now has an optional fourth arg
`just-this-one'.  If non-nil, only output from the specified process
is handled, suspending output from other processes.  If value is an
integer, also inhibit running timers.  This feature is generally not
recommended, but may be necessary for specific applications, such as
speech synthesis.

*** Adaptive read buffering of subprocess output.

On some systems, when emacs reads the output from a subprocess, the
output data is read in very small blocks, potentially resulting in
very poor performance.  This behaviour can be remedied to some extent
by setting the new variable process-adaptive-read-buffering to a
non-nil value (the default), as it will automatically delay reading
from such processes, to allowing them to produce more output before
emacs tries to read it.

+++
** Enhanced networking support.

*** There is a new `make-network-process' function which supports
opening of stream and datagram connections to a server, as well as
create a stream or datagram server inside emacs.

- A server is started using :server t arg.
- Datagram connection is selected using :type 'datagram arg.
- A server can open on a random port using :service t arg.
- Local sockets are supported using :family 'local arg.
- Non-blocking connect is supported using :nowait t arg.
- The process' property list may be initialized using :plist PLIST arg;
  a copy of the server process' property list is automatically inherited
  by new client processes created to handle incoming connections.

To test for the availability of a given feature, use featurep like this:
  (featurep 'make-network-process '(:type datagram))

*** Original open-network-stream is now emulated using make-network-process.

*** New function open-network-stream-nowait.

This function initiates a non-blocking connect and returns immediately
without waiting for the connection to be established.  It takes the
filter and sentinel functions as arguments; when the non-blocking
connect completes, the sentinel is called with a status string
matching "open" or "failed".

*** New function open-network-stream-server.

This function creates a network server process for a TCP service.
When a client connects to the specified service, a new subprocess
is created to handle the new connection, and the sentinel function
is called for the new process.

*** New functions process-datagram-address and set-process-datagram-address.

These functions are used with datagram-based network processes to get
and set the current address of the remote partner.

*** New function format-network-address.

This function reformats the lisp representation of a network address
to a printable string.  For example, an IP address A.B.C.D and port
number P is represented as a five element vector [A B C D P], and the
printable string returned for this vector is "A.B.C.D:P".  See the doc
string for other formatting options.

*** By default, the function process-contact still returns (HOST SERVICE)
for a network process.  Using the new optional KEY arg, the complete list
of network process properties or a specific property can be selected.

Using :local and :remote as the KEY, the address of the local or
remote end-point is returned.  An Inet address is represented as a 5
element vector, where the first 4 elements contain the IP address and
the fifth is the port number.

*** Network processes can now be stopped and restarted with
`stop-process' and `continue-process'.  For a server process, no
connections are accepted in the stopped state.  For a client process,
no input is received in the stopped state.

*** New function network-interface-list.

This function returns a list of network interface names and their
current network addresses.

*** New function network-interface-info.

This function returns the network address, hardware address, current
status, and other information about a specific network interface.

+++
** New function copy-tree.

+++
** New function substring-no-properties.

+++
** New function minibuffer-selected-window.

+++
** New function `call-process-shell-command'.

** New function `process-file'.

This is similar to `call-process', but obeys file handlers.  The file
handler is chosen based on default-directory.

---
** The dummy function keys made by easymenu
are now always lower case.  If you specify the
menu item name "Ada", for instance, it uses `ada'
as the "key" bound by that key binding.

This is relevant only if Lisp code looks for
the bindings that were made with easymenu.

+++
** The function `commandp' takes an additional optional
argument.  If it is non-nil, then `commandp' checks
for a function that could be called with `call-interactively',
and does not return t for keyboard macros.

---
** master-mode.el implements a minor mode for scrolling a slave
buffer without leaving your current buffer, the master buffer.

It can be used by sql.el, for example: the SQL buffer is the master
and its SQLi buffer is the slave.  This allows you to scroll the SQLi
buffer containing the output from the SQL buffer containing the
commands.

This is how to use sql.el and master.el together: the variable
sql-buffer contains the slave buffer.  It is a local variable in the
SQL buffer.

(add-hook 'sql-mode-hook
   (function (lambda ()
	       (master-mode t)
	       (master-set-slave sql-buffer))))
(add-hook 'sql-set-sqli-hook
   (function (lambda ()
	       (master-set-slave sql-buffer))))

+++
** File local variables.

A file local variables list cannot specify a string with text
properties--any specified text properties are discarded.

+++
** New function window-body-height.

This is like window-height but does not count the mode line
or the header line.

+++
** New function format-mode-line.

This returns the mode-line or header-line of the selected (or a
specified) window as a string with or without text properties.

+++
** New function safe-plist-get.

This function is like plist-get, but never signals an error for
a malformed property list.

+++
** New functions `lax-plist-get' and `lax-plist-put'.

These functions are like `plist-get' and `plist-put' except that they
compare the property name using `equal' rather than `eq'.

+++
** New function `tool-bar-local-item-from-menu'

The `tool-bar-add-item-from-menu' must not be used (as previously
recommended) for making entries in the tool bar for local keymaps.
Instead, use the function `tool-bar-local-item-from-menu', which lets
you specify the map to use as an argument.

+++
** The function `atan' now accepts an optional second argument.

When called with 2 arguments, as in `(atan Y X)', `atan' returns the
angle in radians between the vector [X, Y] and the X axis.  (This is
equivalent to the standard C library function `atan2'.)

+++
** You can now make a window as short as one line.

A window that is just one line tall does not display either a mode
line or a header line, even if the variables `mode-line-format' and
`header-line-format' call for them.  A window that is two lines tall
cannot display both a mode line and a header line at once; if the
variables call for both, only the mode line actually appears.

+++
** The new frame parameter `tty-color-mode' specifies the mode to use
for color support on character terminal frames.  Its value can be a
number of colors to support, or a symbol.  See the Emacs Lisp
Reference manual for more detailed documentation.

+++
** The new mode-line construct `(:propertize ELT PROPS...)' can be
used to add text properties to mode-line elements.

+++
** The new `%i' and `%I' constructs for `mode-line-format' can be used
to display the size of the accessible part of the buffer on the mode
line.

---
** Indentation of simple and extended loop forms has been added to the
cl-indent package.  The new user options
`lisp-loop-keyword-indentation', `lisp-loop-forms-indentation', and
`lisp-simple-loop-indentation' can be used to customize the
indentation of keywords and forms in loop forms.

---
** Indentation of backquoted forms has been made customizable in the
cl-indent package.  See the new user option `lisp-backquote-indentation'.

+++
** Already true in Emacs 21.1, but not emphasized clearly enough:

Multibyte buffers can now faithfully record all 256 character codes
from 0 to 255.  As a result, most of the past reasons to use unibyte
buffers no longer exist.  We only know of three reasons to use them
now:

1. If you prefer to use unibyte text all of the time.

2. For reading files into temporary buffers, when you want to avoid
the time it takes to convert the format.

3. For binary files where format conversion would be pointless and
wasteful.

+++
** If text has a `keymap' property, that keymap takes precedence
over minor mode keymaps.

+++
** A hex escape in a string forces the string to be multibyte.
An octal escape makes it unibyte.

+++
** At the end of a command, point moves out from within invisible
text, in the same way it moves out from within text covered by an
image or composition property.

This makes it generally unnecessary to mark invisible text as intangible.
This is particularly good because the intangible property often has
unexpected side-effects since the property applies to everything
(including `goto-char', ...) whereas this new code is only run after
post-command-hook and thus does not care about intermediate states.

+++
** field-beginning and field-end now accept an additional optional
argument, LIMIT.

+++
** define-abbrev now accepts an optional argument SYSTEM-FLAG.  If
non-nil, this marks the abbrev as a "system" abbrev, which means that
it won't be stored in the user's abbrevs file if he saves the abbrevs.
Major modes that predefine some abbrevs should always specify this
flag.

---
** Support for Mocklisp has been removed.

---
** The function insert-string is now obsolete.

---
** The precedence of file-name-handlers has been changed.
Instead of blindly choosing the first handler that matches,
find-file-name-handler now gives precedence to a file-name handler
that matches near the end of the file name.  More specifically, the
handler whose (match-beginning 0) is the largest is chosen.
In case of ties, the old "first matched" rule applies.

---
** Dense keymaps now handle inheritance correctly.
Previously a dense keymap would hide all of the simple-char key
bindings of the parent keymap.

---
** jit-lock obeys a new text-property `jit-lock-defer-multiline'.
If a piece of text with that property gets contextually refontified
(see jit-lock-defer-contextually), then all of that text will
be refontified.  This is useful when the syntax of a textual element
depends on text several lines further down (and when font-lock-multiline
is not appropriate to solve that problem).  For example in Perl:

	s{
		foo
	}{
		bar
	}e

Adding/removing the last `e' changes the `bar' from being a piece of
text to being a piece of code, so you'd put a jit-lock-defer-multiline
property over the second half of the command to force (deferred)
refontification of `bar' whenever the `e' is added/removed.

---
** describe-vector now takes a second argument `describer' which is
called to print the entries' values.  It defaults to `princ'.

** defcustom and other custom declarations now use a default group
(the last prior group defined in the same file) when no :group was given.

+++
** emacsserver now runs pre-command-hook and post-command-hook when
it receives a request from emacsclient.

---
** The variable `recursive-load-depth-limit' has been deleted.
Emacs now signals an error if the same file is loaded with more
than 3 levels of nesting.

---
** If a major mode function has a non-nil `no-clone-indirect'
property, `clone-indirect-buffer' signals an error if you use
it in that buffer.

---
** In `replace-match', the replacement text no longer inherits
properties from surrounding text.

+++
** The list returned by `(match-data t)' now has the buffer as a final
element, if the last match was on a buffer.  `set-match-data'
accepts such a list for restoring the match state.

+++
** New function `buffer-local-value'.

This function returns the buffer-local binding of VARIABLE (a symbol)
in buffer BUFFER.  If VARIABLE does not have a buffer-local binding in
buffer BUFFER, it returns the default value of VARIABLE instead.

---
** New function `text-clone-create'.  Text clones are chunks of text
that are kept identical by transparently propagating changes from one
clone to the other.

+++
** font-lock can manage arbitrary text-properties beside `face'.
*** the FACENAME returned in font-lock-keywords can be a list
of the form (face FACE PROP1 VAL1 PROP2 VAL2 ...) so you can set
other properties than `face'.
*** font-lock-extra-managed-props can be set to make sure those extra
properties are automatically cleaned up by font-lock.

---
** The special treatment of faces whose names are of the form `fg:COLOR'
or `bg:COLOR' has been removed.  Lisp programs should use the
`defface' facility for defining faces with specific colors, or use
the feature of specifying the face attributes :foreground and :background
directly in the `face' property instead of using a named face.

+++
** The new function `run-mode-hooks' and the new macro `delay-mode-hooks'
are used by define-derived-mode to make sure the mode hook for the
parent mode is run at the end of the child mode.

+++
** define-minor-mode now accepts arbitrary additional keyword arguments
and simply passes them to defcustom, if applicable.

+++
** define-derived-mode by default creates a new empty abbrev table.
It does not copy abbrevs from the parent mode's abbrev table.

+++
** `provide' and `featurep' now accept an optional second argument
to test/provide subfeatures.  Also `provide' now checks `after-load-alist'
and runs any code associated with the provided feature.

+++
** Functions `file-name-sans-extension' and `file-name-extension' now
ignore the leading dots in file names, so that file names such as
`.emacs' are treated as extensionless.

+++
** Functions `user-uid' and `user-real-uid' now return floats if the
user UID doesn't fit in a Lisp integer.  Function `user-full-name'
accepts a float as UID parameter.

---
** `define-key-after' now accepts keys longer than 1.

+++
** The local variable `no-byte-compile' in elisp files is now obeyed.

+++
** The Emacs Lisp byte-compiler now displays the actual line and
character position of errors, where possible.  Additionally, the form
of its warning and error messages have been brought more in line with
the output of other GNU tools.

+++
** New functions `keymap-prompt' and `current-active-maps'.

---
** New function `describe-buffer-bindings'.

+++
** New vars `exec-suffixes' and `load-suffixes' used when
searching for an executable resp. an elisp file.

+++
** Variable aliases have been implemented:

*** defvaralias ALIAS-VAR BASE-VAR [DOCSTRING]

This function defines the symbol ALIAS-VAR as a variable alias for
symbol BASE-VAR.  This means that retrieving the value of ALIAS-VAR
returns the value of BASE-VAR, and changing the value of ALIAS-VAR
changes the value of BASE-VAR.

DOCSTRING, if present, is the documentation for ALIAS-VAR; else it has
the same documentation as BASE-VAR.

*** indirect-variable VARIABLE

This function returns the variable at the end of the chain of aliases
of VARIABLE.  If VARIABLE is not a symbol, or if VARIABLE is not
defined as an alias, the function returns VARIABLE.

It might be noteworthy that variables aliases work for all kinds of
variables, including buffer-local and frame-local variables.

+++
** Functions from `post-gc-hook' are run at the end of garbage
collection.  The hook is run with GC inhibited, so use it with care.

+++
** If the second argument to `copy-file' is the name of a directory,
the file is copied to that directory instead of signaling an error.

+++
** The variables most-positive-fixnum and most-negative-fixnum
hold the largest and smallest possible integer values.

---
** On MS Windows, locale-coding-system is used to interact with the OS.
The Windows specific variable w32-system-coding-system, which was
formerly used for that purpose is now an alias for locale-coding-system.

** Functions y-or-n-p, read-char, read-key-sequence and the like, that
display a prompt but don't use the minibuffer, now display the prompt
using the text properties (esp. the face) of the prompt string.

** New function x-send-client-message sends a client message when
running under X.

** Arguments for remove-overlays are now optional, so that you can remove
all overlays in the buffer by just calling (remove-overlay).

** New packages:

*** The new package gdb-ui.el provides an enhanced graphical interface to
GDB. You can interact with GDB through the GUD buffer in the usual way, but
there are also further buffers which control the execution and describe the
state of your program.  It separates the input/output of your program from
that of GDB and watches expressions in the speedbar.  It also uses features of
Emacs 21 such as the display margin for breakpoints, and the toolbar.

Use M-x gdba to start GDB-UI.

*** The new package syntax.el provides an efficient way to find the
current syntactic context (as returned by parse-partial-sexp).

*** The new package bindat.el provides functions to unpack and pack
binary data structures, such as network packets, to and from Lisp
data structures.

*** The TCL package tcl-mode.el was replaced by tcl.el.
This was actually done in Emacs-21.1, and was not documented.

*** The new package button.el implements simple and fast `clickable buttons'
in emacs buffers.  `buttons' are much lighter-weight than the `widgets'
implemented by widget.el, and can be used by lisp code that doesn't
require the full power of widgets.  Emacs uses buttons for such things
as help and apropos buffers.


* Installation changes in Emacs 21.3

** Support for GNU/Linux on little-endian MIPS and on IBM S390 has
been added.


* Changes in Emacs 21.3

** The obsolete C mode (c-mode.el) has been removed to avoid problems
with Custom.

** UTF-16 coding systems are available, encoding the same characters
as mule-utf-8.

** There is a new language environment for UTF-8 (set up automatically
in UTF-8 locales).

** Translation tables are available between equivalent characters in
different Emacs charsets -- for instance `e with acute' coming from the
Latin-1 and Latin-2 charsets.  User options `unify-8859-on-encoding-mode'
and `unify-8859-on-decoding-mode' respectively turn on translation
between ISO 8859 character sets (`unification') on encoding
(e.g. writing a file) and decoding (e.g. reading a file).  Note that
`unify-8859-on-encoding-mode' is useful and safe, but
`unify-8859-on-decoding-mode' can cause text to change when you read
it and write it out again without edits, so it is not generally advisable.
By default `unify-8859-on-encoding-mode' is turned on.

** In Emacs running on the X window system, the default value of
`selection-coding-system' is now `compound-text-with-extensions'.

If you want the old behavior, set selection-coding-system to
compound-text, which may be significantly more efficient.  Using
compound-text-with-extensions seems to be necessary only for decoding
text from applications under XFree86 4.2, whose behaviour is actually
contrary to the compound text specification.


* Installation changes in Emacs 21.2

** Support for BSD/OS 5.0 has been added.

** Support for AIX 5.1 was added.


* Changes in Emacs 21.2

** Emacs now supports compound-text extended segments in X selections.

X applications can use `extended segments' to encode characters in
compound text that belong to character sets which are not part of the
list of approved standard encodings for X, e.g. Big5.  To paste
selections with such characters into Emacs, use the new coding system
compound-text-with-extensions as the value of selection-coding-system.

** The default values of `tooltip-delay' and `tooltip-hide-delay'
were changed.

** On terminals whose erase-char is ^H (Backspace), Emacs
now uses normal-erase-is-backspace-mode.

** When the *scratch* buffer is recreated, its mode is set from
initial-major-mode, which normally is lisp-interaction-mode,
instead of using default-major-mode.

** The new option `Info-scroll-prefer-subnodes' causes Info to behave
like the stand-alone Info reader (from the GNU Texinfo package) as far
as motion between nodes and their subnodes is concerned.  If it is t
(the default), Emacs behaves as before when you type SPC in a menu: it
visits the subnode pointed to by the first menu entry.  If this option
is nil, SPC scrolls to the end of the current node, and only then goes
to the first menu item, like the stand-alone reader does.

This change was already in Emacs 21.1, but wasn't advertised in the
NEWS.


* Lisp Changes in Emacs 21.2

** The meanings of scroll-up-aggressively and scroll-down-aggressively
have been interchanged, so that the former now controls scrolling up,
and the latter now controls scrolling down.

** The variable `compilation-parse-errors-filename-function' can
be used to transform filenames found in compilation output.


* Installation Changes in Emacs 21.1

See the INSTALL file for information on installing extra libraries and
fonts to take advantage of the new graphical features and extra
charsets in this release.

** Support for GNU/Linux on IA64 machines has been added.

** Support for LynxOS has been added.

** There are new configure options associated with the support for
images and toolkit scrollbars.  Use the --help option in `configure'
to list them.

** You can build a 64-bit Emacs for SPARC/Solaris systems which
support 64-bit executables and also on Irix 6.5.  This increases the
maximum buffer size.  See etc/MACHINES for instructions.  Changes to
build on other 64-bit systems should be straightforward modulo any
necessary changes to unexec.

** There is a new configure option `--disable-largefile' to omit
Unix-98-style support for large files if that is available.

** There is a new configure option `--without-xim' that instructs
Emacs to not use X Input Methods (XIM), if these are available.

** `movemail' defaults to supporting POP.  You can turn this off using
the --without-pop configure option, should that be necessary.

** This version can be built for the Macintosh, but does not implement
all of the new display features described below.  The port currently
lacks unexec, asynchronous processes, and networking support.  See the
"Emacs and the Mac OS" appendix in the Emacs manual, for the
description of aspects specific to the Mac.

** Note that the MS-Windows port does not yet implement various of the
new display features described below.


* Changes in Emacs 21.1

** Emacs has a new redisplay engine.

The new redisplay handles characters of variable width and height.
Italic text can be used without redisplay problems.  Fonts containing
oversized characters, i.e. characters larger than the logical height
of a font can be used.  Images of various formats can be displayed in
the text.

** Emacs has a new face implementation.

The new faces no longer fundamentally use X font names to specify the
font.  Instead, each face has several independent attributes--family,
height, width, weight and slant--that it may or may not specify.
These attributes can be merged from various faces, and then together
specify a font.

Faces are supported on terminals that can display color or fonts.
These terminal capabilities are auto-detected.  Details can be found
under Lisp changes, below.

** Emacs can display faces on TTY frames.

Emacs automatically detects terminals that are able to display colors.
Faces with a weight greater than normal are displayed extra-bright, if
the terminal supports it.  Faces with a weight less than normal and
italic faces are displayed dimmed, if the terminal supports it.
Underlined faces are displayed underlined if possible.  Other face
attributes such as `overline', `strike-through', and `box' are ignored
on terminals.

The command-line options `-fg COLOR', `-bg COLOR', and `-rv' are now
supported on character terminals.

Emacs automatically remaps all X-style color specifications to one of
the colors supported by the terminal.  This means you could have the
same color customizations that work both on a windowed display and on
a TTY or when Emacs is invoked with the -nw option.

** New default font is Courier 12pt under X.

** Sound support

Emacs supports playing sound files on GNU/Linux and FreeBSD (Voxware
driver and native BSD driver, a.k.a. Luigi's driver).  Currently
supported file formats are RIFF-WAVE (*.wav) and Sun Audio (*.au).
You must configure Emacs with the option `--with-sound=yes' to enable
sound support.

** Emacs now resizes mini-windows if appropriate.

If a message is longer than one line, or minibuffer contents are
longer than one line, Emacs can resize the minibuffer window unless it
is on a frame of its own.  You can control resizing and the maximum
minibuffer window size by setting the following variables:

- User option: max-mini-window-height

Maximum height for resizing mini-windows.  If a float, it specifies a
fraction of the mini-window frame's height.  If an integer, it
specifies a number of lines.

Default is 0.25.

- User option: resize-mini-windows

How to resize mini-windows.  If nil, don't resize.  If t, always
resize to fit the size of the text.  If `grow-only', let mini-windows
grow only, until they become empty, at which point they are shrunk
again.

Default is `grow-only'.

** LessTif support.

Emacs now runs with the LessTif toolkit (see
<http://www.lesstif.org>).  You will need version 0.92.26, or later.

** LessTif/Motif file selection dialog.

When Emacs is configured to use LessTif or Motif, reading a file name
from a menu will pop up a file selection dialog if `use-dialog-box' is
non-nil.

** File selection dialog on MS-Windows is supported.

When a file is visited by clicking File->Open, the MS-Windows version
now pops up a standard file selection dialog where you can select a
file to visit.  File->Save As also pops up that dialog.

** Toolkit scroll bars.

Emacs now uses toolkit scroll bars if available.  When configured for
LessTif/Motif, it will use that toolkit's scroll bar.  Otherwise, when
configured for Lucid and Athena widgets, it will use the Xaw3d scroll
bar if Xaw3d is available.  You can turn off the use of toolkit scroll
bars by specifying `--with-toolkit-scroll-bars=no' when configuring
Emacs.

When you encounter problems with the Xaw3d scroll bar, watch out how
Xaw3d is compiled on your system.  If the Makefile generated from
Xaw3d's Imakefile contains a `-DNARROWPROTO' compiler option, and your
Emacs system configuration file `s/your-system.h' does not contain a
define for NARROWPROTO, you might consider adding it.  Take
`s/freebsd.h' as an example.

Alternatively, if you don't have access to the Xaw3d source code, take
a look at your system's imake configuration file, for example in the
directory `/usr/X11R6/lib/X11/config' (paths are different on
different systems).  You will find files `*.cf' there.  If your
system's cf-file contains a line like `#define NeedWidePrototypes NO',
add a `#define NARROWPROTO' to your Emacs system configuration file.

The reason for this is that one Xaw3d function uses `double' or
`float' function parameters depending on the setting of NARROWPROTO.
This is not a problem when Imakefiles are used because each system's
imake configuration file contains the necessary information.  Since
Emacs doesn't use imake, this has do be done manually.

** Tool bar support.

Emacs supports a tool bar at the top of a frame under X.  For details
of how to define a tool bar, see the page describing Lisp-level
changes.  Tool-bar global minor mode controls whether or not it is
displayed and is on by default.  The appearance of the bar is improved
if Emacs has been built with XPM image support.  Otherwise monochrome
icons will be used.

To make the tool bar more useful, we need contributions of extra icons
for specific modes (with copyright assignments).

** Tooltips.

Tooltips are small X windows displaying a help string at the current
mouse position.  The Lisp package `tooltip' implements them.  You can
turn them off via the user option `tooltip-mode'.

Tooltips also provides support for GUD debugging.  If activated,
variable values can be displayed in tooltips by pointing at them with
the mouse in source buffers.  You can customize various aspects of the
tooltip display in the group `tooltip'.

** Automatic Hscrolling

Horizontal scrolling now happens automatically if
`automatic-hscrolling' is set (the default).  This setting can be
customized.

If a window is scrolled horizontally with set-window-hscroll, or
scroll-left/scroll-right (C-x <, C-x >), this serves as a lower bound
for automatic horizontal scrolling.  Automatic scrolling will scroll
the text more to the left if necessary, but won't scroll the text more
to the right than the column set with set-window-hscroll etc.

** When using a windowing terminal, each Emacs window now has a cursor
of its own.  By default, when a window is selected, the cursor is
solid; otherwise, it is hollow.  The user-option
`cursor-in-non-selected-windows' controls how to display the
cursor in non-selected windows.  If nil, no cursor is shown, if
non-nil a hollow box cursor is shown.

** Fringes to the left and right of windows are used to display
truncation marks, continuation marks, overlay arrows and alike.  The
foreground, background, and stipple of these areas can be changed by
customizing face `fringe'.

** The mode line under X is now drawn with shadows by default.
You can change its appearance by modifying the face `mode-line'.
In particular, setting the `:box' attribute to nil turns off the 3D
appearance of the mode line.  (The 3D appearance makes the mode line
occupy more space, and thus might cause the first or the last line of
the window to be partially obscured.)

The variable `mode-line-inverse-video', which was used in older
versions of emacs to make the mode-line stand out, is now deprecated.
However, setting it to nil will cause the `mode-line' face to be
ignored, and mode-lines to be drawn using the default text face.

** Mouse-sensitive mode line.

Different parts of the mode line have been made mouse-sensitive on all
systems which support the mouse.  Moving the mouse to a
mouse-sensitive part in the mode line changes the appearance of the
mouse pointer to an arrow, and help about available mouse actions is
displayed either in the echo area, or in the tooltip window if you
have enabled one.

Currently, the following actions have been defined:

- Mouse-1 on the buffer name in the mode line goes to the next buffer.

- Mouse-3 on the buffer-name goes to the previous buffer.

- Mouse-2 on the read-only or modified status in the mode line (`%' or
`*') toggles the status.

- Mouse-3 on the mode name displays a minor-mode menu.

** Hourglass pointer

Emacs can optionally display an hourglass pointer under X.  You can
turn the display on or off by customizing group `cursor'.

** Blinking cursor

M-x blink-cursor-mode toggles a blinking cursor under X and on
terminals having terminal capabilities `vi', `vs', and `ve'.  Blinking
and related parameters like frequency and delay can be customized in
the group `cursor'.

** New font-lock support mode `jit-lock-mode'.

This support mode is roughly equivalent to `lazy-lock' but is
generally faster.  It supports stealth and deferred fontification.
See the documentation of the function `jit-lock-mode' for more
details.

Font-lock uses jit-lock-mode as default support mode, so you don't
have to do anything to activate it.

** The default binding of the Delete key has changed.

The new user-option `normal-erase-is-backspace' can be set to
determine the effect of the Delete and Backspace function keys.

On window systems, the default value of this option is chosen
according to the keyboard used.  If the keyboard has both a Backspace
key and a Delete key, and both are mapped to their usual meanings, the
option's default value is set to t, so that Backspace can be used to
delete backward, and Delete can be used to delete forward.  On
keyboards which either have only one key (usually labeled DEL), or two
keys DEL and BS which produce the same effect, the option's value is
set to nil, and these keys delete backward.

If not running under a window system, setting this option accomplishes
a similar effect by mapping C-h, which is usually generated by the
Backspace key, to DEL, and by mapping DEL to C-d via
`keyboard-translate'.  The former functionality of C-h is available on
the F1 key.  You should probably not use this setting on a text-only
terminal if you don't have both Backspace, Delete and F1 keys.

Programmatically, you can call function normal-erase-is-backspace-mode
to toggle the behavior of the Delete and Backspace keys.

** The default for user-option `next-line-add-newlines' has been
changed to nil, i.e. C-n will no longer add newlines at the end of a
buffer by default.

** The <home> and <end> keys now move to the beginning or end of the
current line, respectively.  C-<home> and C-<end> move to the
beginning and end of the buffer.

** Emacs now checks for recursive loads of Lisp files.  If the
recursion depth exceeds `recursive-load-depth-limit', an error is
signaled.

** When an error is signaled during the loading of the user's init
file, Emacs now pops up the *Messages* buffer.

** Emacs now refuses to load compiled Lisp files which weren't
compiled with Emacs.  Set `load-dangerous-libraries' to t to change
this behavior.

The reason for this change is an incompatible change in XEmacs's byte
compiler.  Files compiled with XEmacs can contain byte codes that let
Emacs dump core.

** Toggle buttons and radio buttons in menus.

When compiled with LessTif (or Motif) support, Emacs uses toolkit
widgets for radio and toggle buttons in menus.  When configured for
Lucid, Emacs draws radio buttons and toggle buttons similar to Motif.

** The menu bar configuration has changed.  The new configuration is
more CUA-compliant.  The most significant change is that Options is
now a separate menu-bar item, with Mule and Customize as its submenus.

** Item Save Options on the Options menu allows saving options set
using that menu.

** Highlighting of trailing whitespace.

When `show-trailing-whitespace' is non-nil, Emacs displays trailing
whitespace in the face `trailing-whitespace'.  Trailing whitespace is
defined as spaces or tabs at the end of a line.  To avoid busy
highlighting when entering new text, trailing whitespace is not
displayed if point is at the end of the line containing the
whitespace.

** C-x 5 1 runs the new command delete-other-frames which deletes
all frames except the selected one.

** The new user-option `confirm-kill-emacs' can be customized to
let Emacs ask for confirmation before exiting.

** The header line in an Info buffer is now displayed as an emacs
header-line (which is like a mode-line, but at the top of the window),
so that it remains visible even when the buffer has been scrolled.
This behavior may be disabled by customizing the option
`Info-use-header-line'.

** Polish, Czech, German, and French translations of Emacs' reference card
have been added.  They are named `pl-refcard.tex', `cs-refcard.tex',
`de-refcard.tex' and `fr-refcard.tex'.  Postscript files are included.

** An `Emacs Survival Guide', etc/survival.tex, is available.

** A reference card for Dired has been added.  Its name is
`dired-ref.tex'.  A French translation is available in
`fr-drdref.tex'.

** C-down-mouse-3 is bound differently.  Now if the menu bar is not
displayed it pops up a menu containing the items which would be on the
menu bar.  If the menu bar is displayed, it pops up the major mode
menu or the Edit menu if there is no major mode menu.

** Variable `load-path' is no longer customizable through Customize.

You can no longer use `M-x customize-variable' to customize `load-path'
because it now contains a version-dependent component.  You can still
use `add-to-list' and `setq' to customize this variable in your
`~/.emacs' init file or to modify it from any Lisp program in general.

** C-u C-x = provides detailed information about the character at
point in a pop-up window.

** Emacs can now support 'wheeled' mice (such as the MS IntelliMouse)
under XFree86.  To enable this, use the `mouse-wheel-mode' command, or
customize the variable `mouse-wheel-mode'.

The variables `mouse-wheel-follow-mouse' and `mouse-wheel-scroll-amount'
determine where and by how much buffers are scrolled.

** Emacs' auto-save list files are now by default stored in a
sub-directory `.emacs.d/auto-save-list/' of the user's home directory.
(On MS-DOS, this subdirectory's name is `_emacs.d/auto-save.list/'.)
You can customize `auto-save-list-file-prefix' to change this location.

** The function `getenv' is now callable interactively.

** The new user-option `even-window-heights' can be set to nil
to prevent `display-buffer' from evening out window heights.

** The new command M-x delete-trailing-whitespace RET will delete the
trailing whitespace within the current restriction.  You can also add
this function to `write-file-hooks' or `local-write-file-hooks'.

** When visiting a file with M-x find-file-literally, no newlines will
be added to the end of the buffer even if `require-final-newline' is
non-nil.

** The new user-option `find-file-suppress-same-file-warnings' can be
set to suppress warnings ``X and Y are the same file'' when visiting a
file that is already visited under a different name.

** The new user-option `electric-help-shrink-window' can be set to
nil to prevent adjusting the help window size to the buffer size.

** New command M-x describe-character-set reads a character set name
and displays information about that.

** The new variable `auto-mode-interpreter-regexp' contains a regular
expression matching interpreters, for file mode determination.

This regular expression is matched against the first line of a file to
determine the file's mode in `set-auto-mode' when Emacs can't deduce a
mode from the file's name.  If it matches, the file is assumed to be
interpreted by the interpreter matched by the second group of the
regular expression.  The mode is then determined as the mode
associated with that interpreter in `interpreter-mode-alist'.

** New function executable-make-buffer-file-executable-if-script-p is
suitable as an after-save-hook as an alternative to `executable-chmod'.

** The most preferred coding-system is now used to save a buffer if
buffer-file-coding-system is `undecided' and it is safe for the buffer
contents.  (The most preferred is set by set-language-environment or
by M-x prefer-coding-system.)  Thus if you visit an ASCII file and
insert a non-ASCII character from your current language environment,
the file will be saved silently with the appropriate coding.
Previously you would be prompted for a safe coding system.

** The many obsolete language `setup-...-environment' commands have
been removed -- use `set-language-environment'.

** The new Custom option `keyboard-coding-system' specifies a coding
system for keyboard input.

** New variable `inhibit-iso-escape-detection' determines if Emacs'
coding system detection algorithm should pay attention to ISO2022's
escape sequences.  If this variable is non-nil, the algorithm ignores
such escape sequences.  The default value is nil, and it is
recommended not to change it except for the special case that you
always want to read any escape code verbatim.  If you just want to
read a specific file without decoding escape codes, use C-x RET c
(`universal-coding-system-argument').  For instance, C-x RET c latin-1
RET C-x C-f filename RET.

** Variable `default-korean-keyboard' is initialized properly from the
environment variable `HANGUL_KEYBOARD_TYPE'.

** New command M-x list-charset-chars reads a character set name and
displays all characters in that character set.

** M-x set-terminal-coding-system (C-x RET t) now allows CCL-based
coding systems such as cpXXX and cyrillic-koi8.

** Emacs now attempts to determine the initial language environment
and preferred and locale coding systems systematically from the
LC_ALL, LC_CTYPE, and LANG environment variables during startup.

** New language environments `Polish', `Latin-8' and `Latin-9'.
Latin-8 and Latin-9 correspond respectively to the ISO character sets
8859-14 (Celtic) and 8859-15 (updated Latin-1, with the Euro sign).
GNU Intlfonts doesn't support these yet but recent X releases have
8859-15.  See etc/INSTALL for information on obtaining extra fonts.
There are new Leim input methods for Latin-8 and Latin-9 prefix (only)
and Polish `slash'.

** New language environments `Dutch' and `Spanish'.
These new environments mainly select appropriate translations
of the tutorial.

** In Ethiopic language environment, special key bindings for
function keys are changed as follows.  This is to conform to "Emacs
Lisp Coding Convention".

    new  command                            old-binding
    ---  -------                            -----------
    f3   ethio-fidel-to-sera-buffer         f5
    S-f3 ethio-fidel-to-sera-region         f5
    C-f3 ethio-fidel-to-sera-mail-or-marker f5

    f4   ethio-sera-to-fidel-buffer         unchanged
    S-f4 ethio-sera-to-fidel-region         unchanged
    C-f4 ethio-sera-to-fidel-mail-or-marker unchanged

    S-f5 ethio-toggle-punctuation           f3
    S-f6 ethio-modify-vowel                 f6
    S-f7 ethio-replace-space                f7
    S-f8 ethio-input-special-character      f8
    S-f9 ethio-replace-space                unchanged
    C-f9 ethio-toggle-space                 f2

** There are new Leim input methods.
New input methods "turkish-postfix", "turkish-alt-postfix",
"greek-mizuochi", "TeX", and "greek-babel" are now part of the Leim
package.

** The rule of input method "slovak" is slightly changed.  Now the
rules for translating "q" and "Q" to "`" (backquote) are deleted, thus
typing them inserts "q" and "Q" respectively.  Rules for translating
"=q", "+q", "=Q", and "+Q" to "`" are also deleted.  Now, to input
"`", you must type "=q".

** When your terminal can't display characters from some of the ISO
8859 character sets but can display Latin-1, you can display
more-or-less mnemonic sequences of ASCII/Latin-1 characters instead of
empty boxes (under a window system) or question marks (not under a
window system).  Customize the option `latin1-display' to turn this
on.

** M-; now calls comment-dwim which tries to do something clever based
on the context.  M-x kill-comment is now an alias to comment-kill,
defined in newcomment.el.  You can choose different styles of region
commenting with the variable `comment-style'.

** New user options `display-time-mail-face' and
`display-time-use-mail-icon' control the appearance of mode-line mail
indicator used by the display-time package.  On a suitable display the
indicator can be an icon and is mouse-sensitive.

** On window-systems, additional space can be put between text lines
on the display using several methods

- By setting frame parameter `line-spacing' to PIXELS.  PIXELS must be
a positive integer, and specifies that PIXELS number of pixels should
be put below text lines on the affected frame or frames.

- By setting X resource `lineSpacing', class `LineSpacing'.  This is
equivalent to specifying the frame parameter.

- By specifying `--line-spacing=N' or `-lsp N' on the command line.

- By setting buffer-local variable `line-spacing'.  The meaning is
the same, but applies to the a particular buffer only.

** The new command `clone-indirect-buffer' can be used to create
an indirect buffer that is a twin copy of the current buffer.  The
command `clone-indirect-buffer-other-window', bound to C-x 4 c,
does the same but displays the indirect buffer in another window.

** New user options `backup-directory-alist' and
`make-backup-file-name-function' control the placement of backups,
typically in a single directory or in an invisible sub-directory.

** New commands iso-iso2sgml and iso-sgml2iso convert between Latin-1
characters and the corresponding SGML (HTML) entities.

** New X resources recognized

*** The X resource `synchronous', class `Synchronous', specifies
whether Emacs should run in synchronous mode.  Synchronous mode
is useful for debugging X problems.

Example:

  emacs.synchronous: true

*** The X resource `visualClass, class `VisualClass', specifies the
visual Emacs should use.  The resource's value should be a string of
the form `CLASS-DEPTH', where CLASS is the name of the visual class,
and DEPTH is the requested color depth as a decimal number.  Valid
visual class names are

  TrueColor
  PseudoColor
  DirectColor
  StaticColor
  GrayScale
  StaticGray

Visual class names specified as X resource are case-insensitive, i.e.
`pseudocolor', `Pseudocolor' and `PseudoColor' all have the same
meaning.

The program `xdpyinfo' can be used to list the visual classes
supported on your display, and which depths they have.  If
`visualClass' is not specified, Emacs uses the display's default
visual.

Example:

  emacs.visualClass: TrueColor-8

*** The X resource `privateColormap', class `PrivateColormap',
specifies that Emacs should use a private colormap if it is using the
default visual, and that visual is of class PseudoColor.  Recognized
resource values are `true' or `on'.

Example:

  emacs.privateColormap: true

** Faces and frame parameters.

There are four new faces `scroll-bar', `border', `cursor' and `mouse'.
Setting the frame parameters `scroll-bar-foreground' and
`scroll-bar-background' sets foreground and background color of face
`scroll-bar' and vice versa.  Setting frame parameter `border-color'
sets the background color of face `border' and vice versa.  Likewise
for frame parameters `cursor-color' and face `cursor', and frame
parameter `mouse-color' and face `mouse'.

Changing frame parameter `font' sets font-related attributes of the
`default' face and vice versa.  Setting frame parameters
`foreground-color' or `background-color' sets the colors of the
`default' face and vice versa.

** New face `menu'.

The face `menu' can be used to change colors and font of Emacs' menus.

** New frame parameter `screen-gamma' for gamma correction.

The new frame parameter `screen-gamma' specifies gamma-correction for
colors.  Its value may be nil, the default, in which case no gamma
correction occurs, or a number > 0, usually a float, that specifies
the screen gamma of a frame's display.

PC monitors usually have a screen gamma of 2.2.  smaller values result
in darker colors.  You might want to try a screen gamma of 1.5 for LCD
color displays.  The viewing gamma Emacs uses is 0.4545. (1/2.2).

The X resource name of this parameter is `screenGamma', class
`ScreenGamma'.

** Tabs and variable-width text.

Tabs are now displayed with stretch properties; the width of a tab is
defined as a multiple of the normal character width of a frame, and is
independent of the fonts used in the text where the tab appears.
Thus, tabs can be used to line up text in different fonts.

** Enhancements of the Lucid menu bar

*** The Lucid menu bar now supports the resource "margin".

	emacs.pane.menubar.margin: 5

The default margin is 4 which makes the menu bar appear like the
LessTif/Motif one.

*** Arrows that indicate sub-menus are now drawn with shadows, as in
LessTif and Motif.

** A block cursor can be drawn as wide as the glyph under it under X.

As an example: if a block cursor is over a tab character, it will be
drawn as wide as that tab on the display.  To do this, set
`x-stretch-cursor' to a non-nil value.

** Empty display lines at the end of a buffer may be marked with a
bitmap (this is similar to the tilde displayed by vi and Less).

This behavior is activated by setting the buffer-local variable
`indicate-empty-lines' to a non-nil value.  The default value of this
variable is found in `default-indicate-empty-lines'.

** There is a new "aggressive" scrolling method.

When scrolling up because point is above the window start, if the
value of the buffer-local variable `scroll-up-aggressively' is a
number, Emacs chooses a new window start so that point ends up that
fraction of the window's height from the top of the window.

When scrolling down because point is below the window end, if the
value of the buffer-local variable `scroll-down-aggressively' is a
number, Emacs chooses a new window start so that point ends up that
fraction of the window's height from the bottom of the window.

** You can now easily create new *Info* buffers using either
M-x clone-buffer, C-u m <entry> RET or C-u g <entry> RET.
M-x clone-buffer can also be used on *Help* and several other special
buffers.

** The command `Info-search' now uses a search history.

** Listing buffers with M-x list-buffers (C-x C-b) now shows
abbreviated file names.  Abbreviations can be customized by changing
`directory-abbrev-alist'.

** A new variable, backup-by-copying-when-privileged-mismatch, gives
the highest file uid for which backup-by-copying-when-mismatch will be
forced on.  The assumption is that uids less than or equal to this
value are special uids (root, bin, daemon, etc.--not real system
users) and that files owned by these users should not change ownership,
even if your system policy allows users other than root to edit them.

The default is 200; set the variable to nil to disable the feature.

** The rectangle commands now avoid inserting undesirable spaces,
notably at the end of lines.

All these functions have been rewritten to avoid inserting unwanted
spaces, and an optional prefix now allows them to behave the old way.

** The function `replace-rectangle' is an alias for `string-rectangle'.

** The new command M-x string-insert-rectangle is like `string-rectangle',
but inserts text instead of replacing it.

** The new command M-x query-replace-regexp-eval acts like
query-replace-regexp, but takes a Lisp expression which is evaluated
after each match to get the replacement text.

** M-x query-replace recognizes a new command `e' (or `E') that lets
you edit the replacement string.

** The new command mail-abbrev-complete-alias, bound to `M-TAB'
(if you load the library `mailabbrev'), lets you complete mail aliases
in the text, analogous to lisp-complete-symbol.

** The variable `echo-keystrokes' may now have a floating point value.

** If your init file is compiled (.emacs.elc), `user-init-file' is set
to the source name (.emacs.el), if that exists, after loading it.

** The help string specified for a menu-item whose definition contains
the property `:help HELP' is now displayed under X, on MS-Windows, and
MS-DOS, either in the echo area or with tooltips.  Many standard menus
displayed by Emacs now have help strings.

--
** New user option `read-mail-command' specifies a command to use to
read mail from the menu etc.

** The environment variable `EMACSLOCKDIR' is no longer used on MS-Windows.
This environment variable was used when creating lock files.  Emacs on
MS-Windows does not use this variable anymore.  This change was made
before Emacs 21.1, but wasn't documented until now.

** Highlighting of mouse-sensitive regions is now supported in the
MS-DOS version of Emacs.

** The new command `msdos-set-mouse-buttons' forces the MS-DOS version
of Emacs to behave as if the mouse had a specified number of buttons.
This comes handy with mice that don't report their number of buttons
correctly.  One example is the wheeled mice, which report 3 buttons,
but clicks on the middle button are not passed to the MS-DOS version
of Emacs.

** Customize changes

*** Customize now supports comments about customized items.  Use the
`State' menu to add comments, or give a prefix argument to
M-x customize-set-variable or M-x customize-set-value.  Note that
customization comments will cause the customizations to fail in
earlier versions of Emacs.

*** The new option `custom-buffer-done-function' says whether to kill
Custom buffers when you've done with them or just bury them (the
default).

*** If Emacs was invoked with the `-q' or `--no-init-file' options, it
does not allow you to save customizations in your `~/.emacs' init
file.  This is because saving customizations from such a session would
wipe out all the other customizationss you might have on your init
file.

** If Emacs was invoked with the `-q' or `--no-init-file' options, it
does not save disabled and enabled commands for future sessions, to
avoid overwriting existing customizations of this kind that are
already in your init file.

** New features in evaluation commands

*** The commands to evaluate Lisp expressions, such as C-M-x in Lisp
modes, C-j in Lisp Interaction mode, and M-:, now bind the variables
print-level, print-length, and debug-on-error based on the new
customizable variables eval-expression-print-level,
eval-expression-print-length, and eval-expression-debug-on-error.

The default values for the first two of these variables are 12 and 4
respectively, which means that `eval-expression' now prints at most
the first 12 members of a list and at most 4 nesting levels deep (if
the list is longer or deeper than that, an ellipsis `...'  is
printed).

<RET> or <mouse-2> on the printed text toggles between an abbreviated
printed representation and an unabbreviated one.

The default value of eval-expression-debug-on-error is t, so any error
during evaluation produces a backtrace.

*** The function `eval-defun' (C-M-x) now loads Edebug and instruments
code when called with a prefix argument.

** CC mode changes.

Note: This release contains changes that might not be compatible with
current user setups (although it's believed that these
incompatibilities will only show in very uncommon circumstances).
However, since the impact is uncertain, these changes may be rolled
back depending on user feedback.  Therefore there's no forward
compatibility guarantee wrt the new features introduced in this
release.

*** The hardcoded switch to "java" style in Java mode is gone.
CC Mode used to automatically set the style to "java" when Java mode
is entered.  This has now been removed since it caused too much
confusion.

However, to keep backward compatibility to a certain extent, the
default value for c-default-style now specifies the "java" style for
java-mode, but "gnu" for all other modes (as before).  So you won't
notice the change if you haven't touched that variable.

*** New cleanups, space-before-funcall and compact-empty-funcall.
Two new cleanups have been added to c-cleanup-list:

space-before-funcall causes a space to be inserted before the opening
parenthesis of a function call, which gives the style "foo (bar)".

compact-empty-funcall causes any space before a function call opening
parenthesis to be removed if there are no arguments to the function.
It's typically useful together with space-before-funcall to get the
style "foo (bar)" and "foo()".

*** Some keywords now automatically trigger reindentation.
Keywords like "else", "while", "catch" and "finally" have been made
"electric" to make them reindent automatically when they continue an
earlier statement.  An example:

for (i = 0; i < 17; i++)
  if (a[i])
    res += a[i]->offset;
else

Here, the "else" should be indented like the preceding "if", since it
continues that statement. CC Mode will automatically reindent it after
the "else" has been typed in full, since it's not until then it's
possible to decide whether it's a new statement or a continuation of
the preceding "if".

CC Mode uses Abbrev mode to achieve this, which is therefore turned on
by default.

*** M-a and M-e now moves by sentence in multiline strings.
Previously these two keys only moved by sentence in comments, which
meant that sentence movement didn't work in strings containing
documentation or other natural language text.

The reason it's only activated in multiline strings (i.e. strings that
contain a newline, even when escaped by a '\') is to avoid stopping in
the short strings that often reside inside statements.  Multiline
strings almost always contain text in a natural language, as opposed
to other strings that typically contain format specifications,
commands, etc.  Also, it's not that bothersome that M-a and M-e misses
sentences in single line strings, since they're short anyway.

*** Support for autodoc comments in Pike mode.
Autodoc comments for Pike are used to extract documentation from the
source, like Javadoc in Java.  Pike mode now recognize this markup in
comment prefixes and paragraph starts.

*** The comment prefix regexps on c-comment-prefix may be mode specific.
When c-comment-prefix is an association list, it specifies the comment
line prefix on a per-mode basis, like c-default-style does.  This
change came about to support the special autodoc comment prefix in
Pike mode only.

*** Better handling of syntactic errors.
The recovery after unbalanced parens earlier in the buffer has been
improved; CC Mode now reports them by dinging and giving a message
stating the offending line, but still recovers and indent the
following lines in a sane way (most of the time).  An "else" with no
matching "if" is handled similarly.  If an error is discovered while
indenting a region, the whole region is still indented and the error
is reported afterwards.

*** Lineup functions may now return absolute columns.
A lineup function can give an absolute column to indent the line to by
returning a vector with the desired column as the first element.

*** More robust and warning-free byte compilation.
Although this is strictly not a user visible change (well, depending
on the view of a user), it's still worth mentioning that CC Mode now
can be compiled in the standard ways without causing trouble.  Some
code have also been moved between the subpackages to enhance the
modularity somewhat.  Thanks to Martin Buchholz for doing the
groundwork.

*** c-style-variables-are-local-p now defaults to t.
This is an incompatible change that has been made to make the behavior
of the style system wrt global variable settings less confusing for
non-advanced users.  If you know what this variable does you might
want to set it to nil in your .emacs, otherwise you probably don't
have to bother.

Defaulting c-style-variables-are-local-p to t avoids the confusing
situation that occurs when a user sets some style variables globally
and edits both a Java and a non-Java file in the same Emacs session.
If the style variables aren't buffer local in this case, loading of
the second file will cause the default style (either "gnu" or "java"
by default) to override the global settings made by the user.

*** New initialization procedure for the style system.
When the initial style for a buffer is determined by CC Mode (from the
variable c-default-style), the global values of style variables now
take precedence over the values specified by the chosen style.  This
is different than the old behavior: previously, the style-specific
settings would override the global settings.  This change makes it
possible to do simple configuration in the intuitive way with
Customize or with setq lines in one's .emacs file.

By default, the global value of every style variable is the new
special symbol set-from-style, which causes the value to be taken from
the style system.  This means that in effect, only an explicit setting
of a style variable will cause the "overriding" behavior described
above.

Also note that global settings override style-specific settings *only*
when the initial style of a buffer is chosen by a CC Mode major mode
function.  When a style is chosen in other ways --- for example, by a
call like (c-set-style "gnu") in a hook, or via M-x c-set-style ---
then the style-specific values take precedence over any global style
values.  In Lisp terms, global values override style-specific values
only when the new second argument to c-set-style is non-nil; see the
function documentation for more info.

The purpose of these changes is to make it easier for users,
especially novice users, to do simple customizations with Customize or
with setq in their .emacs files.  On the other hand, the new system is
intended to be compatible with advanced users' customizations as well,
such as those that choose styles in hooks or whatnot.  This new system
is believed to be almost entirely compatible with current
configurations, in spite of the changed precedence between style and
global variable settings when a buffer's default style is set.

(Thanks to Eric Eide for clarifying this explanation a bit.)

**** c-offsets-alist is now a customizable variable.
This became possible as a result of the new initialization behavior.

This variable is treated slightly differently from the other style
variables; instead of using the symbol set-from-style, it will be
completed with the syntactic symbols it doesn't already contain when
the style is first initialized.  This means it now defaults to the
empty list to make all syntactic elements get their values from the
style system.

**** Compatibility variable to restore the old behavior.
In case your configuration doesn't work with this change, you can set
c-old-style-variable-behavior to non-nil to get the old behavior back
as far as possible.

*** Improvements to line breaking and text filling.
CC Mode now handles this more intelligently and seamlessly wrt the
surrounding code, especially inside comments.  For details see the new
chapter about this in the manual.

**** New variable to recognize comment line prefix decorations.
The variable c-comment-prefix-regexp has been added to properly
recognize the line prefix in both block and line comments.  It's
primarily used to initialize the various paragraph recognition and
adaptive filling variables that the text handling functions uses.

**** New variable c-block-comment-prefix.
This is a generalization of the now obsolete variable
c-comment-continuation-stars to handle arbitrary strings.

**** CC Mode now uses adaptive fill mode.
This to make it adapt better to the paragraph style inside comments.

It's also possible to use other adaptive filling packages inside CC
Mode, notably Kyle E. Jones' Filladapt mode (http://wonderworks.com/).
A new convenience function c-setup-filladapt sets up Filladapt for use
inside CC Mode.

Note though that the 2.12 version of Filladapt lacks a feature that
causes it to work suboptimally when c-comment-prefix-regexp can match
the empty string (which it commonly does).  A patch for that is
available from the CC Mode web site (http://www.python.org/emacs/
cc-mode/).

**** The variables `c-hanging-comment-starter-p' and
`c-hanging-comment-ender-p', which controlled how comment starters and
enders were filled, are not used anymore.  The new version of the
function `c-fill-paragraph' keeps the comment starters and enders as
they were before the filling.

**** It's now possible to selectively turn off auto filling.
The variable c-ignore-auto-fill is used to ignore auto fill mode in
specific contexts, e.g. in preprocessor directives and in string
literals.

**** New context sensitive line break function c-context-line-break.
It works like newline-and-indent in normal code, and adapts the line
prefix according to the comment style when used inside comments.  If
you're normally using newline-and-indent, you might want to switch to
this function.

*** Fixes to IDL mode.
It now does a better job in recognizing only the constructs relevant
to IDL.  E.g. it no longer matches "class" as the beginning of a
struct block, but it does match the CORBA 2.3 "valuetype" keyword.
Thanks to Eric Eide.

*** Improvements to the Whitesmith style.
It now keeps the style consistently on all levels and both when
opening braces hangs and when they don't.

**** New lineup function c-lineup-whitesmith-in-block.

*** New lineup functions c-lineup-template-args and c-indent-multi-line-block.
See their docstrings for details.  c-lineup-template-args does a
better job of tracking the brackets used as parens in C++ templates,
and is used by default to line up continued template arguments.

*** c-lineup-comment now preserves alignment with a comment on the
previous line.  It used to instead preserve comments that started in
the column specified by comment-column.

*** c-lineup-C-comments handles "free form" text comments.
In comments with a long delimiter line at the start, the indentation
is kept unchanged for lines that start with an empty comment line
prefix.  This is intended for the type of large block comments that
contain documentation with its own formatting.  In these you normally
don't want CC Mode to change the indentation.

*** The `c' syntactic symbol is now relative to the comment start
instead of the previous line, to make integers usable as lineup
arguments.

*** All lineup functions have gotten docstrings.

*** More preprocessor directive movement functions.
c-down-conditional does the reverse of c-up-conditional.
c-up-conditional-with-else and c-down-conditional-with-else are
variants of these that also stops at "#else" lines (suggested by Don
Provan).

*** Minor improvements to many movement functions in tricky situations.

** Dired changes

*** New variable `dired-recursive-deletes' determines if the delete
command will delete non-empty directories recursively.  The default
is, delete only empty directories.

*** New variable `dired-recursive-copies' determines if the copy
command will copy directories recursively.  The default is, do not
copy directories recursively.

*** In command `dired-do-shell-command' (usually bound to `!') a `?'
in the shell command has a special meaning similar to `*', but with
the difference that the command will be run on each file individually.

*** The new command `dired-find-alternate-file' (usually bound to `a')
replaces the Dired buffer with the buffer for an alternate file or
directory.

*** The new command `dired-show-file-type' (usually bound to `y') shows
a message in the echo area describing what type of file the point is on.
This command invokes the external program `file' do its work, and so
will only work on systems with that program, and will be only as
accurate or inaccurate as it is.

*** Dired now properly handles undo changes of adding/removing `-R'
from ls switches.

*** Dired commands that prompt for a destination file now allow the use
of the `M-n' command in the minibuffer to insert the source filename,
which the user can then edit.  This only works if there is a single
source file, not when operating on multiple marked files.

** Gnus changes.

The Gnus NEWS entries are short, but they reflect sweeping changes in
four areas: Article display treatment, MIME treatment,
internationalization and mail-fetching.

*** The mail-fetching functions have changed.  See the manual for the
many details.  In particular, all procmail fetching variables are gone.

If you used procmail like in

(setq nnmail-use-procmail t)
(setq nnmail-spool-file 'procmail)
(setq nnmail-procmail-directory "~/mail/incoming/")
(setq nnmail-procmail-suffix "\\.in")

this now has changed to

(setq mail-sources
      '((directory :path "~/mail/incoming/"
		   :suffix ".in")))

More information is available in the info doc at Select Methods ->
Getting Mail -> Mail Sources

*** Gnus is now a MIME-capable reader.  This affects many parts of
Gnus, and adds a slew of new commands.  See the manual for details.
Separate MIME packages like RMIME, mime-compose etc., will probably no
longer work; remove them and use the native facilities.

The FLIM/SEMI package still works with Emacs 21, but if you want to
use the native facilities, you must remove any mailcap.el[c] that was
installed by FLIM/SEMI version 1.13 or earlier.

*** Gnus has also been multilingualized.  This also affects too many
parts of Gnus to summarize here, and adds many new variables.  There
are built-in facilities equivalent to those of gnus-mule.el, which is
now just a compatibility layer.

*** gnus-mule.el is now just a compatibility layer over the built-in
Gnus facilities.

*** gnus-auto-select-first can now be a function to be
called to position point.

*** The user can now decide which extra headers should be included in
summary buffers and NOV files.

*** `gnus-article-display-hook' has been removed.  Instead, a number
of variables starting with `gnus-treat-' have been added.

*** The Gnus posting styles have been redone again and now work in a
subtly different manner.

*** New web-based backends have been added: nnslashdot, nnwarchive
and nnultimate.  nnweb has been revamped, again, to keep up with
ever-changing layouts.

*** Gnus can now read IMAP mail via nnimap.

*** There is image support of various kinds and some sound support.

** Changes in Texinfo mode.

*** A couple of new key bindings have been added for inserting Texinfo
macros

  Key binding	Macro
  -------------------------
  C-c C-c C-s	@strong
  C-c C-c C-e	@emph
  C-c C-c u	@uref
  C-c C-c q     @quotation
  C-c C-c m	@email
  C-c C-o       @<block> ... @end <block>
  M-RET         @item

*** The " key now inserts either " or `` or '' depending on context.

** Changes in Outline mode.

There is now support for Imenu to index headings.  A new command
`outline-headers-as-kill' copies the visible headings in the region to
the kill ring, e.g. to produce a table of contents.

** Changes to Emacs Server

*** The new option `server-kill-new-buffers' specifies what to do
with buffers when done with them.  If non-nil, the default, buffers
are killed, unless they were already present before visiting them with
Emacs Server.  If nil, `server-temp-file-regexp' specifies which
buffers to kill, as before.

Please note that only buffers are killed that still have a client,
i.e. buffers visited with `emacsclient --no-wait' are never killed in
this way.

** Both emacsclient and Emacs itself now accept command line options
of the form +LINE:COLUMN in addition to +LINE.

** Changes to Show Paren mode.

*** Overlays used by Show Paren mode now use a priority property.
The new user option show-paren-priority specifies the priority to
use.  Default is 1000.

** New command M-x check-parens can be used to find unbalanced paren
groups and strings in buffers in Lisp mode (or other modes).

** Changes to hideshow.el

*** Generalized block selection and traversal

A block is now recognized by its start and end regexps (both strings),
and an integer specifying which sub-expression in the start regexp
serves as the place where a `forward-sexp'-like function can operate.
See the documentation of variable `hs-special-modes-alist'.

*** During incremental search, if Hideshow minor mode is active,
hidden blocks are temporarily shown.  The variable `hs-headline' can
be used in the mode line format to show the line at the beginning of
the open block.

*** User option `hs-hide-all-non-comment-function' specifies a
function to be called at each top-level block beginning, instead of
the normal block-hiding function.

*** The command `hs-show-region' has been removed.

*** The key bindings have changed to fit the Emacs conventions,
roughly imitating those of Outline minor mode.  Notably, the prefix
for all bindings is now `C-c @'.  For details, see the documentation
for `hs-minor-mode'.

*** The variable `hs-show-hidden-short-form' has been removed, and
hideshow.el now always behaves as if this variable were set to t.

** Changes to Change Log mode and Add-Log functions

*** If you invoke `add-change-log-entry' from a backup file, it makes
an entry appropriate for the file's parent.  This is useful for making
log entries by comparing a version with deleted functions.

**** New command M-x change-log-merge merges another log into the
current buffer.

*** New command M-x change-log-redate fixes any old-style date entries
in a log file.

*** Change Log mode now adds a file's version number to change log
entries if user-option `change-log-version-info-enabled' is non-nil.
Unless the file is under version control the search for a file's
version number is performed based on regular expressions from
`change-log-version-number-regexp-list' which can be customized.
Version numbers are only found in the first 10 percent of a file.

*** Change Log mode now defines its own faces for font-lock highlighting.

** Changes to cmuscheme

*** The user-option `scheme-program-name' has been renamed
`cmuscheme-program-name' due to conflicts with xscheme.el.

** Changes in Font Lock

*** The new function `font-lock-remove-keywords' can be used to remove
font-lock keywords from the current buffer or from a specific major mode.

*** Multi-line patterns are now supported.  Modes using this, should
set font-lock-multiline to t in their font-lock-defaults.

*** `font-lock-syntactic-face-function' allows major-modes to choose
the face used for each string/comment.

*** A new standard face `font-lock-doc-face'.
Meant for Lisp docstrings, Javadoc comments and other "documentation in code".

** Changes to Shell mode

*** The `shell' command now accepts an optional argument to specify the buffer
to use, which defaults to "*shell*".  When used interactively, a
non-default buffer may be specified by giving the `shell' command a
prefix argument (causing it to prompt for the buffer name).

** Comint (subshell) changes

These changes generally affect all modes derived from comint mode, which
include shell-mode, gdb-mode, scheme-interaction-mode, etc.

*** Comint now by default interprets some carriage-control characters.
Comint now removes CRs from CR LF sequences, and treats single CRs and
BSs in the output in a way similar to a terminal (by deleting to the
beginning of the line, or deleting the previous character,
respectively).  This is achieved by adding `comint-carriage-motion' to
the `comint-output-filter-functions' hook by default.

*** By default, comint no longer uses the variable `comint-prompt-regexp'
to distinguish prompts from user-input.  Instead, it notices which
parts of the text were output by the process, and which entered by the
user, and attaches `field' properties to allow emacs commands to use
this information.  Common movement commands, notably beginning-of-line,
respect field boundaries in a fairly natural manner.  To disable this
feature, and use the old behavior, customize the user option
`comint-use-prompt-regexp-instead-of-fields'.

*** Comint now includes new features to send commands to running processes
and redirect the output to a designated buffer or buffers.

*** The command M-x comint-redirect-send-command reads a command and
buffer name from the mini-buffer.  The command is sent to the current
buffer's process, and its output is inserted into the specified buffer.

The command M-x comint-redirect-send-command-to-process acts like
M-x comint-redirect-send-command but additionally reads the name of
the buffer whose process should be used from the mini-buffer.

*** Packages based on comint now highlight user input and program prompts,
and support choosing previous input with mouse-2.  To control these features,
see the user-options `comint-highlight-input' and `comint-highlight-prompt'.

*** The new command `comint-write-output' (usually bound to `C-c C-s')
saves the output from the most recent command to a file.  With a prefix
argument, it appends to the file.

*** The command `comint-kill-output' has been renamed `comint-delete-output'
(usually bound to `C-c C-o'); the old name is aliased to it for
compatibility.

*** The new function `comint-add-to-input-history' adds commands to the input
ring (history).

*** The new variable `comint-input-history-ignore' is a regexp for
identifying history lines that should be ignored, like tcsh time-stamp
strings, starting with a `#'.  The default value of this variable is "^#".

** Changes to Rmail mode

*** The new user-option rmail-user-mail-address-regexp can be
set to fine tune the identification of the correspondent when
receiving new mail.  If it matches the address of the sender, the
recipient is taken as correspondent of a mail.  If nil, the default,
`user-login-name' and `user-mail-address' are used to exclude yourself
as correspondent.

Usually you don't have to set this variable, except if you collect
mails sent by you under different user names.  Then it should be a
regexp matching your mail addresses.

*** The new user-option rmail-confirm-expunge controls whether and how
to ask for confirmation before expunging deleted messages from an
Rmail file.  You can choose between no confirmation, confirmation
with y-or-n-p, or confirmation with yes-or-no-p.  Default is to ask
for confirmation with yes-or-no-p.

*** RET is now bound in the Rmail summary to rmail-summary-goto-msg,
like `j'.

*** There is a new user option `rmail-digest-end-regexps' that
specifies the regular expressions to detect the line that ends a
digest message.

*** The new user option `rmail-automatic-folder-directives' specifies
in which folder to put messages automatically.

*** The new function `rmail-redecode-body' allows to fix a message
with non-ASCII characters if Emacs happens to decode it incorrectly
due to missing or malformed "charset=" header.

** The new user-option `mail-envelope-from' can be used to specify
an envelope-from address different from user-mail-address.

** The variable mail-specify-envelope-from controls whether to
use the -f option when sending mail.

** The Rmail command `o' (`rmail-output-to-rmail-file') now writes the
current message in the internal `emacs-mule' encoding, rather than in
the encoding taken from the variable `buffer-file-coding-system'.
This allows to save messages whose characters cannot be safely encoded
by the buffer's coding system, and makes sure the message will be
displayed correctly when you later visit the target Rmail file.

If you want your Rmail files be encoded in a specific coding system
other than `emacs-mule', you can customize the variable
`rmail-file-coding-system' to set its value to that coding system.

** Changes to TeX mode

*** The default mode has been changed from `plain-tex-mode' to
`latex-mode'.

*** latex-mode now has a simple indentation algorithm.

*** M-f and M-p jump around \begin...\end pairs.

*** Added support for outline-minor-mode.

** Changes to RefTeX mode

*** RefTeX has new support for index generation.  Index entries can be
    created with `C-c <', with completion available on index keys.
    Pressing `C-c /' indexes the word at the cursor with a default
    macro.  `C-c >' compiles all index entries into an alphabetically
    sorted *Index* buffer which looks like the final index.  Entries
    can be edited from that buffer.

*** Label and citation key selection now allow to select several
    items and reference them together (use `m' to mark items, `a' or
    `A' to use all marked entries).

*** reftex.el has been split into a number of smaller files to reduce
    memory use when only a part of RefTeX is being used.

*** a new command `reftex-view-crossref-from-bibtex' (bound to `C-c &'
    in BibTeX-mode) can be called in a BibTeX database buffer in order
    to show locations in LaTeX documents where a particular entry has
    been cited.

** Emacs Lisp mode now allows multiple levels of outline headings.
The level of a heading is determined from the number of leading
semicolons in a heading line.  Toplevel forms starting with a `('
in column 1 are always made leaves.

** The M-x time-stamp command (most commonly used on write-file-hooks)
has the following new features:

*** The patterns for finding the time stamp and for updating a pattern
may match text spanning multiple lines.  For example, some people like
to have the filename and date on separate lines.  The new variable
time-stamp-inserts-lines controls the matching for multi-line patterns.

*** More than one time stamp can be updated in the same file.  This
feature is useful if you need separate time stamps in a program source
file to both include in formatted documentation and insert in the
compiled binary.  The same time-stamp will be written at each matching
pattern.  The variable time-stamp-count enables this new feature; it
defaults to 1.

** Partial Completion mode now completes environment variables in
file names.

** Ispell changes

*** The command `ispell' now spell-checks a region if
transient-mark-mode is on, and the mark is active.  Otherwise it
spell-checks the current buffer.

*** Support for synchronous subprocesses - DOS/Windoze - has been
added.

*** An "alignment error" bug was fixed when a manual spelling
correction is made and re-checked.

*** Italian, Portuguese, and Slovak dictionary definitions have been added.

*** Region skipping performance has been vastly improved in some
cases.

*** Spell checking HTML buffers has been improved and isn't so strict
on syntax errors.

*** The buffer-local words are now always placed on a new line at the
end of the buffer.

*** Spell checking now works in the MS-DOS version of Emacs.

** Makefile mode changes

*** The mode now uses the abbrev table `makefile-mode-abbrev-table'.

*** Conditionals and include statements are now highlighted when
Fontlock mode is active.

** Isearch changes

*** Isearch now puts a call to `isearch-resume' in the command history,
so that searches can be resumed.

*** In Isearch mode, C-M-s and C-M-r are now bound like C-s and C-r,
respectively, i.e. you can repeat a regexp isearch with the same keys
that started the search.

*** In Isearch mode, mouse-2 in the echo area now yanks the current
selection into the search string rather than giving an error.

*** There is a new lazy highlighting feature in incremental search.

Lazy highlighting is switched on/off by customizing variable
`isearch-lazy-highlight'.  When active, all matches for the current
search string are highlighted.  The current match is highlighted as
before using face `isearch' or `region'.  All other matches are
highlighted using face `isearch-lazy-highlight-face' which defaults to
`secondary-selection'.

The extra highlighting makes it easier to anticipate where the cursor
will end up each time you press C-s or C-r to repeat a pending search.
Highlighting of these additional matches happens in a deferred fashion
using "idle timers," so the cycles needed do not rob isearch of its
usual snappy response.

If `isearch-lazy-highlight-cleanup' is set to t, highlights for
matches are automatically cleared when you end the search.  If it is
set to nil, you can remove the highlights manually with `M-x
isearch-lazy-highlight-cleanup'.

** VC Changes

VC has been overhauled internally.  It is now modular, making it
easier to plug-in arbitrary version control backends.  (See Lisp
Changes for details on the new structure.)  As a result, the mechanism
to enable and disable support for particular version systems has
changed: everything is now controlled by the new variable
`vc-handled-backends'.  Its value is a list of symbols that identify
version systems; the default is '(RCS CVS SCCS).  When finding a file,
each of the backends in that list is tried in order to see whether the
file is registered in that backend.

When registering a new file, VC first tries each of the listed
backends to see if any of them considers itself "responsible" for the
directory of the file (e.g. because a corresponding subdirectory for
master files exists).  If none of the backends is responsible, then
the first backend in the list that could register the file is chosen.
As a consequence, the variable `vc-default-back-end' is now obsolete.

The old variable `vc-master-templates' is also obsolete, although VC
still supports it for backward compatibility.  To define templates for
RCS or SCCS, you should rather use the new variables
vc-{rcs,sccs}-master-templates.  (There is no such feature under CVS
where it doesn't make sense.)

The variables `vc-ignore-vc-files' and `vc-handle-cvs' are also
obsolete now, you must set `vc-handled-backends' to nil or exclude
`CVS' from the list, respectively, to achieve their effect now.

*** General Changes

The variable `vc-checkout-carefully' is obsolete: the corresponding
checks are always done now.

VC Dired buffers are now kept up-to-date during all version control
operations.

`vc-diff' output is now displayed in `diff-mode'.
`vc-print-log' uses `log-view-mode'.
`vc-log-mode' (used for *VC-Log*) has been replaced by `log-edit-mode'.

The command C-x v m (vc-merge) now accepts an empty argument as the
first revision number.  This means that any recent changes on the
current branch should be picked up from the repository and merged into
the working file (``merge news'').

The commands C-x v s (vc-create-snapshot) and C-x v r
(vc-retrieve-snapshot) now ask for a directory name from which to work
downwards.

*** Multiple Backends

VC now lets you register files in more than one backend.  This is
useful, for example, if you are working with a slow remote CVS
repository.  You can then use RCS for local editing, and occasionally
commit your changes back to CVS, or pick up changes from CVS into your
local RCS archives.

To make this work, the ``more local'' backend (RCS in our example)
should come first in `vc-handled-backends', and the ``more remote''
backend (CVS) should come later.  (The default value of
`vc-handled-backends' already has it that way.)

You can then commit changes to another backend (say, RCS), by typing
C-u C-x v v RCS RET (i.e. vc-next-action now accepts a backend name as
a revision number).  VC registers the file in the more local backend
if that hasn't already happened, and commits to a branch based on the
current revision number from the more remote backend.

If a file is registered in multiple backends, you can switch to
another one using C-x v b (vc-switch-backend).  This does not change
any files, it only changes VC's perspective on the file.  Use this to
pick up changes from CVS while working under RCS locally.

After you are done with your local RCS editing, you can commit your
changes back to CVS using C-u C-x v v CVS RET.  In this case, the
local RCS archive is removed after the commit, and the log entry
buffer is initialized to contain the entire RCS change log of the file.

*** Changes for CVS

There is a new user option, `vc-cvs-stay-local'.  If it is `t' (the
default), then VC avoids network queries for files registered in
remote repositories.  The state of such files is then only determined
by heuristics and past information.  `vc-cvs-stay-local' can also be a
regexp to match against repository hostnames; only files from hosts
that match it are treated locally.  If the variable is nil, then VC
queries the repository just as often as it does for local files.

If `vc-cvs-stay-local' is on, then VC also makes local backups of
repository versions.  This means that ordinary diffs (C-x v =) and
revert operations (C-x v u) can be done completely locally, without
any repository interactions at all.  The name of a local version
backup of FILE is FILE.~REV.~, where REV is the repository version
number.  This format is similar to that used by C-x v ~
(vc-version-other-window), except for the trailing dot.  As a matter
of fact, the two features can each use the files created by the other,
the only difference being that files with a trailing `.' are deleted
automatically after commit.  (This feature doesn't work on MS-DOS,
since DOS disallows more than a single dot in the trunk of a file
name.)

If `vc-cvs-stay-local' is on, and there have been changes in the
repository, VC notifies you about it when you actually try to commit.
If you want to check for updates from the repository without trying to
commit, you can either use C-x v m RET to perform an update on the
current file, or you can use C-x v r RET to get an update for an
entire directory tree.

The new user option `vc-cvs-use-edit' indicates whether VC should call
"cvs edit" to make files writeable; it defaults to `t'.  (This option
is only meaningful if the CVSREAD variable is set, or if files are
"watched" by other developers.)

The commands C-x v s (vc-create-snapshot) and C-x v r
(vc-retrieve-snapshot) are now also implemented for CVS.  If you give
an empty snapshot name to the latter, that performs a `cvs update',
starting at the given directory.

*** Lisp Changes in VC

VC has been restructured internally to make it modular.  You can now
add support for arbitrary version control backends by writing a
library that provides a certain set of backend-specific functions, and
then telling VC to use that library.  For example, to add support for
a version system named SYS, you write a library named vc-sys.el, which
provides a number of functions vc-sys-... (see commentary at the top
of vc.el for a detailed list of them).  To make VC use that library,
you need to put it somewhere into Emacs' load path and add the symbol
`SYS' to the list `vc-handled-backends'.

** The customizable EDT emulation package now supports the EDT
SUBS command and EDT scroll margins.  It also works with more
terminal/keyboard configurations and it now works under XEmacs.
See etc/edt-user.doc for more information.

** New modes and packages

*** The new global minor mode `minibuffer-electric-default-mode'
automatically hides the `(default ...)' part of minibuffer prompts when
the default is not applicable.

*** Artist is an Emacs lisp package that allows you to draw lines,
rectangles and ellipses by using your mouse and/or keyboard.  The
shapes are made up with the ascii characters |, -, / and \.

Features are:

- Intersecting: When a `|' intersects with a `-', a `+' is
  drawn, like this:   |         \ /
                    --+--        X
                      |         / \

- Rubber-banding: When drawing lines you can interactively see the
  result while holding the mouse button down and moving the mouse.  If
  your machine is not fast enough (a 386 is a bit too slow, but a
  pentium is well enough), you can turn this feature off.  You will
  then see 1's and 2's which mark the 1st and 2nd endpoint of the line
  you are drawing.

- Arrows: After having drawn a (straight) line or a (straight)
  poly-line, you can set arrows on the line-ends by typing < or >.

- Flood-filling: You can fill any area with a certain character by
  flood-filling.

- Cut copy and paste: You can cut, copy and paste rectangular
  regions.  Artist also interfaces with the rect package (this can be
  turned off if it causes you any trouble) so anything you cut in
  artist can be yanked with C-x r y and vice versa.

- Drawing with keys: Everything you can do with the mouse, you can
  also do without the mouse.

- Aspect-ratio: You can set the variable artist-aspect-ratio to
  reflect the height-width ratio for the font you are using. Squares
  and circles are then drawn square/round.  Note, that once your
  ascii-file is shown with font with a different height-width ratio,
  the squares won't be square and the circles won't be round.

- Drawing operations: The following drawing operations are implemented:

    lines		straight-lines
    rectangles		squares
    poly-lines		straight poly-lines
    ellipses		circles
    text (see-thru)	text (overwrite)
    spray-can		setting size for spraying
    vaporize line	vaporize lines
    erase characters	erase rectangles

  Straight lines are lines that go horizontally, vertically or
  diagonally.  Plain lines go in any direction.  The operations in
  the right column are accessed by holding down the shift key while
  drawing.

  It is possible to vaporize (erase) entire lines and connected lines
  (rectangles for example) as long as the lines being vaporized are
  straight and connected at their endpoints.  Vaporizing is inspired
  by the drawrect package by Jari Aalto <jari.aalto@poboxes.com>.

- Picture mode compatibility: Artist is picture mode compatible (this
  can be turned off).

*** The new package Eshell is an operating system command shell
implemented entirely in Emacs Lisp.  Use `M-x eshell' to invoke it.
It functions similarly to bash and zsh, and allows running of Lisp
functions and external commands using the same syntax.  It supports
history lists, aliases, extended globbing, smart scrolling, etc.  It
will work on any platform Emacs has been ported to.  And since most of
the basic commands -- ls, rm, mv, cp, ln, du, cat, etc. -- have been
rewritten in Lisp, it offers an operating-system independent shell,
all within the scope of your Emacs process.

*** The new package timeclock.el is a mode is for keeping track of time
intervals.  You can use it for whatever purpose you like, but the
typical scenario is to keep track of how much time you spend working
on certain projects.

*** The new package hi-lock.el provides commands to highlight matches
of interactively entered regexps.  For example,

  M-x highlight-regexp RET clearly RET RET

will highlight all occurrences of `clearly' using a yellow background
face.  New occurrences of `clearly' will be highlighted as they are
typed.  `M-x unhighlight-regexp RET' will remove the highlighting.
Any existing face can be used for highlighting and a set of
appropriate faces is provided.  The regexps can be written into the
current buffer in a form that will be recognized the next time the
corresponding file is read.  There are commands to highlight matches
to phrases and to highlight entire lines containing a match.

*** The new package zone.el plays games with Emacs' display when
Emacs is idle.

*** The new package tildify.el allows to add hard spaces or other text
fragments in accordance with the current major mode.

*** The new package xml.el provides a simple but generic XML
parser. It doesn't parse the DTDs however.

*** The comment operations are now provided by the newcomment.el
package which allows different styles of comment-region and should
be more robust while offering the same functionality.
`comment-region' now doesn't always comment a-line-at-a-time, but only
comments the region, breaking the line at point if necessary.

*** The Ebrowse package implements a C++ class browser and tags
facilities tailored for use with C++.  It is documented in a
separate Texinfo file.

*** The PCL-CVS package available by either running M-x cvs-examine or
by visiting a CVS administrative directory (with a prefix argument)
provides an alternative interface to VC-dired for CVS.  It comes with
`log-view-mode' to view RCS and SCCS logs and `log-edit-mode' used to
enter check-in log messages.

*** The new package called `woman' allows to browse Unix man pages
without invoking external programs.

The command `M-x woman' formats manual pages entirely in Emacs Lisp
and then displays them, like `M-x manual-entry' does.  Unlike
`manual-entry', `woman' does not invoke any external programs, so it
is useful on systems such as MS-DOS/MS-Windows where the `man' and
Groff or `troff' commands are not readily available.

The command `M-x woman-find-file' asks for the file name of a man
page, then formats and displays it like `M-x woman' does.

*** The new command M-x re-builder offers a convenient interface for
authoring regular expressions with immediate visual feedback.

The buffer from which the command was called becomes the target for
the regexp editor popping up in a separate window.  Matching text in
the target buffer is immediately color marked during the editing.
Each sub-expression of the regexp will show up in a different face so
even complex regexps can be edited and verified on target data in a
single step.

On displays not supporting faces the matches instead blink like
matching parens to make them stand out.  On such a setup you will
probably also want to use the sub-expression mode when the regexp
contains such to get feedback about their respective limits.

*** glasses-mode is a minor mode that makes
unreadableIdentifiersLikeThis readable.  It works as glasses, without
actually modifying content of a buffer.

*** The package ebnf2ps translates an EBNF to a syntactic chart in
PostScript.

Currently accepts ad-hoc EBNF, ISO EBNF and Bison/Yacc.

The ad-hoc default EBNF syntax has the following elements:

    ;		comment (until end of line)
    A		non-terminal
    "C"		terminal
    ?C?		special
    $A		default non-terminal
    $"C"	default terminal
    $?C?	default special
    A = B.	production (A is the header and B the body)
    C D		sequence (C occurs before D)
    C | D	alternative (C or D occurs)
    A - B	exception (A excluding B, B without any non-terminal)
    n * A	repetition (A repeats n (integer) times)
    (C)		group (expression C is grouped together)
    [C]		optional (C may or not occurs)
    C+		one or more occurrences of C
    {C}+	one or more occurrences of C
    {C}*	zero or more occurrences of C
    {C}		zero or more occurrences of C
    C / D	equivalent to: C {D C}*
    {C || D}+	equivalent to: C {D C}*
    {C || D}*	equivalent to: [C {D C}*]
    {C || D}	equivalent to: [C {D C}*]

Please, see ebnf2ps documentation for EBNF syntax and how to use it.

*** The package align.el will align columns within a region, using M-x
align.  Its mode-specific rules, based on regular expressions,
determine where the columns should be split.  In C and C++, for
example, it will align variable names in declaration lists, or the
equal signs of assignments.

*** `paragraph-indent-minor-mode' is a new minor mode supporting
paragraphs in the same style as `paragraph-indent-text-mode'.

*** bs.el is a new package for buffer selection similar to
list-buffers or electric-buffer-list.  Use M-x bs-show to display a
buffer menu with this package.  See the Custom group `bs'.

*** find-lisp.el is a package emulating the Unix find command in Lisp.

*** calculator.el is a small calculator package that is intended to
replace desktop calculators such as xcalc and calc.exe.  Actually, it
is not too small - it has more features than most desktop calculators,
and can be customized easily to get many more functions.  It should
not be confused with "calc" which is a much bigger mathematical tool
which answers different needs.

*** The minor modes cwarn-mode and global-cwarn-mode highlights
suspicious C and C++ constructions.  Currently, assignments inside
expressions, semicolon following `if', `for' and `while' (except, of
course, after a `do .. while' statement), and C++ functions with
reference parameters are recognized.  The modes require font-lock mode
to be enabled.

*** smerge-mode.el provides `smerge-mode', a simple minor-mode for files
containing diff3-style conflict markers, such as generated by RCS.

*** 5x5.el is a simple puzzle game.

*** hl-line.el provides `hl-line-mode', a minor mode to highlight the
current line in the current buffer.  It also provides
`global-hl-line-mode' to provide the same behavior in all buffers.

*** ansi-color.el translates ANSI terminal escapes into text-properties.

Please note: if `ansi-color-for-comint-mode' and
`global-font-lock-mode' are non-nil, loading ansi-color.el will
disable font-lock and add `ansi-color-apply' to
`comint-preoutput-filter-functions' for all shell-mode buffers.  This
displays the output of "ls --color=yes" using the correct foreground
and background colors.

*** delphi.el provides a major mode for editing the Delphi (Object
Pascal) language.

*** quickurl.el provides a simple method of inserting a URL based on
the text at point.

*** sql.el provides an interface to SQL data bases.

*** fortune.el uses the fortune program to create mail/news signatures.

*** whitespace.el is a package for warning about and cleaning bogus
whitespace in a file.

*** PostScript mode (ps-mode) is a new major mode for editing PostScript
files. It offers: interaction with a PostScript interpreter, including
(very basic) error handling; fontification, easily customizable for
interpreter messages; auto-indentation; insertion of EPSF templates and
often used code snippets; viewing of BoundingBox; commenting out /
uncommenting regions; conversion of 8bit characters to PostScript octal
codes. All functionality is accessible through a menu.

*** delim-col helps to prettify columns in a text region or rectangle.

Here is an example of columns:

horse	apple	bus
dog	pineapple	car	EXTRA
porcupine	strawberry	airplane

Doing the following settings:

   (setq delimit-columns-str-before "[ ")
   (setq delimit-columns-str-after " ]")
   (setq delimit-columns-str-separator ", ")
   (setq delimit-columns-separator "\t")


Selecting the lines above and typing:

   M-x delimit-columns-region

It results:

[ horse    , apple     , bus     ,       ]
[ dog      , pineapple , car     , EXTRA ]
[ porcupine, strawberry, airplane,       ]

delim-col has the following options:

   delimit-columns-str-before		Specify a string to be inserted
					before all columns.

   delimit-columns-str-separator	Specify a string to be inserted
					between each column.

   delimit-columns-str-after		Specify a string to be inserted
					after all columns.

   delimit-columns-separator		Specify a regexp which separates
					each column.

delim-col has the following commands:

   delimit-columns-region	Prettify all columns in a text region.
   delimit-columns-rectangle	Prettify all columns in a text rectangle.

*** Recentf mode maintains a menu for visiting files that were
operated on recently.  User option recentf-menu-filter specifies a
menu filter function to change the menu appearance. For example, the
recent file list can be displayed:

- organized by major modes, directories or user defined rules.
- sorted by file paths, file names, ascending or descending.
- showing paths relative to the current default-directory

The `recentf-filter-changer' menu filter function allows to
dynamically change the menu appearance.

*** elide-head.el provides a mechanism for eliding boilerplate header
text.

*** footnote.el provides `footnote-mode', a minor mode supporting use
of footnotes.  It is intended for use with Message mode, but isn't
specific to Message mode.

*** diff-mode.el provides `diff-mode', a major mode for
viewing/editing context diffs (patches).  It is selected for files
with extension `.diff', `.diffs', `.patch' and `.rej'.

*** EUDC, the Emacs Unified Directory Client, provides a common user
interface to access directory servers using different directory
protocols.  It has a separate manual.

*** autoconf.el provides a major mode for editing configure.in files
for Autoconf, selected automatically.

*** windmove.el provides moving between windows.

*** crm.el provides a facility to read multiple strings from the
minibuffer with completion.

*** todo-mode.el provides management of TODO lists and integration
with the diary features.

*** autoarg.el provides a feature reported from Twenex Emacs whereby
numeric keys supply prefix args rather than self inserting.

*** The function `turn-off-auto-fill' unconditionally turns off Auto
Fill mode.

*** pcomplete.el is a library that provides programmable completion
facilities for Emacs, similar to what zsh and tcsh offer.  The main
difference is that completion functions are written in Lisp, meaning
they can be profiled, debugged, etc.

*** antlr-mode is a new major mode for editing ANTLR grammar files.
It is automatically turned on for files whose names have the extension
`.g'.

** Changes in sort.el

The function sort-numeric-fields interprets numbers starting with `0'
as octal and numbers starting with `0x' or `0X' as hexadecimal.  The
new user-option sort-numeric-base can be used to specify a default
numeric base.

** Changes to Ange-ftp

*** Ange-ftp allows you to specify of a port number in remote file
names cleanly.  It is appended to the host name, separated by a hash
sign, e.g. `/foo@bar.org#666:mumble'.  (This syntax comes from EFS.)

*** If the new user-option `ange-ftp-try-passive-mode' is set, passive
ftp mode will be used if the ftp client supports that.

*** Ange-ftp handles the output of the w32-style clients which
output ^M at the end of lines.

** The recommended way of using Iswitchb is via the new global minor
mode `iswitchb-mode'.

** Just loading the msb package doesn't switch on Msb mode anymore.
If you have `(require 'msb)' in your .emacs, please replace it with
`(msb-mode 1)'.

** Flyspell mode has various new options.  See the `flyspell' Custom
group.

** The user option `backward-delete-char-untabify-method' controls the
behavior of `backward-delete-char-untabify'.  The following values
are recognized:

`untabify' -- turn a tab to many spaces, then delete one space;
`hungry'   -- delete all whitespace, both tabs and spaces;
`all'      -- delete all whitespace, including tabs, spaces and newlines;
nil        -- just delete one character.

Default value is `untabify'.

[This change was made in Emacs 20.3 but not mentioned then.]

** In Cperl mode `cperl-invalid-face' should now be a normal face
symbol, not double-quoted.

** Some packages are declared obsolete, to be removed in a future
version.  They are:  auto-show, c-mode, hilit19, hscroll, ooutline,
profile, rnews, rnewspost, and sc.  Their implementations have been
moved to lisp/obsolete.

** auto-compression mode is no longer enabled just by loading jka-compr.el.
To control it, set `auto-compression-mode' via Custom or use the
`auto-compression-mode' command.

** `browse-url-gnome-moz' is a new option for
`browse-url-browser-function', invoking Mozilla in GNOME, and
`browse-url-kde' can be chosen for invoking the KDE browser.

** The user-option `browse-url-new-window-p' has been renamed to
`browse-url-new-window-flag'.

** The functions `keep-lines', `flush-lines' and `how-many' now
operate on the active region in Transient Mark mode.

** `gnus-user-agent' is a new possibility for `mail-user-agent'.  It
is like `message-user-agent', but with all the Gnus paraphernalia.

** The Strokes package has been updated.  If your Emacs has XPM
support, you can use it for pictographic editing.  In Strokes mode,
use C-mouse-2 to compose a complex stoke and insert it into the
buffer.  You can encode or decode a strokes buffer with new commands
M-x strokes-encode-buffer and M-x strokes-decode-buffer.  There is a
new command M-x strokes-list-strokes.

** Hexl contains a new command `hexl-insert-hex-string' which inserts
a string of hexadecimal numbers read from the mini-buffer.

** Hexl mode allows to insert non-ASCII characters.

The non-ASCII characters are encoded using the same encoding as the
file you are visiting in Hexl mode.

** Shell script mode changes.

Shell script mode (sh-script) can now indent scripts for shells
derived from sh and rc.  The indentation style is customizable, and
sh-script can attempt to "learn" the current buffer's style.

** Etags changes.

*** In DOS, etags looks for file.cgz if it cannot find file.c.

*** New option --ignore-case-regex is an alternative to --regex.  It is now
possible to bind a regexp to a language, by prepending the regexp with
{lang}, where lang is one of the languages that `etags --help' prints out.
This feature is useful especially for regex files, where each line contains
a regular expression.  The manual contains details.

*** In C and derived languages, etags creates tags for function
declarations when given the --declarations option.

*** In C++, tags are created for "operator".  The tags have the form
"operator+", without spaces between the keyword and the operator.

*** You shouldn't generally need any more the -C or -c++ option: etags
automatically switches to C++ parsing when it meets the `class' or
`template' keywords.

*** Etags now is able to delve at arbitrary deeps into nested structures in
C-like languages.  Previously, it was limited to one or two brace levels.

*** New language Ada: tags are functions, procedures, packages, tasks, and
types.

*** In Fortran, `procedure' is not tagged.

*** In Java, tags are created for "interface".

*** In Lisp, "(defstruct (foo", "(defun (operator" and similar constructs
are now tagged.

*** In makefiles, tags the targets.

*** In Perl, the --globals option tags global variables.  my and local
variables are tagged.

*** New language Python: def and class at the beginning of a line are tags.

*** .ss files are Scheme files, .pdb is Postscript with C syntax, .psw is
for PSWrap.

** Changes in etags.el

*** The new user-option tags-case-fold-search can be used to make
tags operations case-sensitive or case-insensitive.  The default
is to use the same setting as case-fold-search.

*** You can display additional output with M-x tags-apropos by setting
the new variable tags-apropos-additional-actions.

If non-nil, the variable's value should be a list of triples (TITLE
FUNCTION TO-SEARCH).  For each triple, M-x tags-apropos processes
TO-SEARCH and lists tags from it.  TO-SEARCH should be an alist,
obarray, or symbol.  If it is a symbol, the symbol's value is used.

TITLE is a string to use to label the list of tags from TO-SEARCH.

FUNCTION is a function to call when an entry is selected in the Tags
List buffer.  It is called with one argument, the selected symbol.

A useful example value for this variable might be something like:

  '(("Emacs Lisp" Info-goto-emacs-command-node obarray)
    ("Common Lisp" common-lisp-hyperspec common-lisp-hyperspec-obarray)
    ("SCWM" scwm-documentation scwm-obarray))

*** The face tags-tag-face can be used to customize the appearance
of tags in the output of M-x tags-apropos.

*** Setting tags-apropos-verbose to a non-nil value displays the
names of tags files in the *Tags List* buffer.

*** You can now search for tags that are part of the filename itself.
If you have tagged the files topfile.c subdir/subfile.c
/tmp/tempfile.c, you can now search for tags "topfile.c", "subfile.c",
"dir/sub", "tempfile", "tempfile.c".  If the tag matches the file name,
point will go to the beginning of the file.

*** Compressed files are now transparently supported if
auto-compression-mode is active.  You can tag (with Etags) and search
(with find-tag) both compressed and uncompressed files.

*** Tags commands like M-x tags-search no longer change point
in buffers where no match is found.  In buffers where a match is
found, the original value of point is pushed on the marker ring.

** Fortran mode has a new command `fortran-strip-sequence-nos' to
remove text past column 72.  The syntax class of `\' in Fortran is now
appropriate for C-style escape sequences in strings.

** SGML mode's default `sgml-validate-command' is now `nsgmls'.

** A new command `view-emacs-problems' (C-h P) displays the PROBLEMS file.

** The Dabbrev package has a new user-option `dabbrev-ignored-regexps'
containing a list of regular expressions.  Buffers matching a regular
expression from that list, are not checked.

** Emacs can now figure out modification times of remote files.
When you do C-x C-f /user@host:/path/file RET and edit the file,
and someone else modifies the file, you will be prompted to revert
the buffer, just like for the local files.

** The buffer menu (C-x C-b) no longer lists the *Buffer List* buffer.

** When invoked with a prefix argument, the command `list-abbrevs' now
displays local abbrevs, only.

** Refill minor mode provides preliminary support for keeping
paragraphs filled as you modify them.

** The variable `double-click-fuzz' specifies how much the mouse
may be moved between clicks that are recognized as a pair.  Its value
is measured in pixels.

** The new global minor mode `auto-image-file-mode' allows image files
to be visited as images.

** Two new user-options `grep-command' and `grep-find-command'
were added to compile.el.

** Withdrawn packages

*** mldrag.el has been removed.  mouse.el provides the same
functionality with aliases for the mldrag functions.

*** eval-reg.el has been obsoleted by changes to edebug.el and removed.

*** ph.el has been obsoleted by EUDC and removed.


* Incompatible Lisp changes

There are a few Lisp changes which are not backwards-compatible and
may require changes to existing code. Here is a list for reference.
See the sections below for details.

** Since `format' preserves text properties, the idiom
`(format "%s" foo)' no longer works to copy and remove properties.
Use `copy-sequence' to copy the string, then use `set-text-properties'
to remove the properties of the copy.

** Since the `keymap' text property now has significance, some code
which uses both `local-map' and `keymap' properties (for portability)
may, for instance, give rise to duplicate menus when the keymaps from
these properties are active.

** The change in the treatment of non-ASCII characters in search
ranges may affect some code.

** A non-nil value for the LOCAL arg of add-hook makes the hook
buffer-local even if `make-local-hook' hasn't been called, which might
make a difference to some code.

** The new treatment of the minibuffer prompt might affect code which
operates on the minibuffer.

** The new character sets `eight-bit-control' and `eight-bit-graphic'
cause `no-conversion' and `emacs-mule-unix' coding systems to produce
different results when reading files with non-ASCII characters
(previously, both coding systems would produce the same results).
Specifically, `no-conversion' interprets each 8-bit byte as a separate
character.  This makes `no-conversion' inappropriate for reading
multibyte text, e.g. buffers written to disk in their internal MULE
encoding (auto-saving does that, for example).  If a Lisp program
reads such files with `no-conversion', each byte of the multibyte
sequence, including the MULE leading codes such as \201, is treated as
a separate character, which prevents them from being interpreted in
the buffer as multibyte characters.

Therefore, Lisp programs that read files which contain the internal
MULE encoding should use `emacs-mule-unix'.  `no-conversion' is only
appropriate for reading truly binary files.

** Code that relies on the obsolete `before-change-function' and
`after-change-function' to detect buffer changes will now fail.  Use
`before-change-functions' and `after-change-functions' instead.

** Code that uses `concat' with integer args now gets an error, as
long promised.  So does any code that uses derivatives of `concat',
such as `mapconcat'.

** The function base64-decode-string now always returns a unibyte
string.

** Not a Lisp incompatibility as such but, with the introduction of
extra private charsets, there is now only one slot free for a new
dimension-2 private charset.  User code which tries to add more than
one extra will fail unless you rebuild Emacs with some standard
charset(s) removed; that is probably inadvisable because it changes
the emacs-mule encoding.  Also, files stored in the emacs-mule
encoding using Emacs 20 with additional private charsets defined will
probably not be read correctly by Emacs 21.

** The variable `directory-sep-char' is slated for removal.
Not really a change (yet), but a projected one that you should be
aware of: The variable `directory-sep-char' is deprecated, and should
not be used.  It was always ignored on GNU/Linux and Unix systems and
on MS-DOS, but the MS-Windows port tried to support it by adapting the
behavior of certain primitives to the value of this variable.  It
turned out that such support cannot be reliable, so it was decided to
remove this variable in the near future.  Lisp programs are well
advised not to set it to anything but '/', because any different value
will not have any effect when support for this variable is removed.


* Lisp changes made after edition 2.6 of the Emacs Lisp Manual,
(Display-related features are described in a page of their own below.)

** Function assq-delete-all replaces function assoc-delete-all.

** The new function animate-string, from lisp/play/animate.el
allows the animated display of strings.

** The new function `interactive-form' can be used to obtain the
interactive form of a function.

** The keyword :set-after in defcustom allows to specify dependencies
between custom options.  Example:

  (defcustom default-input-method nil
    "*Default input method for multilingual text (a string).
  This is the input method activated automatically by the command
  `toggle-input-method' (\\[toggle-input-method])."
    :group 'mule
    :type '(choice (const nil) string)
    :set-after '(current-language-environment))

This specifies that default-input-method should be set after
current-language-environment even if default-input-method appears
first in a custom-set-variables statement.

** The new hook `kbd-macro-termination-hook' is run at the end of
function execute-kbd-macro.  Functions on this hook are called with no
args.  The hook is run independent of how the macro was terminated
(signal or normal termination).

** Functions `butlast' and `nbutlast' for removing trailing elements
from a list are now available without requiring the CL package.

** The new user-option `even-window-heights' can be set to nil
to prevent `display-buffer' from evening out window heights.

** The user-option `face-font-registry-alternatives' specifies
alternative font registry names to try when looking for a font.

** Function `md5' calculates the MD5 "message digest"/"checksum".

** Function `delete-frame' runs `delete-frame-hook' before actually
deleting the frame.  The hook is called with one arg, the frame
being deleted.

** `add-hook' now makes the hook local if called with a non-nil LOCAL arg.

** The treatment of non-ASCII characters in search ranges has changed.
If a range in a regular expression or the arg of
skip-chars-forward/backward starts with a unibyte character C and ends
with a multibyte character C2, the range is divided into two: one is
C..?\377, the other is C1..C2, where C1 is the first character of C2's
charset.

** The new function `display-message-or-buffer' displays a message in
the echo area or pops up a buffer, depending on the length of the
message.

** The new macro `with-auto-compression-mode' allows evaluating an
expression with auto-compression-mode enabled.

** In image specifications, `:heuristic-mask' has been replaced
with the more general `:mask' property.

** Image specifications accept more `:conversion's.

** A `?' can be used in a symbol name without escaping it with a
backslash.

** Reading from the mini-buffer now reads from standard input if Emacs
is running in batch mode.  For example,

  (message "%s" (read t))

will read a Lisp expression from standard input and print the result
to standard output.

** The argument of `down-list', `backward-up-list', `up-list',
`kill-sexp', `backward-kill-sexp' and `mark-sexp' is now optional.

** If `display-buffer-reuse-frames' is set, function `display-buffer'
will raise frames displaying a buffer, instead of creating a new
frame or window.

** Two new functions for removing elements from lists/sequences
were added

- Function: remove ELT SEQ

Return a copy of SEQ with all occurrences of ELT removed.  SEQ must be
a list, vector, or string.  The comparison is done with `equal'.

- Function: remq ELT LIST

Return a copy of LIST with all occurrences of ELT removed.  The
comparison is done with `eq'.

** The function `delete' now also works with vectors and strings.

** The meaning of the `:weakness WEAK' argument of make-hash-table
has been changed: WEAK can now have new values `key-or-value' and
`key-and-value', in addition to `nil', `key', `value', and `t'.

** Function `aset' stores any multibyte character in any string
without signaling "Attempt to change char length of a string".  It may
convert a unibyte string to multibyte if necessary.

** The value of the `help-echo' text property is called as a function
or evaluated, if it is not a string already, to obtain a help string.

** Function `make-obsolete' now has an optional arg to say when the
function was declared obsolete.

** Function `plist-member' is renamed from `widget-plist-member' (which is
retained as an alias).

** Easy-menu's :filter now takes the unconverted form of the menu and
the result is automatically converted to Emacs' form.

** The new function `window-list' has been defined

- Function: window-list &optional FRAME WINDOW MINIBUF

Return a list of windows on FRAME, starting with WINDOW.  FRAME nil or
omitted means use the selected frame.  WINDOW nil or omitted means use
the selected window.  MINIBUF t means include the minibuffer window,
even if it isn't active.  MINIBUF nil or omitted means include the
minibuffer window only if it's active.  MINIBUF neither nil nor t
means never include the minibuffer window.

** There's a new function `get-window-with-predicate' defined as follows

- Function: get-window-with-predicate PREDICATE &optional MINIBUF ALL-FRAMES DEFAULT

Return a window satisfying PREDICATE.

This function cycles through all visible windows using `walk-windows',
calling PREDICATE on each one.  PREDICATE is called with a window as
argument.  The first window for which PREDICATE returns a non-nil
value is returned.  If no window satisfies PREDICATE, DEFAULT is
returned.

Optional second arg MINIBUF t means count the minibuffer window even
if not active.  MINIBUF nil or omitted means count the minibuffer iff
it is active.  MINIBUF neither t nor nil means not to count the
minibuffer even if it is active.

Several frames may share a single minibuffer; if the minibuffer
counts, all windows on all frames that share that minibuffer count
too.  Therefore, if you are using a separate minibuffer frame
and the minibuffer is active and MINIBUF says it counts,
`walk-windows' includes the windows in the frame from which you
entered the minibuffer, as well as the minibuffer window.

ALL-FRAMES is the optional third argument.
ALL-FRAMES nil or omitted means cycle within the frames as specified above.
ALL-FRAMES = `visible' means include windows on all visible frames.
ALL-FRAMES = 0 means include windows on all visible and iconified frames.
ALL-FRAMES = t means include windows on all frames including invisible frames.
If ALL-FRAMES is a frame, it means include windows on that frame.
Anything else means restrict to the selected frame.

** The function `single-key-description' now encloses function key and
event names in angle brackets.  When called with a second optional
argument non-nil, angle brackets won't be printed.

** If the variable `message-truncate-lines' is bound to t around a
call to `message', the echo area will not be resized to display that
message; it will be truncated instead, as it was done in 20.x.
Default value is nil.

** The user option `line-number-display-limit' can now be set to nil,
meaning no limit.

** The new user option `line-number-display-limit-width' controls
the maximum width of lines in a buffer for which Emacs displays line
numbers in the mode line.  The default is 200.

** `select-safe-coding-system' now also checks the most preferred
coding-system if buffer-file-coding-system is `undecided' and
DEFAULT-CODING-SYSTEM is not specified,

** The function `subr-arity' provides information about the argument
list of a primitive.

** `where-is-internal' now also accepts a list of keymaps.

** The text property `keymap' specifies a key map which overrides the
buffer's local map and the map specified by the `local-map' property.
This is probably what most current uses of `local-map' want, rather
than replacing the local map.

** The obsolete variables `before-change-function' and
`after-change-function' are no longer acted upon and have been
removed.  Use `before-change-functions' and `after-change-functions'
instead.

** The function `apropos-mode' runs the hook `apropos-mode-hook'.

** `concat' no longer accepts individual integer arguments,
as promised long ago.

** The new function `float-time' returns the current time as a float.

** The new variable auto-coding-regexp-alist specifies coding systems
for reading specific files, analogous to auto-coding-alist, but
patterns are checked against file contents instead of file names.


* Lisp changes in Emacs 21.1 (see following page for display-related features)

** The new package rx.el provides an alternative sexp notation for
regular expressions.

- Function: rx-to-string SEXP

Translate SEXP into a regular expression in string notation.

- Macro: rx SEXP

Translate SEXP into a regular expression in string notation.

The following are valid subforms of regular expressions in sexp
notation.

STRING
     matches string STRING literally.

CHAR
     matches character CHAR literally.

`not-newline'
     matches any character except a newline.
			.
`anything'
     matches any character

`(any SET)'
     matches any character in SET.  SET may be a character or string.
     Ranges of characters can be specified as `A-Z' in strings.

'(in SET)'
     like `any'.

`(not (any SET))'
     matches any character not in SET

`line-start'
     matches the empty string, but only at the beginning of a line
     in the text being matched

`line-end'
     is similar to `line-start' but matches only at the end of a line

`string-start'
     matches the empty string, but only at the beginning of the
     string being matched against.

`string-end'
     matches the empty string, but only at the end of the
     string being matched against.

`buffer-start'
     matches the empty string, but only at the beginning of the
     buffer being matched against.

`buffer-end'
     matches the empty string, but only at the end of the
     buffer being matched against.

`point'
     matches the empty string, but only at point.

`word-start'
     matches the empty string, but only at the beginning or end of a
     word.

`word-end'
     matches the empty string, but only at the end of a word.

`word-boundary'
     matches the empty string, but only at the beginning or end of a
     word.

`(not word-boundary)'
     matches the empty string, but not at the beginning or end of a
     word.

`digit'
     matches 0 through 9.

`control'
     matches ASCII control characters.

`hex-digit'
     matches 0 through 9, a through f and A through F.

`blank'
     matches space and tab only.

`graphic'
     matches graphic characters--everything except ASCII control chars,
     space, and DEL.

`printing'
     matches printing characters--everything except ASCII control chars
     and DEL.

`alphanumeric'
     matches letters and digits.  (But at present, for multibyte characters,
     it matches anything that has word syntax.)

`letter'
     matches letters.  (But at present, for multibyte characters,
     it matches anything that has word syntax.)

`ascii'
     matches ASCII (unibyte) characters.

`nonascii'
     matches non-ASCII (multibyte) characters.

`lower'
     matches anything lower-case.

`upper'
     matches anything upper-case.

`punctuation'
     matches punctuation.  (But at present, for multibyte characters,
     it matches anything that has non-word syntax.)

`space'
     matches anything that has whitespace syntax.

`word'
     matches anything that has word syntax.

`(syntax SYNTAX)'
     matches a character with syntax SYNTAX.  SYNTAX must be one
     of the following symbols.

     `whitespace'		(\\s- in string notation)
     `punctuation'		(\\s.)
     `word'			(\\sw)
     `symbol'			(\\s_)
     `open-parenthesis'		(\\s()
     `close-parenthesis'	(\\s))
     `expression-prefix'	(\\s')
     `string-quote'		(\\s\")
     `paired-delimiter'		(\\s$)
     `escape'			(\\s\\)
     `character-quote'		(\\s/)
     `comment-start'		(\\s<)
     `comment-end'		(\\s>)

`(not (syntax SYNTAX))'
     matches a character that has not syntax SYNTAX.

`(category CATEGORY)'
     matches a character with category CATEGORY.  CATEGORY must be
     either a character to use for C, or one of the following symbols.

     `consonant'			(\\c0 in string notation)
     `base-vowel'			(\\c1)
     `upper-diacritical-mark'		(\\c2)
     `lower-diacritical-mark'		(\\c3)
     `tone-mark'		        (\\c4)
     `symbol'			        (\\c5)
     `digit'			        (\\c6)
     `vowel-modifying-diacritical-mark'	(\\c7)
     `vowel-sign'			(\\c8)
     `semivowel-lower'			(\\c9)
     `not-at-end-of-line'		(\\c<)
     `not-at-beginning-of-line'		(\\c>)
     `alpha-numeric-two-byte'		(\\cA)
     `chinse-two-byte'			(\\cC)
     `greek-two-byte'			(\\cG)
     `japanese-hiragana-two-byte'	(\\cH)
     `indian-two-byte'			(\\cI)
     `japanese-katakana-two-byte'	(\\cK)
     `korean-hangul-two-byte'		(\\cN)
     `cyrillic-two-byte'		(\\cY)
     `ascii'				(\\ca)
     `arabic'				(\\cb)
     `chinese'				(\\cc)
     `ethiopic'				(\\ce)
     `greek'				(\\cg)
     `korean'				(\\ch)
     `indian'				(\\ci)
     `japanese'				(\\cj)
     `japanese-katakana'		(\\ck)
     `latin'				(\\cl)
     `lao'				(\\co)
     `tibetan'				(\\cq)
     `japanese-roman'			(\\cr)
     `thai'				(\\ct)
     `vietnamese'			(\\cv)
     `hebrew'				(\\cw)
     `cyrillic'				(\\cy)
     `can-break'			(\\c|)

`(not (category CATEGORY))'
     matches a character that has not category CATEGORY.

`(and SEXP1 SEXP2 ...)'
     matches what SEXP1 matches, followed by what SEXP2 matches, etc.

`(submatch SEXP1 SEXP2 ...)'
     like `and', but makes the match accessible with `match-end',
     `match-beginning', and `match-string'.

`(group SEXP1 SEXP2 ...)'
     another name for `submatch'.

`(or SEXP1 SEXP2 ...)'
     matches anything that matches SEXP1 or SEXP2, etc.  If all
     args are strings, use `regexp-opt' to optimize the resulting
     regular expression.

`(minimal-match SEXP)'
     produce a non-greedy regexp for SEXP.  Normally, regexps matching
     zero or more occurrences of something are \"greedy\" in that they
     match as much as they can, as long as the overall regexp can
     still match.  A non-greedy regexp matches as little as possible.

`(maximal-match SEXP)'
     produce a greedy regexp for SEXP.  This is the default.

`(zero-or-more SEXP)'
     matches zero or more occurrences of what SEXP matches.

`(0+ SEXP)'
     like `zero-or-more'.

`(* SEXP)'
     like `zero-or-more', but always produces a greedy regexp.

`(*? SEXP)'
     like `zero-or-more', but always produces a non-greedy regexp.

`(one-or-more SEXP)'
     matches one or more occurrences of A.

`(1+ SEXP)'
     like `one-or-more'.

`(+ SEXP)'
     like `one-or-more', but always produces a greedy regexp.

`(+? SEXP)'
     like `one-or-more', but always produces a non-greedy regexp.

`(zero-or-one SEXP)'
     matches zero or one occurrences of A.

`(optional SEXP)'
     like `zero-or-one'.

`(? SEXP)'
     like `zero-or-one', but always produces a greedy regexp.

`(?? SEXP)'
     like `zero-or-one', but always produces a non-greedy regexp.

`(repeat N SEXP)'
     matches N occurrences of what SEXP matches.

`(repeat N M SEXP)'
     matches N to M occurrences of what SEXP matches.

`(eval FORM)'
      evaluate FORM and insert result.  If result is a string,
      `regexp-quote' it.

`(regexp REGEXP)'
      include REGEXP in string notation in the result.

*** The features `md5' and `overlay' are now provided by default.

*** The special form `save-restriction' now works correctly even if the
buffer is widened inside the save-restriction and changes made outside
the original restriction.  Previously, doing this would cause the saved
restriction to be restored incorrectly.

*** The functions `find-charset-region' and `find-charset-string' include
`eight-bit-control' and/or `eight-bit-graphic' in the returned list
when they find 8-bit characters.  Previously, they included `ascii' in a
multibyte buffer and `unknown' in a unibyte buffer.

*** The functions `set-buffer-multibyte', `string-as-multibyte' and
`string-as-unibyte' change the byte sequence of a buffer or a string
if it contains a character from the `eight-bit-control' character set.

*** The handling of multibyte sequences in a multibyte buffer is
changed.  Previously, a byte sequence matching the pattern
[\200-\237][\240-\377]+ was interpreted as a single character
regardless of the length of the trailing bytes [\240-\377]+.  Thus, if
the sequence was longer than what the leading byte indicated, the
extra trailing bytes were ignored by Lisp functions.  Now such extra
bytes are independent 8-bit characters belonging to the charset
eight-bit-graphic.

** Fontsets are now implemented using char-tables.

A fontset can now be specified for each independent character, for
a group of characters or for a character set rather than just for a
character set as previously.

*** The arguments of the function `set-fontset-font' are changed.
They are NAME, CHARACTER, FONTNAME, and optional FRAME.  The function
modifies fontset NAME to use FONTNAME for CHARACTER.

CHARACTER may be a cons (FROM . TO), where FROM and TO are non-generic
characters.  In that case FONTNAME is used for all characters in the
range FROM and TO (inclusive).  CHARACTER may be a charset.  In that
case FONTNAME is used for all character in the charset.

FONTNAME may be a cons (FAMILY . REGISTRY), where FAMILY is the family
name of a font and REGISTRY is a registry name of a font.

*** Variable x-charset-registry has been deleted.  The default charset
registries of character sets are set in the default fontset
"fontset-default".

*** The function `create-fontset-from-fontset-spec' ignores the second
argument STYLE-VARIANT.  It never creates style-variant fontsets.

** The method of composing characters is changed.  Now character
composition is done by a special text property `composition' in
buffers and strings.

*** Charset composition is deleted.  Emacs never creates a `composite
character' which is an independent character with a unique character
code.  Thus the following functions handling `composite characters'
have been deleted: composite-char-component,
composite-char-component-count, composite-char-composition-rule,
composite-char-composition-rule and decompose-composite-char delete.
The variables leading-code-composition and min-composite-char have
also been deleted.

*** Three more glyph reference points are added.  They can be used to
specify a composition rule.  See the documentation of the variable
`reference-point-alist' for more detail.

*** The function `compose-region' takes new arguments COMPONENTS and
MODIFICATION-FUNC.  With COMPONENTS, you can specify not only a
composition rule but also characters to be composed.  Such characters
may differ between buffer and string text.

*** The function `compose-string' takes new arguments START, END,
COMPONENTS, and MODIFICATION-FUNC.

*** The function `compose-string' puts text property `composition'
directly on the argument STRING instead of returning a new string.
Likewise, the function `decompose-string' just removes text property
`composition' from STRING.

*** The new function `find-composition' returns information about
a composition at a specified position in a buffer or a string.

*** The function `decompose-composite-char' is now labeled as
obsolete.

** The new coding system `mac-roman' is primarily intended for use on
the Macintosh but may be used generally for Macintosh-encoded text.

** The new character sets `mule-unicode-0100-24ff',
`mule-unicode-2500-33ff', and `mule-unicode-e000-ffff' have been
introduced for Unicode characters in the range U+0100..U+24FF,
U+2500..U+33FF, U+E000..U+FFFF respectively.

Note that the character sets are not yet unified in Emacs, so
characters which belong to charsets such as Latin-2, Greek, Hebrew,
etc. and the same characters in the `mule-unicode-*' charsets are
different characters, as far as Emacs is concerned.  For example, text
which includes Unicode characters from the Latin-2 locale cannot be
encoded by Emacs with ISO 8859-2 coding system.

** The new coding system `mule-utf-8' has been added.
It provides limited support for decoding/encoding UTF-8 text.  For
details, please see the documentation string of this coding system.

** The new character sets `japanese-jisx0213-1' and
`japanese-jisx0213-2' have been introduced for the new Japanese
standard JIS X 0213 Plane 1 and Plane 2.

** The new character sets `latin-iso8859-14' and `latin-iso8859-15'
have been introduced.

** The new character sets `eight-bit-control' and `eight-bit-graphic'
have been introduced for 8-bit characters in the ranges 0x80..0x9F and
0xA0..0xFF respectively.  Note that the multibyte representation of
eight-bit-control is never exposed; this leads to an exception in the
emacs-mule coding system, which encodes everything else to the
buffer/string internal representation.  Note that to search for
eight-bit-graphic characters in a multibyte buffer, the search string
must be multibyte, otherwise such characters will be converted to
their multibyte equivalent.

** If the APPEND argument of `write-region' is an integer, it seeks to
that offset in the file before writing.

** The function `add-minor-mode' has been added for convenience and
compatibility with XEmacs (and is used internally by define-minor-mode).

** The function `shell-command' now sets the default directory of the
`*Shell Command Output*' buffer to the default directory of the buffer
from which the command was issued.

** The functions `query-replace', `query-replace-regexp',
`query-replace-regexp-eval' `map-query-replace-regexp',
`replace-string', `replace-regexp', and `perform-replace' take two
additional optional arguments START and END that specify the region to
operate on.

** The new function `count-screen-lines' is a more flexible alternative
to `window-buffer-height'.

- Function: count-screen-lines &optional BEG END COUNT-FINAL-NEWLINE WINDOW

Return the number of screen lines in the region between BEG and END.
The number of screen lines may be different from the number of actual
lines, due to line breaking, display table, etc.

Optional arguments BEG and END default to `point-min' and `point-max'
respectively.

If region ends with a newline, ignore it unless optional third argument
COUNT-FINAL-NEWLINE is non-nil.

The optional fourth argument WINDOW specifies the window used for
obtaining parameters such as width, horizontal scrolling, and so
on. The default is to use the selected window's parameters.

Like `vertical-motion', `count-screen-lines' always uses the current
buffer, regardless of which buffer is displayed in WINDOW. This makes
possible to use `count-screen-lines' in any buffer, whether or not it
is currently displayed in some window.

** The new function `mapc' is like `mapcar' but doesn't collect the
argument function's results.

** The functions base64-decode-region and base64-decode-string now
signal an error instead of returning nil if decoding fails.  Also,
`base64-decode-string' now always returns a unibyte string (in Emacs
20, it returned a multibyte string when the result was a valid multibyte
sequence).

** The function sendmail-user-agent-compose now recognizes a `body'
header in the list of headers passed to it.

** The new function member-ignore-case works like `member', but
ignores differences in case and text representation.

** The buffer-local variable cursor-type can be used to specify the
cursor to use in windows displaying a buffer.  Values are interpreted
as follows:

  t 		use the cursor specified for the frame (default)
  nil		don't display a cursor
  `bar'		display a bar cursor with default width
  (bar . WIDTH)	display a bar cursor with width WIDTH
  others	display a box cursor.

** The variable open-paren-in-column-0-is-defun-start controls whether
an open parenthesis in column 0 is considered to be the start of a
defun.  If set, the default, it is considered a defun start.  If not
set, an open parenthesis in column 0 has no special meaning.

** The new function `string-to-syntax' can be used to translate syntax
specifications in string form as accepted by `modify-syntax-entry' to
the cons-cell form that is used for the values of the `syntax-table'
text property, and in `font-lock-syntactic-keywords'.

Example:

  (string-to-syntax "()")
    => (4 . 41)

** Emacs' reader supports CL read syntax for integers in bases
other than 10.

*** `#BINTEGER' or `#bINTEGER' reads INTEGER in binary (radix 2).
INTEGER optionally contains a sign.

  #b1111
    => 15
  #b-1111
    => -15

*** `#OINTEGER' or `#oINTEGER' reads INTEGER in octal (radix 8).

  #o666
    => 438

*** `#XINTEGER' or `#xINTEGER' reads INTEGER in hexadecimal (radix 16).

  #xbeef
    => 48815

*** `#RADIXrINTEGER' reads INTEGER in radix RADIX, 2 <= RADIX <= 36.

  #2R-111
    => -7
  #25rah
    => 267

** The function `documentation-property' now evaluates the value of
the given property to obtain a string if it doesn't refer to etc/DOC
and isn't a string.

** If called for a symbol, the function `documentation' now looks for
a `function-documentation' property of that symbol.  If it has a non-nil
value, the documentation is taken from that value.  If the value is
not a string, it is evaluated to obtain a string.

** The last argument of `define-key-after' defaults to t for convenience.

** The new function `replace-regexp-in-string' replaces all matches
for a regexp in a string.

** `mouse-position' now runs the abnormal hook
`mouse-position-function'.

** The function string-to-number now returns a float for numbers
that don't fit into a Lisp integer.

** The variable keyword-symbols-constants-flag has been removed.
Keywords are now always considered constants.

** The new function `delete-and-extract-region' deletes text and
returns it.

** The function `clear-this-command-keys' now also clears the vector
returned by function `recent-keys'.

** Variables `beginning-of-defun-function' and `end-of-defun-function'
can be used to define handlers for the functions that find defuns.
Major modes can define these locally instead of rebinding C-M-a
etc. if the normal conventions for defuns are not appropriate for the
mode.

** easy-mmode-define-minor-mode now takes an additional BODY argument
and is renamed `define-minor-mode'.

** If an abbrev has a hook function which is a symbol, and that symbol
has a non-nil `no-self-insert' property, the return value of the hook
function specifies whether an expansion has been done or not.  If it
returns nil, abbrev-expand also returns nil, meaning "no expansion has
been performed."

When abbrev expansion is done by typing a self-inserting character,
and the abbrev has a hook with the `no-self-insert' property, and the
hook function returns non-nil meaning expansion has been done,
then the self-inserting character is not inserted.

** The function `intern-soft' now accepts a symbol as first argument.
In this case, that exact symbol is looked up in the specified obarray,
and the function's value is nil if it is not found.

** The new macro `with-syntax-table' can be used to evaluate forms
with the syntax table of the current buffer temporarily set to a
specified table.

  (with-syntax-table TABLE &rest BODY)

Evaluate BODY with syntax table of current buffer set to a copy of
TABLE.  The current syntax table is saved, BODY is evaluated, and the
saved table is restored, even in case of an abnormal exit.  Value is
what BODY returns.

** Regular expressions now support intervals \{n,m\} as well as
Perl's shy-groups \(?:...\) and non-greedy *? +? and ?? operators.
Also back-references like \2 are now considered as an error if the
corresponding subgroup does not exist (or is not closed yet).
Previously it would have been silently turned into `2' (ignoring the `\').

** The optional argument BUFFER of function file-local-copy has been
removed since it wasn't used by anything.

** The file name argument of function `file-locked-p' is now required
instead of being optional.

** The new built-in error `text-read-only' is signaled when trying to
modify read-only text.

** New functions and variables for locales.

The new variable `locale-coding-system' specifies how to encode and
decode strings passed to low-level message functions like strerror and
time functions like strftime.  The new variables
`system-messages-locale' and `system-time-locale' give the system
locales to be used when invoking these two types of functions.

The new function `set-locale-environment' sets the language
environment, preferred coding system, and locale coding system from
the system locale as specified by the LC_ALL, LC_CTYPE, and LANG
environment variables.  Normally, it is invoked during startup and need
not be invoked thereafter.  It uses the new variables
`locale-language-names', `locale-charset-language-names', and
`locale-preferred-coding-systems' to make its decisions.

** syntax tables now understand nested comments.
To declare a comment syntax as allowing nesting, just add an `n'
modifier to either of the characters of the comment end and the comment
start sequences.

** The function `pixmap-spec-p' has been renamed `bitmap-spec-p'
because `bitmap' is more in line with the usual X terminology.

** New function `propertize'

The new function `propertize' can be used to conveniently construct
strings with text properties.

- Function: propertize STRING &rest PROPERTIES

Value is a copy of STRING with text properties assigned as specified
by PROPERTIES.  PROPERTIES is a sequence of pairs PROPERTY VALUE, with
PROPERTY being the name of a text property and VALUE being the
specified value of that property.  Example:

  (propertize "foo" 'face 'bold 'read-only t)

** push and pop macros.

Simple versions of the push and pop macros of Common Lisp
are now defined in Emacs Lisp.  These macros allow only symbols
as the place that holds the list to be changed.

(push NEWELT LISTNAME)  add NEWELT to the front of LISTNAME's value.
(pop LISTNAME)          return first elt of LISTNAME, and remove it
			(thus altering the value of LISTNAME).

** New dolist and dotimes macros.

Simple versions of the dolist and dotimes macros of Common Lisp
are now defined in Emacs Lisp.

(dolist (VAR LIST [RESULT]) BODY...)
      Execute body once for each element of LIST,
      using the variable VAR to hold the current element.
      Then return the value of RESULT, or nil if RESULT is omitted.

(dotimes (VAR COUNT [RESULT]) BODY...)
      Execute BODY with VAR bound to successive integers running from 0,
      inclusive, to COUNT, exclusive.
      Then return the value of RESULT, or nil if RESULT is omitted.

** Regular expressions now support Posix character classes such as
[:alpha:], [:space:] and so on.  These must be used within a character
class--for instance, [-[:digit:].+] matches digits or a period
or a sign.

[:digit:]  matches 0 through 9
[:cntrl:]  matches ASCII control characters
[:xdigit:]  matches 0 through 9, a through f and A through F.
[:blank:]  matches space and tab only
[:graph:]  matches graphic characters--everything except ASCII control chars,
	   space, and DEL.
[:print:]  matches printing characters--everything except ASCII control chars
	   and DEL.
[:alnum:]  matches letters and digits.
	   (But at present, for multibyte characters,
	    it matches anything that has word syntax.)
[:alpha:]  matches letters.
	   (But at present, for multibyte characters,
	    it matches anything that has word syntax.)
[:ascii:]  matches ASCII (unibyte) characters.
[:nonascii:]  matches non-ASCII (multibyte) characters.
[:lower:]  matches anything lower-case.
[:punct:]  matches punctuation.
	   (But at present, for multibyte characters,
	    it matches anything that has non-word syntax.)
[:space:]  matches anything that has whitespace syntax.
[:upper:]  matches anything upper-case.
[:word:]   matches anything that has word syntax.

** Emacs now has built-in hash tables.

The following functions are defined for hash tables:

- Function: make-hash-table ARGS

The argument list ARGS consists of keyword/argument pairs.  All arguments
are optional.  The following arguments are defined:

:test TEST

TEST must be a symbol specifying how to compare keys.  Default is `eql'.
Predefined are `eq', `eql' and `equal'.  If TEST is not predefined,
it must have been defined with `define-hash-table-test'.

:size SIZE

SIZE must be an integer > 0 giving a hint to the implementation how
many elements will be put in the hash table.  Default size is 65.

:rehash-size REHASH-SIZE

REHASH-SIZE specifies by how much to grow a hash table once it becomes
full.  If REHASH-SIZE is an integer, add that to the hash table's old
size to get the new size.  Otherwise, REHASH-SIZE must be a float >
1.0, and the new size is computed by multiplying REHASH-SIZE with the
old size.  Default rehash size is 1.5.

:rehash-threshold THRESHOLD

THRESHOLD must be a float > 0 and <= 1.0 specifying when to resize the
hash table.  It is resized when the ratio of (number of entries) /
(size of hash table) is >= THRESHOLD.  Default threshold is 0.8.

:weakness WEAK

WEAK must be either nil, one of the symbols `key, `value',
`key-or-value', `key-and-value', or t, meaning the same as
`key-and-value'.  Entries are removed from weak tables during garbage
collection if their key and/or value are not referenced elsewhere
outside of the hash table.  Default are non-weak hash tables.

- Function: makehash &optional TEST

Similar to make-hash-table, but only TEST can be specified.

- Function: hash-table-p TABLE

Returns non-nil if TABLE is a hash table object.

- Function: copy-hash-table TABLE

Returns a copy of TABLE.  Only the table itself is copied, keys and
values are shared.

- Function: hash-table-count TABLE

Returns the number of entries in TABLE.

- Function: hash-table-rehash-size TABLE

Returns the rehash size of TABLE.

- Function: hash-table-rehash-threshold TABLE

Returns the rehash threshold of TABLE.

- Function: hash-table-rehash-size TABLE

Returns the size of TABLE.

- Function: hash-table-test TABLE

Returns the test TABLE uses to compare keys.

- Function: hash-table-weakness TABLE

Returns the weakness specified for TABLE.

- Function: clrhash TABLE

Clear TABLE.

- Function: gethash KEY TABLE &optional DEFAULT

Look up KEY in TABLE and return its associated VALUE or DEFAULT if
not found.

- Function: puthash KEY VALUE TABLE

Associate KEY with VALUE in TABLE.  If KEY is already associated with
another value, replace the old value with VALUE.

- Function: remhash KEY TABLE

Remove KEY from TABLE if it is there.

- Function: maphash FUNCTION TABLE

Call FUNCTION for all elements in TABLE.  FUNCTION must take two
arguments KEY and VALUE.

- Function: sxhash OBJ

Return a hash code for Lisp object OBJ.

- Function: define-hash-table-test NAME TEST-FN HASH-FN

Define a new hash table test named NAME.  If NAME is specified as
a test in `make-hash-table', the table created will use TEST-FN for
comparing keys, and HASH-FN to compute hash codes for keys.  Test
and hash function are stored as symbol property `hash-table-test'
of NAME with a value of (TEST-FN HASH-FN).

TEST-FN must take two arguments and return non-nil if they are the same.

HASH-FN must take one argument and return an integer that is the hash
code of the argument.  The function should use the whole range of
integer values for hash code computation, including negative integers.

Example: The following creates a hash table whose keys are supposed to
be strings that are compared case-insensitively.

  (defun case-fold-string= (a b)
    (compare-strings a nil nil b nil nil t))

  (defun case-fold-string-hash (a)
    (sxhash (upcase a)))

  (define-hash-table-test 'case-fold 'case-fold-string=
                          'case-fold-string-hash))

  (make-hash-table :test 'case-fold)

** The Lisp reader handles circular structure.

It now works to use the #N= and #N# constructs to represent
circular structures.  For example, #1=(a . #1#) represents
a cons cell which is its own cdr.

** The Lisp printer handles circular structure.

If you bind print-circle to a non-nil value, the Lisp printer outputs
#N= and #N# constructs to represent circular and shared structure.

** If the second argument to `move-to-column' is anything but nil or
t, that means replace a tab with spaces if necessary to reach the
specified column, but do not add spaces at the end of the line if it
is too short to reach that column.

** perform-replace has a new feature:  the REPLACEMENTS argument may
now be a cons cell (FUNCTION . DATA).  This means to call FUNCTION
after each match to get the replacement text.  FUNCTION is called with
two arguments: DATA, and the number of replacements already made.

If the FROM-STRING contains any upper-case letters,
perform-replace also turns off `case-fold-search' temporarily
and inserts the replacement text without altering case in it.

** The function buffer-size now accepts an optional argument
to specify which buffer to return the size of.

** The calendar motion commands now run the normal hook
calendar-move-hook after moving point.

** The new variable small-temporary-file-directory specifies a
directory to use for creating temporary files that are likely to be
small.  (Certain Emacs features use this directory.)  If
small-temporary-file-directory is nil, they use
temporary-file-directory instead.

** The variable `inhibit-modification-hooks', if non-nil, inhibits all
the hooks that track changes in the buffer.  This affects
`before-change-functions' and `after-change-functions', as well as
hooks attached to text properties and overlay properties.

** assq-delete-all is a new function that deletes all the
elements of an alist which have a car `eq' to a particular value.

** make-temp-file provides a more reliable way to create a temporary file.

make-temp-file is used like make-temp-name, except that it actually
creates the file before it returns.  This prevents a timing error,
ensuring that no other job can use the same name for a temporary file.

** New exclusive-open feature in `write-region'

The optional seventh arg is now called MUSTBENEW.  If non-nil, it insists
on a check for an existing file with the same name.  If MUSTBENEW
is `excl', that means to get an error if the file already exists;
never overwrite. If MUSTBENEW is neither nil nor `excl', that means
ask for confirmation before overwriting, but do go ahead and
overwrite the file if the user gives confirmation.

If the MUSTBENEW argument in `write-region' is `excl',
that means to use a special feature in the `open' system call
to get an error if the file exists at that time.
The error reported is `file-already-exists'.

** Function `format' now handles text properties.

Text properties of the format string are applied to the result string.
If the result string is longer than the format string, text properties
ending at the end of the format string are extended to the end of the
result string.

Text properties from string arguments are applied to the result
string where arguments appear in the result string.

Example:

  (let ((s1 "hello, %s")
        (s2 "world"))
     (put-text-property 0 (length s1) 'face 'bold s1)
     (put-text-property 0 (length s2) 'face 'italic s2)
     (format s1 s2))

results in a bold-face string with an italic `world' at the end.

** Messages can now be displayed with text properties.

Text properties are handled as described above for function `format'.
The following example displays a bold-face message with an italic
argument in it.

  (let ((msg "hello, %s!")
        (arg "world"))
     (put-text-property 0 (length msg) 'face 'bold msg)
     (put-text-property 0 (length arg) 'face 'italic arg)
     (message msg arg))

** Sound support

Emacs supports playing sound files on GNU/Linux and the free BSDs
(Voxware driver and native BSD driver, aka as Luigi's driver).

Currently supported file formats are RIFF-WAVE (*.wav) and Sun Audio
(*.au).  You must configure Emacs with the option `--with-sound=yes'
to enable sound support.

Sound files can be played by calling (play-sound SOUND).  SOUND is a
list of the form `(sound PROPERTY...)'.  The function is only defined
when sound support is present for the system on which Emacs runs.  The
functions runs `play-sound-functions' with one argument which is the
sound to play, before playing the sound.

The following sound properties are supported:

- `:file FILE'

FILE is a file name.  If FILE isn't an absolute name, it will be
searched relative to `data-directory'.

- `:data DATA'

DATA is a string containing sound data.  Either :file or :data
may be present, but not both.

- `:volume VOLUME'

VOLUME must be an integer in the range 0..100 or a float in the range
0..1.  This property is optional.

- `:device DEVICE'

DEVICE is a string specifying the system device on which to play the
sound.  The default device is system-dependent.

Other properties are ignored.

An alternative interface is called as
(play-sound-file FILE &optional VOLUME DEVICE).

** `multimedia' is a new Finder keyword and Custom group.

** keywordp is a new predicate to test efficiently for an object being
a keyword symbol.

** Changes to garbage collection

*** The function garbage-collect now additionally returns the number
of live and free strings.

*** There is a new variable `strings-consed' holding the number of
strings that have been consed so far.


* Lisp-level Display features added after release 2.6 of the Emacs
Lisp Manual

** The user-option `resize-mini-windows' controls how Emacs resizes
mini-windows.

** The function `pos-visible-in-window-p' now has a third optional
argument, PARTIALLY.  If a character is only partially visible, nil is
returned, unless PARTIALLY is non-nil.

** On window systems, `glyph-table' is no longer used.

** Help strings in menu items are now used to provide `help-echo' text.

** The function `image-size' can be used to determine the size of an
image.

- Function: image-size SPEC &optional PIXELS FRAME

Return the size of an image as a pair (WIDTH . HEIGHT).

SPEC is an image specification.  PIXELS non-nil means return sizes
measured in pixels, otherwise return sizes measured in canonical
character units (fractions of the width/height of the frame's default
font).  FRAME is the frame on which the image will be displayed.
FRAME nil or omitted means use the selected frame.

** The function `image-mask-p' can be used to determine if an image
has a mask bitmap.

- Function: image-mask-p SPEC &optional FRAME

Return t if image SPEC has a mask bitmap.
FRAME is the frame on which the image will be displayed.  FRAME nil
or omitted means use the selected frame.

** The function `find-image' can be used to find a usable image
satisfying one of a list of specifications.

** The STRING argument of `put-image' and `insert-image' is now
optional.

** Image specifications may contain the property `:ascent center' (see
below).


* New Lisp-level Display features in Emacs 21.1

** The function tty-suppress-bold-inverse-default-colors can be used
to make Emacs avoid displaying text with bold black foreground on TTYs.

Some terminals, notably PC consoles, emulate bold text by displaying
text in brighter colors.  On such a console, a bold black foreground
is displayed in a gray color.  If this turns out to be hard to read on
your monitor---the problem occurred with the mode line on
laptops---you can instruct Emacs to ignore the text's boldness, and to
just display it black instead.

This situation can't be detected automatically.  You will have to put
a line like

  (tty-suppress-bold-inverse-default-colors t)

in your `.emacs'.

** New face implementation.

Emacs faces have been reimplemented from scratch.  They don't use XLFD
font names anymore and face merging now works as expected.

*** New faces.

Each face can specify the following display attributes:

   1. Font family or fontset alias name.

   2. Relative proportionate width, aka character set width or set
   width (swidth), e.g. `semi-compressed'.

   3. Font height in 1/10pt

   4. Font weight, e.g. `bold'.

   5. Font slant, e.g. `italic'.

   6. Foreground color.

   7. Background color.

   8. Whether or not characters should be underlined, and in what color.

   9. Whether or not characters should be displayed in inverse video.

   10. A background stipple, a bitmap.

   11. Whether or not characters should be overlined, and in what color.

   12. Whether or not characters should be strike-through, and in what
   color.

   13. Whether or not a box should be drawn around characters, its
   color, the width of the box lines, and 3D appearance.

Faces are frame-local by nature because Emacs allows to define the
same named face (face names are symbols) differently for different
frames.  Each frame has an alist of face definitions for all named
faces.  The value of a named face in such an alist is a Lisp vector
with the symbol `face' in slot 0, and a slot for each of the face
attributes mentioned above.

There is also a global face alist `face-new-frame-defaults'.  Face
definitions from this list are used to initialize faces of newly
created frames.

A face doesn't have to specify all attributes.  Those not specified
have a nil value.  Faces specifying all attributes are called
`fully-specified'.

*** Face merging.

The display style of a given character in the text is determined by
combining several faces.  This process is called `face merging'.  Any
aspect of the display style that isn't specified by overlays or text
properties is taken from the `default' face.  Since it is made sure
that the default face is always fully-specified, face merging always
results in a fully-specified face.

*** Face realization.

After all face attributes for a character have been determined by
merging faces of that character, that face is `realized'.  The
realization process maps face attributes to what is physically
available on the system where Emacs runs.  The result is a `realized
face' in form of an internal structure which is stored in the face
cache of the frame on which it was realized.

Face realization is done in the context of the charset of the
character to display because different fonts and encodings are used
for different charsets.  In other words, for characters of different
charsets, different realized faces are needed to display them.

Except for composite characters, faces are always realized for a
specific character set and contain a specific font, even if the face
being realized specifies a fontset.  The reason is that the result of
the new font selection stage is better than what can be done with
statically defined font name patterns in fontsets.

In unibyte text, Emacs' charsets aren't applicable; function
`char-charset' reports ASCII for all characters, including those >
0x7f.  The X registry and encoding of fonts to use is determined from
the variable `face-default-registry' in this case.  The variable is
initialized at Emacs startup time from the font the user specified for
Emacs.

Currently all unibyte text, i.e. all buffers with
`enable-multibyte-characters' nil are displayed with fonts of the same
registry and encoding `face-default-registry'.  This is consistent
with the fact that languages can also be set globally, only.

**** Clearing face caches.

The Lisp function `clear-face-cache' can be called to clear face caches
on all frames.  If called with a non-nil argument, it will also unload
unused fonts.

*** Font selection.

Font selection tries to find the best available matching font for a
given (charset, face) combination.  This is done slightly differently
for faces specifying a fontset, or a font family name.

If the face specifies a fontset name, that fontset determines a
pattern for fonts of the given charset.  If the face specifies a font
family, a font pattern is constructed.  Charset symbols have a
property `x-charset-registry' for that purpose that maps a charset to
an XLFD registry and encoding in the font pattern constructed.

Available fonts on the system on which Emacs runs are then matched
against the font pattern.  The result of font selection is the best
match for the given face attributes in this font list.

Font selection can be influenced by the user.

The user can specify the relative importance he gives the face
attributes width, height, weight, and slant by setting
face-font-selection-order (faces.el) to a list of face attribute
names.  The default is (:width :height :weight :slant), and means
that font selection first tries to find a good match for the font
width specified by a face, then---within fonts with that width---tries
to find a best match for the specified font height, etc.

Setting `face-font-family-alternatives' allows the user to specify
alternative font families to try if a family specified by a face
doesn't exist.

Setting `face-font-registry-alternatives' allows the user to specify
all alternative font registry names to try for a face specifying a
registry.

Please note that the interpretations of the above two variables are
slightly different.

Setting face-ignored-fonts allows the user to ignore specific fonts.


**** Scalable fonts

Emacs can make use of scalable fonts but doesn't do so by default,
since the use of too many or too big scalable fonts may crash XFree86
servers.

To enable scalable font use, set the variable
`scalable-fonts-allowed'.  A value of nil, the default, means never use
scalable fonts.  A value of t means any scalable font may be used.
Otherwise, the value must be a list of regular expressions.  A
scalable font may then be used if it matches a regular expression from
that list.  Example:

  (setq scalable-fonts-allowed '("muleindian-2$"))

allows the use of scalable fonts with registry `muleindian-2'.

*** Functions and variables related to font selection.

- Function: x-family-fonts &optional FAMILY FRAME

Return a list of available fonts of family FAMILY on FRAME.  If FAMILY
is omitted or nil, list all families.  Otherwise, FAMILY must be a
string, possibly containing wildcards `?' and `*'.

If FRAME is omitted or nil, use the selected frame.  Each element of
the result is a vector [FAMILY WIDTH POINT-SIZE WEIGHT SLANT FIXED-P
FULL REGISTRY-AND-ENCODING].  FAMILY is the font family name.
POINT-SIZE is the size of the font in 1/10 pt.  WIDTH, WEIGHT, and
SLANT are symbols describing the width, weight and slant of the font.
These symbols are the same as for face attributes.  FIXED-P is non-nil
if the font is fixed-pitch.  FULL is the full name of the font, and
REGISTRY-AND-ENCODING is a string giving the registry and encoding of
the font.  The result list is sorted according to the current setting
of the face font sort order.

- Function: x-font-family-list

Return a list of available font families on FRAME.  If FRAME is
omitted or nil, use the selected frame.  Value is a list of conses
(FAMILY . FIXED-P) where FAMILY is a font family, and FIXED-P is
non-nil if fonts of that family are fixed-pitch.

- Variable: font-list-limit

Limit for font matching.  If an integer > 0, font matching functions
won't load more than that number of fonts when searching for a
matching font.  The default is currently 100.

*** Setting face attributes.

For the most part, the new face implementation is interface-compatible
with the old one.  Old face attribute related functions are now
implemented in terms of the new functions `set-face-attribute' and
`face-attribute'.

Face attributes are identified by their names which are keyword
symbols.  All attributes can be set to `unspecified'.

The following attributes are recognized:

`:family'

VALUE must be a string specifying the font family, e.g. ``courier'',
or a fontset alias name.  If a font family is specified, wild-cards `*'
and `?' are allowed.

`:width'

VALUE specifies the relative proportionate width of the font to use.
It must be one of the symbols `ultra-condensed', `extra-condensed',
`condensed', `semi-condensed', `normal', `semi-expanded', `expanded',
`extra-expanded', or `ultra-expanded'.

`:height'

VALUE must be either an integer specifying the height of the font to use
in 1/10 pt, a floating point number specifying the amount by which to
scale any underlying face, or a function, which is called with the old
height (from the underlying face), and should return the new height.

`:weight'

VALUE specifies the weight of the font to use.  It must be one of the
symbols `ultra-bold', `extra-bold', `bold', `semi-bold', `normal',
`semi-light', `light', `extra-light', `ultra-light'.

`:slant'

VALUE specifies the slant of the font to use.  It must be one of the
symbols `italic', `oblique', `normal', `reverse-italic', or
`reverse-oblique'.

`:foreground', `:background'

VALUE must be a color name, a string.

`:underline'

VALUE specifies whether characters in FACE should be underlined.  If
VALUE is t, underline with foreground color of the face.  If VALUE is
a string, underline with that color.  If VALUE is nil, explicitly
don't underline.

`:overline'

VALUE specifies whether characters in FACE should be overlined.  If
VALUE is t, overline with foreground color of the face.  If VALUE is a
string, overline with that color.  If VALUE is nil, explicitly don't
overline.

`:strike-through'

VALUE specifies whether characters in FACE should be drawn with a line
striking through them.  If VALUE is t, use the foreground color of the
face.  If VALUE is a string, strike-through with that color.  If VALUE
is nil, explicitly don't strike through.

`:box'

VALUE specifies whether characters in FACE should have a box drawn
around them.  If VALUE is nil, explicitly don't draw boxes.  If
VALUE is t, draw a box with lines of width 1 in the foreground color
of the face.  If VALUE is a string, the string must be a color name,
and the box is drawn in that color with a line width of 1.  Otherwise,
VALUE must be a property list of the form `(:line-width WIDTH
:color COLOR :style STYLE)'.  If a keyword/value pair is missing from
the property list, a default value will be used for the value, as
specified below.  WIDTH specifies the width of the lines to draw; it
defaults to 1.  COLOR is the name of the color to draw in, default is
the foreground color of the face for simple boxes, and the background
color of the face for 3D boxes.  STYLE specifies whether a 3D box
should be draw.  If STYLE is `released-button', draw a box looking
like a released 3D button.  If STYLE is `pressed-button' draw a box
that appears like a pressed button.  If STYLE is nil, the default if
the property list doesn't contain a style specification, draw a 2D
box.

`:inverse-video'

VALUE specifies whether characters in FACE should be displayed in
inverse video. VALUE must be one of t or nil.

`:stipple'

If VALUE is a string, it must be the name of a file of pixmap data.
The directories listed in the `x-bitmap-file-path' variable are
searched.  Alternatively, VALUE may be a list of the form (WIDTH
HEIGHT DATA) where WIDTH and HEIGHT are the size in pixels, and DATA
is a string containing the raw bits of the bitmap.  VALUE nil means
explicitly don't use a stipple pattern.

For convenience, attributes `:family', `:width', `:height', `:weight',
and `:slant' may also be set in one step from an X font name:

`:font'

Set font-related face attributes from VALUE.  VALUE must be a valid
XLFD font name.  If it is a font name pattern, the first matching font
is used--this is for compatibility with the behavior of previous
versions of Emacs.

For compatibility with Emacs 20, keywords `:bold' and `:italic' can
be used to specify that a bold or italic font should be used.  VALUE
must be t or nil in that case.  A value of `unspecified' is not allowed."

Please see also the documentation of `set-face-attribute' and
`defface'.

`:inherit'

VALUE is the name of a face from which to inherit attributes, or a list
of face names.  Attributes from inherited faces are merged into the face
like an underlying face would be, with higher priority than underlying faces.

*** Face attributes and X resources

The following X resource names can be used to set face attributes
from X resources:

  Face attribute	X resource		class
-----------------------------------------------------------------------
  :family		attributeFamily .	Face.AttributeFamily
  :width		attributeWidth		Face.AttributeWidth
  :height		attributeHeight		Face.AttributeHeight
  :weight		attributeWeight		Face.AttributeWeight
  :slant		attributeSlant		Face.AttributeSlant
   foreground		attributeForeground	Face.AttributeForeground
  :background		attributeBackground .	Face.AttributeBackground
  :overline		attributeOverline	Face.AttributeOverline
  :strike-through	attributeStrikeThrough	Face.AttributeStrikeThrough
  :box			attributeBox		Face.AttributeBox
  :underline		attributeUnderline	Face.AttributeUnderline
  :inverse-video	attributeInverse	Face.AttributeInverse
  :stipple		attributeStipple	Face.AttributeStipple
	or		attributeBackgroundPixmap
						Face.AttributeBackgroundPixmap
  :font			attributeFont		Face.AttributeFont
  :bold			attributeBold		Face.AttributeBold
  :italic		attributeItalic .	Face.AttributeItalic
  :font			attributeFont		Face.AttributeFont

*** Text property `face'.

The value of the `face' text property can now be a single face
specification or a list of such specifications.  Each face
specification can be

1. A symbol or string naming a Lisp face.

2. A property list of the form (KEYWORD VALUE ...) where each
   KEYWORD is a face attribute name, and VALUE is an appropriate value
   for that attribute.  Please see the doc string of `set-face-attribute'
   for face attribute names.

3. Conses of the form (FOREGROUND-COLOR . COLOR) or
   (BACKGROUND-COLOR . COLOR) where COLOR is a color name.  This is
   for compatibility with previous Emacs versions.

** Support functions for colors on text-only terminals.

The function `tty-color-define' can be used to define colors for use
on TTY and MSDOS frames.  It maps a color name to a color number on
the terminal.  Emacs defines a couple of common color mappings by
default.  You can get defined colors with a call to
`defined-colors'.  The function `tty-color-clear' can be
used to clear the mapping table.

** Unified support for colors independent of frame type.

The new functions `defined-colors', `color-defined-p', `color-values',
and `display-color-p' work for any type of frame.  On frames whose
type is neither x nor w32, these functions transparently map X-style
color specifications to the closest colors supported by the frame
display.  Lisp programs should use these new functions instead of the
old `x-defined-colors', `x-color-defined-p', `x-color-values', and
`x-display-color-p'.  (The old function names are still available for
compatibility; they are now aliases of the new names.)  Lisp programs
should no more look at the value of the variable window-system to
modify their color-related behavior.

The primitives `color-gray-p' and `color-supported-p' also work for
any frame type.

** Platform-independent functions to describe display capabilities.

The new functions `display-mouse-p', `display-popup-menus-p',
`display-graphic-p', `display-selections-p', `display-screens',
`display-pixel-width', `display-pixel-height', `display-mm-width',
`display-mm-height', `display-backing-store', `display-save-under',
`display-planes', `display-color-cells', `display-visual-class', and
`display-grayscale-p' describe the basic capabilities of a particular
display.  Lisp programs should call these functions instead of testing
the value of the variables `window-system' or `system-type', or calling
platform-specific functions such as `x-display-pixel-width'.

The new function `display-images-p' returns non-nil if a particular
display can display image files.

** The minibuffer prompt is now actually inserted in the minibuffer.

This makes it possible to scroll through the prompt, if you want to.
To disallow this completely (like previous versions of emacs), customize
the variable `minibuffer-prompt-properties', and turn on the
`Inviolable' option.

The function `minibuffer-prompt-end' returns the current position of the
end of the minibuffer prompt, if the minibuffer is current.
Otherwise, it returns `(point-min)'.

** New `field' abstraction in buffers.

There is now code to support an abstraction called `fields' in emacs
buffers.  A field is a contiguous region of text with the same `field'
property (which can be a text property or an overlay).

Many emacs functions, such as forward-word, forward-sentence,
forward-paragraph, beginning-of-line, etc., stop moving when they come
to the boundary between fields; beginning-of-line and end-of-line will
not let the point move past the field boundary, but other movement
commands continue into the next field if repeated.  Stopping at field
boundaries can be suppressed programmatically by binding
`inhibit-field-text-motion' to a non-nil value around calls to these
functions.

Now that the minibuffer prompt is inserted into the minibuffer, it is in
a separate field from the user-input part of the buffer, so that common
editing commands treat the user's text separately from the prompt.

The following functions are defined for operating on fields:

- Function: constrain-to-field NEW-POS OLD-POS &optional ESCAPE-FROM-EDGE ONLY-IN-LINE INHIBIT-CAPTURE-PROPERTY

Return the position closest to NEW-POS that is in the same field as OLD-POS.

A field is a region of text with the same `field' property.
If NEW-POS is nil, then the current point is used instead, and set to the
constrained position if that is different.

If OLD-POS is at the boundary of two fields, then the allowable
positions for NEW-POS depends on the value of the optional argument
ESCAPE-FROM-EDGE: If ESCAPE-FROM-EDGE is nil, then NEW-POS is
constrained to the field that has the same `field' char-property
as any new characters inserted at OLD-POS, whereas if ESCAPE-FROM-EDGE
is non-nil, NEW-POS is constrained to the union of the two adjacent
fields.  Additionally, if two fields are separated by another field with
the special value `boundary', then any point within this special field is
also considered to be `on the boundary'.

If the optional argument ONLY-IN-LINE is non-nil and constraining
NEW-POS would move it to a different line, NEW-POS is returned
unconstrained.  This useful for commands that move by line, like
C-n or C-a, which should generally respect field boundaries
only in the case where they can still move to the right line.

If the optional argument INHIBIT-CAPTURE-PROPERTY is non-nil, and OLD-POS has
a non-nil property of that name, then any field boundaries are ignored.

Field boundaries are not noticed if `inhibit-field-text-motion' is non-nil.

- Function: delete-field &optional POS

Delete the field surrounding POS.
A field is a region of text with the same `field' property.
If POS is nil, the value of point is used for POS.

- Function: field-beginning &optional POS ESCAPE-FROM-EDGE

Return the beginning of the field surrounding POS.
A field is a region of text with the same `field' property.
If POS is nil, the value of point is used for POS.
If ESCAPE-FROM-EDGE is non-nil and POS is at the beginning of its
field, then the beginning of the *previous* field is returned.

- Function: field-end &optional POS ESCAPE-FROM-EDGE

Return the end of the field surrounding POS.
A field is a region of text with the same `field' property.
If POS is nil, the value of point is used for POS.
If ESCAPE-FROM-EDGE is non-nil and POS is at the end of its field,
then the end of the *following* field is returned.

- Function: field-string &optional POS

Return the contents of the field surrounding POS as a string.
A field is a region of text with the same `field' property.
If POS is nil, the value of point is used for POS.

- Function: field-string-no-properties &optional POS

Return the contents of the field around POS, without text-properties.
A field is a region of text with the same `field' property.
If POS is nil, the value of point is used for POS.

** Image support.

Emacs can now display images.  Images are inserted into text by giving
strings or buffer text a `display' text property containing one of
(AREA IMAGE) or IMAGE.  The display of the `display' property value
replaces the display of the characters having that property.

If the property value has the form (AREA IMAGE), AREA must be one of
`(margin left-margin)', `(margin right-margin)' or `(margin nil)'.  If
AREA is `(margin nil)', IMAGE will be displayed in the text area of a
window, otherwise it will be displayed in the left or right marginal
area.

IMAGE is an image specification.

*** Image specifications

Image specifications are lists of the form `(image PROPS)' where PROPS
is a property list whose keys are keyword symbols.  Each
specifications must contain a property `:type TYPE' with TYPE being a
symbol specifying the image type, e.g. `xbm'.  Properties not
described below are ignored.

The following is a list of properties all image types share.

`:ascent ASCENT'

ASCENT must be a number in the range 0..100, or the symbol `center'.
If it is a number, it specifies the percentage of the image's height
to use for its ascent.

If not specified, ASCENT defaults to the value 50 which means that the
image will be centered with the base line of the row it appears in.

If ASCENT is `center' the image is vertically centered around a
centerline which is the vertical center of text drawn at the position
of the image, in the manner specified by the text properties and
overlays that apply to the image.

`:margin MARGIN'

MARGIN must be either a number >= 0 specifying how many pixels to put
as margin around the image, or a pair (X . Y) with X specifying the
horizontal margin and Y specifying the vertical margin.  Default is 0.

`:relief RELIEF'

RELIEF is analogous to the `:relief' attribute of faces.  Puts a relief
around an image.

`:conversion ALGO'

Apply an image algorithm to the image before displaying it.

ALGO `laplace' or `emboss' means apply a Laplace or ``emboss''
edge-detection algorithm to the image.

ALGO `(edge-detection :matrix MATRIX :color-adjust ADJUST)' means
apply a general edge-detection algorithm.  MATRIX must be either a
nine-element list or a nine-element vector of numbers.  A pixel at
position x/y in the transformed image is computed from original pixels
around that position.  MATRIX specifies, for each pixel in the
neighborhood of x/y, a factor with which that pixel will influence the
transformed pixel; element 0 specifies the factor for the pixel at
x-1/y-1, element 1 the factor for the pixel at x/y-1 etc. as shown
below.

  (x-1/y-1  x/y-1  x+1/y-1
   x-1/y    x/y    x+1/y
   x-1/y+1  x/y+1  x+1/y+1)

The resulting pixel is computed from the color intensity of the color
resulting from summing up the RGB values of surrounding pixels,
multiplied by the specified factors, and dividing that sum by the sum
of the factors' absolute values.

Laplace edge-detection currently uses a matrix of

  (1  0  0
   0  0  0
   9  9 -1)

Emboss edge-detection uses a matrix of

  ( 2 -1  0
   -1  0  1
    0  1 -2)

ALGO `disabled' means transform the image so that it looks
``disabled''.

`:mask MASK'

If MASK is `heuristic' or `(heuristic BG)', build a clipping mask for
the image, so that the background of a frame is visible behind the
image.  If BG is not specified, or if BG is t, determine the
background color of the image by looking at the 4 corners of the
image, assuming the most frequently occurring color from the corners is
the background color of the image.  Otherwise, BG must be a list `(RED
GREEN BLUE)' specifying the color to assume for the background of the
image.

If MASK is nil, remove a mask from the image, if it has one.  Images
in some formats include a mask which can be removed by specifying
`:mask nil'.

`:file FILE'

Load image from FILE.  If FILE is not absolute after expanding it,
search for the image in `data-directory'.  Some image types support
building images from data.  When this is done, no `:file' property
may be present in the image specification.

`:data DATA'

Get image data from DATA.  (As of this writing, this is not yet
supported for image type `postscript').  Either :file or :data may be
present in an image specification, but not both.  All image types
support strings as DATA, some types allow additional types of DATA.

*** Supported image types

**** XBM, image type `xbm'.

XBM images don't require an external library.  Additional image
properties supported are:

`:foreground FG'

FG must be a string specifying the image foreground color, or nil
meaning to use the default.  Default is the frame's foreground color.

`:background BG'

BG must be a string specifying the image background color, or nil
meaning to use the default.  Default is the frame's background color.

XBM images can be constructed from data instead of file.  In this
case, the image specification must contain the following properties
instead of a `:file' property.

`:width WIDTH'

WIDTH specifies the width of the image in pixels.

`:height HEIGHT'

HEIGHT specifies the height of the image in pixels.

`:data DATA'

DATA must be either

   1. a string large enough to hold the bitmap data, i.e. it must
   have a size >= (WIDTH + 7) / 8 * HEIGHT

   2. a bool-vector of size >= WIDTH * HEIGHT

   3. a vector of strings or bool-vectors, one for each line of the
   bitmap.

   4. a string that's an in-memory XBM file.  Neither width nor
   height may be specified in this case because these are defined
   in the file.

**** XPM, image type `xpm'

XPM images require the external library `libXpm', package
`xpm-3.4k.tar.gz', version 3.4k or later.  Make sure the library is
found when Emacs is configured by supplying appropriate paths via
`--x-includes' and `--x-libraries'.

Additional image properties supported are:

`:color-symbols SYMBOLS'

SYMBOLS must be a list of pairs (NAME . COLOR), with NAME being the
name of color as it appears in an XPM file, and COLOR being an X color
name.

XPM images can be built from memory instead of files.  In that case,
add a `:data' property instead of a `:file' property.

The XPM library uses libz in its implementation so that it is able
to display compressed images.

**** PBM, image type `pbm'

PBM images don't require an external library.  Color, gray-scale and
mono images are supported.  Additional image properties supported for
mono images are:

`:foreground FG'

FG must be a string specifying the image foreground color, or nil
meaning to use the default.  Default is the frame's foreground color.

`:background FG'

BG must be a string specifying the image background color, or nil
meaning to use the default.  Default is the frame's background color.

**** JPEG, image type `jpeg'

Support for JPEG images requires the external library `libjpeg',
package `jpegsrc.v6a.tar.gz', or later.  There are no additional image
properties defined.

**** TIFF, image type `tiff'

Support for TIFF images requires the external library `libtiff',
package `tiff-v3.4-tar.gz', or later.  There are no additional image
properties defined.

**** GIF, image type `gif'

Support for GIF images requires the external library `libungif', package
`libungif-4.1.0', or later.

Additional image properties supported are:

`:index INDEX'

INDEX must be an integer >= 0.  Load image number INDEX from a
multi-image GIF file.  If INDEX is too large, the image displays
as a hollow box.

This could be used to implement limited support for animated GIFs.
For example, the following function displays a multi-image GIF file
at point-min in the current buffer, switching between sub-images
every 0.1 seconds.

(defun show-anim (file max)
  "Display multi-image GIF file FILE which contains MAX subimages."
  (display-anim (current-buffer) file 0 max t))

(defun display-anim (buffer file idx max first-time)
  (when (= idx max)
    (setq idx 0))
  (let ((img (create-image file nil nil :index idx)))
    (save-excursion
      (set-buffer buffer)
      (goto-char (point-min))
      (unless first-time (delete-char 1))
      (insert-image img "x"))
    (run-with-timer 0.1 nil 'display-anim buffer file (1+ idx) max nil)))

**** PNG, image type `png'

Support for PNG images requires the external library `libpng',
package `libpng-1.0.2.tar.gz', or later.  There are no additional image
properties defined.

**** Ghostscript, image type `postscript'.

Additional image properties supported are:

`:pt-width WIDTH'

WIDTH is width of the image in pt (1/72 inch).  WIDTH must be an
integer.  This is a required property.

`:pt-height HEIGHT'

HEIGHT specifies the height of the image in pt (1/72 inch).  HEIGHT
must be a integer.  This is an required property.

`:bounding-box BOX'

BOX must be a list or vector of 4 integers giving the bounding box of
the PS image, analogous to the `BoundingBox' comment found in PS
files.  This is an required property.

Part of the Ghostscript interface is implemented in Lisp.  See
lisp/gs.el.

*** Lisp interface.

The variable `image-types' contains a list of those image types
which are supported in the current configuration.

Images are stored in an image cache and removed from the cache when
they haven't been displayed for `image-cache-eviction-delay seconds.
The function `clear-image-cache' can be used to clear the image cache
manually.  Images in the cache are compared with `equal', i.e. all
images with `equal' specifications share the same image.

*** Simplified image API, image.el

The new Lisp package image.el contains functions that simplify image
creation and putting images into text.  The function `create-image'
can be used to create images.  The macro `defimage' can be used to
define an image based on available image types.  The functions
`put-image' and `insert-image' can be used to insert an image into a
buffer.

** Display margins.

Windows can now have margins which are used for special text
and images.

To give a window margins, either set the buffer-local variables
`left-margin-width' and `right-margin-width', or call
`set-window-margins'.  The function `window-margins' can be used to
obtain the current settings.  To make `left-margin-width' and
`right-margin-width' take effect, you must set them before displaying
the buffer in a window, or use `set-window-buffer' to force an update
of the display margins.

You can put text in margins by giving it a `display' text property
containing a pair of the form `(LOCATION . VALUE)', where LOCATION is
one of `left-margin' or `right-margin' or nil.  VALUE can be either a
string, an image specification or a stretch specification (see later
in this file).

** Help display

Emacs displays short help messages in the echo area, when the mouse
moves over a tool-bar item or a piece of text that has a text property
`help-echo'.  This feature also applies to strings in the mode line
that have a `help-echo' property.

If the value of the `help-echo' property is a function, that function
is called with three arguments WINDOW, OBJECT and POSITION.  WINDOW is
the window in which the help was found.

If OBJECT is a buffer, POS is the position in the buffer where the
`help-echo' text property was found.

If OBJECT is an overlay, that overlay has a `help-echo' property, and
POS is the position in the overlay's buffer under the mouse.

If OBJECT is a string (an overlay string or a string displayed with
the `display' property), POS is the position in that string under the
mouse.

If the value of the `help-echo' property is neither a function nor a
string, it is evaluated to obtain a help string.

For tool-bar and menu-bar items, their key definition is used to
determine the help to display.  If their definition contains a
property `:help FORM', FORM is evaluated to determine the help string.
For tool-bar items without a help form, the caption of the item is
used as help string.

The hook `show-help-function' can be set to a function that displays
the help string differently.  For example, enabling a tooltip window
causes the help display to appear there instead of in the echo area.

** Vertical fractional scrolling.

The display of text in windows can be scrolled smoothly in pixels.
This is useful, for example, for making parts of large images visible.

The function `window-vscroll' returns the current value of vertical
scrolling, a non-negative fraction of the canonical character height.
The function `set-window-vscroll' can be used to set the vertical
scrolling value.  Here is an example of how these function might be
used.

  (global-set-key [A-down]
    #'(lambda ()
        (interactive)
	(set-window-vscroll (selected-window)
                            (+ 0.5 (window-vscroll)))))
  (global-set-key [A-up]
    #'(lambda ()
	(interactive)
	(set-window-vscroll (selected-window)
	                    (- (window-vscroll) 0.5)))))

** New hook `fontification-functions'.

Functions from `fontification-functions' are called from redisplay
when it encounters a region of text that is not yet fontified.  This
variable automatically becomes buffer-local when set.  Each function
is called with one argument, POS.

At least one of the hook functions should fontify one or more
characters starting at POS in the current buffer.  It should mark them
as fontified by giving them a non-nil value of the `fontified' text
property.  It may be reasonable for these functions to check for the
`fontified' property and not put it back on, but they do not have to.

** Tool bar support.

Emacs supports a tool bar at the top of a frame under X.  The frame
parameter `tool-bar-lines' (X resource "toolBar", class "ToolBar")
controls how may lines to reserve for the tool bar.  A zero value
suppresses the tool bar.  If the value is non-zero and
`auto-resize-tool-bars' is non-nil the tool bar's size will be changed
automatically so that all tool bar items are visible.

*** Tool bar item definitions

Tool bar items are defined using `define-key' with a prefix-key
`tool-bar'.  For example `(define-key global-map [tool-bar item1] ITEM)'
where ITEM is a list `(menu-item CAPTION BINDING PROPS...)'.

CAPTION is the caption of the item, If it's not a string, it is
evaluated to get a string.  The caption is currently not displayed in
the tool bar, but it is displayed if the item doesn't have a `:help'
property (see below).

BINDING is the tool bar item's binding.  Tool bar items with keymaps as
binding are currently ignored.

The following properties are recognized:

`:enable FORM'.

FORM is evaluated and specifies whether the tool bar item is enabled
or disabled.

`:visible FORM'

FORM is evaluated and specifies whether the tool bar item is displayed.

`:filter FUNCTION'

FUNCTION is called with one parameter, the same list BINDING in which
FUNCTION is specified as the filter.  The value FUNCTION returns is
used instead of BINDING to display this item.

`:button (TYPE SELECTED)'

TYPE must be one of `:radio' or `:toggle'.  SELECTED is evaluated
and specifies whether the button is selected (pressed) or not.

`:image IMAGES'

IMAGES is either a single image specification or a vector of four
image specifications.  If it is a vector, this table lists the
meaning of each of the four elements:

   Index	Use when item is
   ----------------------------------------
     0		enabled and selected
     1		enabled and deselected
     2		disabled and selected
     3		disabled and deselected

If IMAGE is a single image specification, a Laplace edge-detection
algorithm is used on that image to draw the image in disabled state.

`:help HELP-STRING'.

Gives a help string to display for the tool bar item.  This help
is displayed when the mouse is moved over the item.

The function `toolbar-add-item' is a convenience function for adding
toolbar items generally, and `tool-bar-add-item-from-menu' can be used
to define a toolbar item with a binding copied from an item on the
menu bar.

The default bindings use a menu-item :filter to derive the tool-bar
dynamically from variable `tool-bar-map' which may be set
buffer-locally to override the global map.

*** Tool-bar-related variables.

If `auto-resize-tool-bar' is non-nil, the tool bar will automatically
resize to show all defined tool bar items.  It will never grow larger
than 1/4 of the frame's size.

If `auto-raise-tool-bar-buttons' is non-nil, tool bar buttons will be
raised when the mouse moves over them.

You can add extra space between tool bar items by setting
`tool-bar-button-margin' to a positive integer specifying a number of
pixels, or a pair of integers (X . Y) specifying horizontal and
vertical margins .  Default is 1.

You can change the shadow thickness of tool bar buttons by setting
`tool-bar-button-relief' to an integer.  Default is 3.

*** Tool-bar clicks with modifiers.

You can bind commands to clicks with control, shift, meta etc. on
a tool bar item.  If

  (define-key global-map [tool-bar shell]
    '(menu-item "Shell" shell
		:image (image :type xpm :file "shell.xpm")))

is the original tool bar item definition, then

  (define-key global-map [tool-bar S-shell] 'some-command)

makes a binding to run `some-command' for a shifted click on the same
item.

** Mode line changes.

*** Mouse-sensitive mode line.

The mode line can be made mouse-sensitive by displaying strings there
that have a `local-map' text property.  There are three ways to display
a string with a `local-map' property in the mode line.

1. The mode line spec contains a variable whose string value has
a `local-map' text property.

2. The mode line spec contains a format specifier (e.g. `%12b'), and
that format specifier has a `local-map' property.

3. The mode line spec contains a list containing `:eval FORM'.  FORM
is evaluated.  If the result is a string, and that string has a
`local-map' property.

The same mechanism is used to determine the `face' and `help-echo'
properties of strings in the mode line.  See `bindings.el' for an
example.

*** If a mode line element has the form `(:eval FORM)', FORM is
evaluated and the result is used as mode line element.

*** You can suppress mode-line display by setting the buffer-local
variable mode-line-format to nil.

*** A headerline can now be displayed at the top of a window.

This mode line's contents are controlled by the new variable
`header-line-format' and `default-header-line-format' which are
completely analogous to `mode-line-format' and
`default-mode-line-format'.  A value of nil means don't display a top
line.

The appearance of top mode lines is controlled by the face
`header-line'.

The function `coordinates-in-window-p' returns `header-line' for a
position in the header-line.

** Text property `display'

The `display' text property is used to insert images into text,
replace text with other text, display text in marginal area, and it is
also used to control other aspects of how text displays.  The value of
the `display' property should be a display specification, as described
below, or a list or vector containing display specifications.

*** Replacing text, displaying text in marginal areas

To replace the text having the `display' property with some other
text, use a display specification of the form `(LOCATION STRING)'.

If LOCATION is `(margin left-margin)', STRING is displayed in the left
marginal area, if it is `(margin right-margin)', it is displayed in
the right marginal area, and if LOCATION is `(margin nil)' STRING
is displayed in the text.  In the latter case you can also use the
simpler form STRING as property value.

*** Variable width and height spaces

To display a space of fractional width or height, use a display
specification of the form `(LOCATION STRECH)'.  If LOCATION is
`(margin left-margin)', the space is displayed in the left marginal
area, if it is `(margin right-margin)', it is displayed in the right
marginal area, and if LOCATION is `(margin nil)' the space is
displayed in the text.  In the latter case you can also use the
simpler form STRETCH as property value.

The stretch specification STRETCH itself is a list of the form `(space
PROPS)', where PROPS is a property list which can contain the
properties described below.

The display of the fractional space replaces the display of the
characters having the `display' property.

- :width WIDTH

Specifies that the space width should be WIDTH times the normal
character width.  WIDTH can be an integer or floating point number.

- :relative-width FACTOR

Specifies that the width of the stretch should be computed from the
first character in a group of consecutive characters that have the
same `display' property.  The computation is done by multiplying the
width of that character by FACTOR.

- :align-to HPOS

Specifies that the space should be wide enough to reach HPOS.  The
value HPOS is measured in units of the normal character width.

Exactly one of the above properties should be used.

- :height HEIGHT

Specifies the height of the space, as HEIGHT, measured in terms of the
normal line height.

- :relative-height FACTOR

The height of the space is computed as the product of the height
of the text having the `display' property and FACTOR.

- :ascent ASCENT

Specifies that ASCENT percent of the height of the stretch should be
used for the ascent of the stretch, i.e. for the part above the
baseline.  The value of ASCENT must be a non-negative number less or
equal to 100.

You should not use both `:height' and `:relative-height' together.

*** Images

A display specification for an image has the form `(LOCATION
. IMAGE)', where IMAGE is an image specification.  The image replaces,
in the display, the characters having this display specification in
their `display' text property.  If LOCATION is `(margin left-margin)',
the image will be displayed in the left marginal area, if it is
`(margin right-margin)' it will be displayed in the right marginal
area, and if LOCATION is `(margin nil)' the image will be displayed in
the text.  In the latter case you can also use the simpler form IMAGE
as display specification.

*** Other display properties

- (space-width FACTOR)

Specifies that space characters in the text having that property
should be displayed FACTOR times as wide as normal; FACTOR must be an
integer or float.

- (height HEIGHT)

Display text having this property in a font that is smaller or larger.

If HEIGHT is a list of the form `(+ N)', where N is an integer, that
means to use a font that is N steps larger.  If HEIGHT is a list of
the form `(- N)', that means to use a font that is N steps smaller.  A
``step'' is defined by the set of available fonts; each size for which
a font is available counts as a step.

If HEIGHT is a number, that means to use a font that is HEIGHT times
as tall as the frame's default font.

If HEIGHT is a symbol, it is called as a function with the current
height as argument.  The function should return the new height to use.

Otherwise, HEIGHT is evaluated to get the new height, with the symbol
`height' bound to the current specified font height.

- (raise FACTOR)

FACTOR must be a number, specifying a multiple of the current
font's height.  If it is positive, that means to display the characters
raised.  If it is negative, that means to display them lower down.  The
amount of raising or lowering is computed without taking account of the
`height' subproperty.

*** Conditional display properties

All display specifications can be conditionalized.  If a specification
has the form `(when CONDITION . SPEC)', the specification SPEC applies
only when CONDITION yields a non-nil value when evaluated.  During the
evaluation, `object' is bound to the string or buffer having the
conditional display property; `position' and `buffer-position' are
bound to the position within `object' and the buffer position where
the display property was found, respectively.  Both positions can be
different when object is a string.

The normal specification consisting of SPEC only is equivalent to
`(when t . SPEC)'.

** New menu separator types.

Emacs now supports more than one menu separator type.  Menu items with
item names consisting of dashes only (including zero dashes) are
treated like before.  In addition, the following item names are used
to specify other menu separator types.

- `--no-line' or `--space', or `--:space', or `--:noLine'

No separator lines are drawn, but a small space is inserted where the
separator occurs.

- `--single-line' or `--:singleLine'

A single line in the menu's foreground color.

- `--double-line' or `--:doubleLine'

A double line in the menu's foreground color.

- `--single-dashed-line' or `--:singleDashedLine'

A single dashed line in the menu's foreground color.

- `--double-dashed-line' or `--:doubleDashedLine'

A double dashed line in the menu's foreground color.

- `--shadow-etched-in' or `--:shadowEtchedIn'

A single line with 3D sunken appearance.  This is the form
displayed for item names consisting of dashes only.

- `--shadow-etched-out' or `--:shadowEtchedOut'

A single line with 3D raised appearance.

- `--shadow-etched-in-dash' or `--:shadowEtchedInDash'

A single dashed line with 3D sunken appearance.

- `--shadow-etched-out-dash' or `--:shadowEtchedOutDash'

A single dashed line with 3D raise appearance.

- `--shadow-double-etched-in' or `--:shadowDoubleEtchedIn'

Two lines with 3D sunken appearance.

- `--shadow-double-etched-out' or `--:shadowDoubleEtchedOut'

Two lines with 3D raised appearance.

- `--shadow-double-etched-in-dash' or `--:shadowDoubleEtchedInDash'

Two dashed lines with 3D sunken appearance.

- `--shadow-double-etched-out-dash' or `--:shadowDoubleEtchedOutDash'

Two dashed lines with 3D raised appearance.

Under LessTif/Motif, the last four separator types are displayed like
the corresponding single-line separators.

** New frame parameters for scroll bar colors.

The new frame parameters `scroll-bar-foreground' and
`scroll-bar-background' can be used to change scroll bar colors.
Their value must be either a color name, a string, or nil to specify
that scroll bars should use a default color.  For toolkit scroll bars,
default colors are toolkit specific.  For non-toolkit scroll bars, the
default background is the background color of the frame, and the
default foreground is black.

The X resource name of these parameters are `scrollBarForeground'
(class ScrollBarForeground) and `scrollBarBackground' (class
`ScrollBarBackground').

Setting these parameters overrides toolkit specific X resource
settings for scroll bar colors.

** You can set `redisplay-dont-pause' to a non-nil value to prevent
display updates from being interrupted when input is pending.

** Changing a window's width may now change its window start if it
starts on a continuation line.  The new window start is computed based
on the window's new width, starting from the start of the continued
line as the start of the screen line with the minimum distance from
the original window start.

** The variable `hscroll-step' and the functions
`hscroll-point-visible' and `hscroll-window-column' have been removed
now that proper horizontal scrolling is implemented.

** Windows can now be made fixed-width and/or fixed-height.

A window is fixed-size if its buffer has a buffer-local variable
`window-size-fixed' whose value is not nil.  A value of `height' makes
windows fixed-height, a value of `width' makes them fixed-width, any
other non-nil value makes them both fixed-width and fixed-height.

The following code makes all windows displaying the current buffer
fixed-width and fixed-height.

  (set (make-local-variable 'window-size-fixed) t)

A call to enlarge-window on a window gives an error if that window is
fixed-width and it is tried to change the window's width, or if the
window is fixed-height, and it is tried to change its height.  To
change the size of a fixed-size window, bind `window-size-fixed'
temporarily to nil, for example

  (let ((window-size-fixed nil))
     (enlarge-window 10))

Likewise, an attempt to split a fixed-height window vertically,
or a fixed-width window horizontally results in a error.

** The cursor-type frame parameter is now supported on MS-DOS
terminals.  When Emacs starts, it by default changes the cursor shape
to a solid box, as it does on Unix.  The `cursor-type' frame parameter
overrides this as it does on Unix, except that the bar cursor is
horizontal rather than vertical (since the MS-DOS display doesn't
support a vertical-bar cursor).



* Emacs 20.7 is a bug-fix release with few user-visible changes

** It is now possible to use CCL-based coding systems for keyboard
input.

** ange-ftp now handles FTP security extensions, like Kerberos.

** Rmail has been extended to recognize more forms of digest messages.

** Now, most coding systems set in keyboard coding system work not
only for character input, but also in incremental search.  The
exceptions are such coding systems that handle 2-byte character sets
(e.g euc-kr, euc-jp) and that use ISO's escape sequence
(e.g. iso-2022-jp).  They are ignored in incremental search.

** Support for Macintosh PowerPC-based machines running GNU/Linux has
been added.


* Emacs 20.6 is a bug-fix release with one user-visible change

** Support for ARM-based non-RISCiX machines has been added.



* Emacs 20.5 is a bug-fix release with no user-visible changes.

** Not new, but not mentioned before:
M-w when Transient Mark mode is enabled disables the mark.

* Changes in Emacs 20.4

** Init file may be called .emacs.el.

You can now call the Emacs init file `.emacs.el'.
Formerly the name had to be `.emacs'.  If you use the name
`.emacs.el', you can byte-compile the file in the usual way.

If both `.emacs' and `.emacs.el' exist, the latter file
is the one that is used.

** shell-command, and shell-command-on-region, now return
the exit code of the command (unless it is asynchronous).
Also, you can specify a place to put the error output,
separate from the command's regular output.
Interactively, the variable shell-command-default-error-buffer
says where to put error output; set it to a buffer name.
In calls from Lisp, an optional argument ERROR-BUFFER specifies
the buffer name.

When you specify a non-nil error buffer (or buffer name), any error
output is inserted before point in that buffer, with \f\n to separate
it from the previous batch of error output.  The error buffer is not
cleared, so error output from successive commands accumulates there.

** Setting the default value of enable-multibyte-characters to nil in
the .emacs file, either explicitly using setq-default, or via Custom,
is now essentially equivalent to using --unibyte: all buffers
created during startup will be made unibyte after loading .emacs.

** C-x C-f now handles the wildcards * and ? in file names.  For
example, typing C-x C-f c*.c RET visits all the files whose names
match c*.c.  To visit a file whose name contains * or ?, add the
quoting sequence /: to the beginning of the file name.

** The M-x commands keep-lines, flush-lines and count-matches
now have the same feature as occur and query-replace:
if the pattern contains any upper case letters, then
they never ignore case.

** The end-of-line format conversion feature previously mentioned
under `* Emacs 20.1 changes for MS-DOS and MS-Windows' actually
applies to all operating systems.  Emacs recognizes from the contents
of a file what convention it uses to separate lines--newline, CRLF, or
just CR--and automatically converts the contents to the normal Emacs
convention (using newline to separate lines) for editing.  This is a
part of the general feature of coding system conversion.

If you subsequently save the buffer, Emacs converts the text back to
the same format that was used in the file before.

You can turn off end-of-line conversion by setting the variable
`inhibit-eol-conversion' to non-nil, e.g. with Custom in the MULE group.

** The character set property `prefered-coding-system' has been
renamed to `preferred-coding-system', for the sake of correct spelling.
This is a fairly internal feature, so few programs should be affected.

** Mode-line display of end-of-line format is changed.
The indication of the end-of-line format of the file visited by a
buffer is now more explicit when that format is not the usual one for
your operating system.  For example, the DOS-style end-of-line format
is displayed as "(DOS)" on Unix and GNU/Linux systems.  The usual
end-of-line format is still displayed as a single character (colon for
Unix, backslash for DOS and Windows, and forward slash for the Mac).

The values of the variables eol-mnemonic-unix, eol-mnemonic-dos,
eol-mnemonic-mac, and eol-mnemonic-undecided, which are strings,
control what is displayed in the mode line for each end-of-line
format.  You can now customize these variables.

** In the previous version of Emacs, tar-mode didn't work well if a
filename contained non-ASCII characters.  Now this is fixed.  Such a
filename is decoded by file-name-coding-system if the default value of
enable-multibyte-characters is non-nil.

** The command temp-buffer-resize-mode toggles a minor mode
in which temporary buffers (such as help buffers) are given
windows just big enough to hold the whole contents.

** If you use completion.el, you must now run the function
dynamic-completion-mode to enable it.  Just loading the file
doesn't have any effect.

** In Flyspell mode, the default is now to make just one Ispell process,
not one per buffer.

** If you use iswitchb but do not call (iswitchb-default-keybindings) to
use the default keybindings, you will need to add the following line:
  (add-hook 'minibuffer-setup-hook 'iswitchb-minibuffer-setup)

** Auto-show mode is no longer enabled just by loading auto-show.el.
To control it, set `auto-show-mode' via Custom or use the
`auto-show-mode' command.

** Handling of X fonts' ascent/descent parameters has been changed to
avoid redisplay problems.  As a consequence, compared with previous
versions the line spacing and frame size now differ with some font
choices, typically increasing by a pixel per line.  This change
occurred in version 20.3 but was not documented then.

** If you select the bar cursor style, it uses the frame's
cursor-color, rather than the cursor foreground pixel.

** In multibyte mode, Rmail decodes incoming MIME messages using the
character set specified in the message.  If you want to disable this
feature, set the variable rmail-decode-mime-charset to nil.

** Not new, but not mentioned previously in NEWS: when you use #! at
the beginning of a file to make it executable and specify an
interpreter program, Emacs looks on the second line for the -*- mode
and variable specification, as well as on the first line.

** Support for IBM codepage encoding of non-ASCII characters.

The new command M-x codepage-setup creates a special coding system
that can be used to convert text between a specific IBM codepage and
one of the character sets built into Emacs which matches that
codepage.  For example, codepage 850 corresponds to Latin-1 character
set, codepage 855 corresponds to Cyrillic-ISO character set, etc.

Windows codepages 1250, 1251 and some others, where Windows deviates
from the corresponding ISO character set, are also supported.

IBM box-drawing characters and other glyphs which don't have
equivalents in the corresponding ISO character set, are converted to
a character defined by dos-unsupported-char-glyph on MS-DOS, and to
`?' on other systems.

IBM codepages are widely used on MS-DOS and MS-Windows, so this
feature is most useful on those platforms, but it can also be used on
Unix.

Emacs compiled for MS-DOS automatically loads the support for the
current codepage when it starts.

** Mail changes

*** When mail is sent using compose-mail (C-x m), and if
`mail-send-nonascii' is set to the new default value `mime',
appropriate MIME headers are added.  The headers are added only if
non-ASCII characters are present in the body of the mail, and no other
MIME headers are already present.  For example, the following three
headers are added if the coding system used in the *mail* buffer is
latin-1:

  MIME-version: 1.0
  Content-type: text/plain; charset=iso-8859-1
  Content-Transfer-Encoding: 8bit

*** The new variable default-sendmail-coding-system specifies the
default way to encode outgoing mail.  This has higher priority than
default-buffer-file-coding-system but has lower priority than
sendmail-coding-system and the local value of
buffer-file-coding-system.

You should not set this variable manually.  Instead, set
sendmail-coding-system to specify a fixed encoding for all outgoing
mail.

*** When you try to send a message that contains non-ASCII characters,
if the coding system specified by those variables doesn't handle them,
Emacs will ask you to select a suitable coding system while showing a
list of possible coding systems.

** CC Mode changes

*** c-default-style can now take an association list that maps major
modes to style names.  When this variable is an alist, Java mode no
longer hardcodes a setting to "java" style.  See the variable's
docstring for details.

*** It's now possible to put a list as the offset on a syntactic
symbol.  The list is evaluated recursively until a non-nil offset is
found.  This is useful to combine several lineup functions to act in a
prioritized order on a single line.  However, none of the supplied
lineup functions use this feature currently.

*** New syntactic symbol catch-clause, which is used on the "catch" and
"finally" lines in try-catch constructs in C++ and Java.

*** New cleanup brace-catch-brace on c-cleanup-list, which does for
"catch" lines what brace-elseif-brace does for "else if" lines.

*** The braces of Java anonymous inner classes are treated separately
from the braces of other classes in auto-newline mode.  Two new
symbols inexpr-class-open and inexpr-class-close may be used on
c-hanging-braces-alist to control the automatic newlines used for
anonymous classes.

*** Support for the Pike language added, along with new Pike specific
syntactic symbols: inlambda, lambda-intro-cont

*** Support for Java anonymous classes via new syntactic symbol
inexpr-class.  New syntactic symbol inexpr-statement for Pike
support and gcc-style statements inside expressions.  New lineup
function c-lineup-inexpr-block.

*** New syntactic symbol brace-entry-open which is used in brace lists
(i.e. static initializers) when a list entry starts with an open
brace.  These used to be recognized as brace-list-entry's.
c-electric-brace also recognizes brace-entry-open braces
(brace-list-entry's can no longer be electrified).

*** New command c-indent-line-or-region, not bound by default.

*** `#' is only electric when typed in the indentation of a line.

*** Parentheses are now electric (via the new command c-electric-paren)
for auto-reindenting lines when parens are typed.

*** In "gnu" style, inline-open offset is now set to zero.

*** Uniform handling of the inclass syntactic symbol.  The indentation
associated with it is now always relative to the class opening brace.
This means that the indentation behavior has changed in some
circumstances, but only if you've put anything besides 0 on the
class-open syntactic symbol (none of the default styles do that).

** Gnus changes.

*** New functionality for using Gnus as an offline newsreader has been
added.  A plethora of new commands and modes have been added.  See the
Gnus manual for the full story.

*** The nndraft backend has returned, but works differently than
before.  All Message buffers are now also articles in the nndraft
group, which is created automatically.

*** `gnus-alter-header-function' can now be used to alter header
values.

*** `gnus-summary-goto-article' now accept Message-ID's.

*** A new Message command for deleting text in the body of a message
outside the region: `C-c C-v'.

*** You can now post to component group in nnvirtual groups with
`C-u C-c C-c'.

*** `nntp-rlogin-program' -- new variable to ease customization.

*** `C-u C-c C-c' in `gnus-article-edit-mode' will now inhibit
re-highlighting of the article buffer.

*** New element in `gnus-boring-article-headers' -- `long-to'.

*** `M-i' symbolic prefix command.  See the section "Symbolic
Prefixes" in the Gnus manual for details.

*** `L' and `I' in the summary buffer now take the symbolic prefix
`a' to add the score rule to the "all.SCORE" file.

*** `gnus-simplify-subject-functions' variable to allow greater
control over simplification.

*** `A T' -- new command for fetching the current thread.

*** `/ T' -- new command for including the current thread in the
limit.

*** `M-RET' is a new Message command for breaking cited text.

*** \\1-expressions are now valid in `nnmail-split-methods'.

*** The `custom-face-lookup' function has been removed.
If you used this function in your initialization files, you must
rewrite them to use `face-spec-set' instead.

*** Canceling now uses the current select method.  Symbolic prefix
`a' forces normal posting method.

*** New command to translate M******** sm*rtq**t*s into proper text
-- `W d'.

*** For easier debugging of nntp, you can set `nntp-record-commands'
to a non-nil value.

*** nntp now uses ~/.authinfo, a .netrc-like file, for controlling
where and how to send AUTHINFO to NNTP servers.

*** A command for editing group parameters from the summary buffer
has been added.

*** A history of where mails have been split is available.

*** A new article date command has been added -- `article-date-iso8601'.

*** Subjects can be simplified when threading by setting
`gnus-score-thread-simplify'.

*** A new function for citing in Message has been added --
`message-cite-original-without-signature'.

*** `article-strip-all-blank-lines' -- new article command.

*** A new Message command to kill to the end of the article has
been added.

*** A minimum adaptive score can be specified by using the
`gnus-adaptive-word-minimum' variable.

*** The "lapsed date" article header can be kept continually
updated by the `gnus-start-date-timer' command.

*** Web listserv archives can be read with the nnlistserv backend.

*** Old dejanews archives can now be read by nnweb.

*** `gnus-posting-styles' has been re-activated.

** Changes to TeX and LaTeX mode

*** The new variable `tex-start-options-string' can be used to give
options for the TeX run.  The default value causes TeX to run in
nonstopmode.  For an interactive TeX run set it to nil or "".

*** The command `tex-feed-input' sends input to the Tex Shell.  In a
TeX buffer it is bound to the keys C-RET, C-c RET, and C-c C-m (some
of these keys may not work on all systems).  For instance, if you run
TeX interactively and if the TeX run stops because of an error, you
can continue it without leaving the TeX buffer by typing C-RET.

*** The Tex Shell Buffer is now in `compilation-shell-minor-mode'.
All error-parsing commands of the Compilation major mode are available
but bound to keys that don't collide with the shell.  Thus you can use
the Tex Shell for command line executions like a usual shell.

*** The commands `tex-validate-region' and `tex-validate-buffer' check
the matching of braces and $'s.  The errors are listed in a *Occur*
buffer and you can use C-c C-c or mouse-2 to go to a particular
mismatch.

** Changes to RefTeX mode

*** The table of contents buffer can now also display labels and
file boundaries in addition to sections. Use `l', `i', and `c' keys.

*** Labels derived from context (the section heading) are now
lowercase by default.  To make the label legal in LaTeX, latin-1
characters will lose their accent.  All Mule characters will be
removed from the label.

*** The automatic display of cross reference information can also use
a window instead of the echo area.  See variable `reftex-auto-view-crossref'.

*** kpsewhich can be used by RefTeX to find TeX and BibTeX files.  See the
customization group `reftex-finding-files'.

*** The option `reftex-bibfile-ignore-list' has been renamed to
`reftex-bibfile-ignore-regexps' and indeed can be fed with regular
expressions.

*** Multiple Selection buffers are now hidden buffers.

** New/deleted modes and packages

*** The package snmp-mode.el provides major modes for editing SNMP and
SNMPv2 MIBs.  It has entries on `auto-mode-alist'.

*** The package sql.el provides a major mode, M-x sql-mode, for
editing SQL files, and M-x sql-interactive-mode for interacting with
SQL interpreters.  It has an entry on `auto-mode-alist'.

*** M-x highlight-changes-mode provides a minor mode displaying buffer
changes with a special face.

*** ispell4.el has been deleted.  It got in the way of ispell.el and
this was hard to fix reliably.  It has long been obsolete -- use
Ispell 3.1 and ispell.el.

* MS-DOS changes in Emacs 20.4

** Emacs compiled for MS-DOS now supports MULE features better.
This includes support for display of all ISO 8859-N character sets,
conversion to and from IBM codepage encoding of non-ASCII characters,
and automatic setup of the MULE environment at startup.  For details,
check out the section `MS-DOS and MULE' in the manual.

The MS-DOS installation procedure automatically configures and builds
Emacs with input method support if it finds an unpacked Leim
distribution when the config.bat script is run.

** Formerly, the value of lpr-command did not affect printing on
MS-DOS unless print-region-function was set to nil, but now it
controls whether an external program is invoked or output is written
directly to a printer port.  Similarly, in the previous version of
Emacs, the value of ps-lpr-command did not affect PostScript printing
on MS-DOS unless ps-printer-name was set to something other than a
string (eg. t or `pipe'), but now it controls whether an external
program is used.  (These changes were made so that configuration of
